function Out = freqdrop(dat,freqmin,freqmax)
%FREQDROP  Drop frequencies of no interest
%

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1998-2001
%       All rights reserved.
%       $Revision: $
%       Last modified: 14-Jun-2001

ni = nargin;
no = nargout;
error(nargchk(1,3,ni));
if ni<2, freqmin=[]; end; if isempty(freqmin), freqmin=-inf; end 
if ni<3, freqmax=[]; end; if isempty(freqmax), freqmax=inf; end 
fv=get(dat,'freqpoints');
ind=find((fv<freqmin)|(fv>freqmax));
if length(ind)<length(fv)
  Out=subsref(dat,struct('type','()','subs',{{ind}})); 
else
  Out=dat;
end
% end of function @fiddata/freqdrop
