function datamodel=insertdata(model,data)
%INSERTDATA  Insert data and fill in fitinfo properties for model

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2000
%       All rights reserved.
%       $Revision: $
%       Last modified: 27-Feb-2000

ni = nargin;
no = nargout;
error(nargchk(2,2,ni))
if no>1
  error('Only one output argument is allowed');
end
if ~isa(data,'fidmodel')
  try
    data=fiddata(data);
  catch
    error('Second input argument cannot be converted to fiddata')
  end
end
runmod=[]; devrunmod=[]; 
on=length(model.num)-1;
od=length(model.denom)-1;
dom=model.variable;
runmod.itmax=0;
runmod.initset='object';
runmod.initmodel=model;
runmod.plotdens=inf;
runmod.plot0='off';
devrunmod.displaymessages='off';
%
datamodel=elis(data,dom,on,od,runmod,devrunmod);
%
datamodel.fitinfo.iterations=NaN;
datamodel.fitinfo.termcause='';
datamodel.algorithm.iteration='';
% end ../@fidmodel/insertdata.m