function [y,t,x] = nichols(varargin)
%NICHOLS  Nichols plot of fidmodel object

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2000
%       All rights reserved.
%       $Revision: $
%       Last modified: 21-Oct-2000

ni = nargin;
no = nargout;
error(nargchk(1,100,ni))
obj=varargin{1};

if ~exist('@zpk/zpk.m')%|strcmp(obj.variable,'w')
  error('Control toolbox is not installed')
else %control toolbox exists
  ltiobj=zpk(obj);
  if nargout==0
    nichols(ltiobj);
  elseif nargout==1
    [y]=nichols(ltiobj);
  elseif nargout==2
    [y,t]=nichols(ltiobj);
  elseif nargout==3
    [y,t,x]=nichols(ltiobj);
  else
    error('Too many output arguments')
  end
end  % end ../@fidmodel/nichols.m