function Out = eq(obj1,obj2)
%EQ  Returns 1 if all properties (beside some strings, etc) are equal.
%       Properties not considered: Name, Date, Notes, History, Instrumentation
%       See also  @IDDAT/GET, @IDDAT/SET.

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1998-99
%       All rights reserved.
%       $Revision: $
%       Last modified: 03-Sep-1998

ni = nargin;
no = nargout;
error(nargchk(2,2,ni));

d=diff(obj1,obj2);
for ii=1:size(d,1)
   ind=find(d(ii,:)==':');
   if ~isempty(ind)
      str=d(ii,1:ind(1)-1);
      str=fliplr(deblank(fliplr(str)));
      if ~any(findstr(['|',str,'|'],'|obj1|obj2|Name|Date|Notes|History|'))
         Out=0; return
      end
   end
end %for ii
Out=1;
%
% end @iddat/eq.m
