function fdsimul(p1,p2,p3,p4,p5,seltype) 
%       Handle simulation window for time or frequency domain
%
%       Input arguments:
%       p1 - type of action
%       p2 - action modifier
%       p3 - caller
%       p4 - not used
%       p5 - not used
%       seltype - selection type (in playback mode)

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1997-2003
%       All rights reserved.
%       $Revision: $
%       Written by Gy. Simon
%       Last modified: 21-Aug-2003

mainfig=findall(0, 'tag','fdtool_main');
Me = 'fdsimulation_main';
myfcn='fdsimul';

if nargin >0 & ~strcmp(p1, 'init')
  myfig=findall(0,'tag',Me);
  if nargin == 6
    sender=p5;
  else
    seltype=get(myfig,'selectiontype');
    eval(['sender=p', num2str(nargin) ';']);
  end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 INITIALIZATION
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if nargin ==0 | strcmp(p1, 'init')
  tmp=findall(0, 'tag','fdsimulation_main');
  if ~isempty(tmp) 
    % set(tmp,'visible','on');
    %figure(tmp);
    guiclose('fdsimulation')         
  end
  
  fdsimdef
  fig = figure(...
    'Units','pixels',...
    'Position',[ fig_offsx fig_offsy fig_dx fig_dy ],...
    'Resize','on',...
    'color',figure_col,...
    'Tag','fdsimulation_main',...
    'Name','Simulation in FDTool',...
    'NumberTitle','off',...
    'IntegerHandle', 'off',...  
    'Windowbuttonmotion', 'fdtool(''callback'',''fdsimul'',''mouse_motion'')',...  
    'Handlevisibility', 'off',...
    'resize', 'off', ...    
    'Closerequestfcn','fdtool(''callback'',''fdsimul'',''fdsimul_uic_cancelpb'',''fdsimul_uic_cancelpb'');',... 
    'visible','off'); 
%
%    'resizefcn','fdtool(''callback'',''fdsimul'',''resize'',''resize'')',...
%set(fig,'visible','on'); 
  
  myfig=fig;
  fdwindef(myfig);  % set default window properties
  
  %  Uicontrol Object Creation 
  
  fdsimul_uic_donepb = uicontrol(...
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_donepb'',''fdsimul_uic_donepb'');', ...
    'Units','pixels',...
    'Position',[ donepb_offsx donepb_offsy donepb_dx donepb_dy ], ...
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Close', ...
    'tooltipstring','Close window and return data',...
    'HorizontalAlignment','center', ...
    'Style','pushbutton',...
    'enable', 'off', ...
    'Tag','fdsimul_uic_donepb',...
    'UserData',''); 
  fdsimul_uic_cancelpb = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_cancelpb'',''fdsimul_uic_cancelpb'');',... 
    'Units','pixels',...
    'Position',[ cancelpb_offsx cancelpb_offsy cancelpb_dx cancelpb_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Cancel',... 
    'tooltipstring','Close window and do not return data',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'on', ...
    'Tag','fdsimul_uic_cancelpb',... 
    'UserData',''); 
  fdsimul_uic_fdsimulpb = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_fdsimulpb'',''fdsimul_uic_fdsimulpb'');',... 
    'Units','pixels',...
    'Position',[ fdsimulpb_offsx fdsimulpb_offsy fdsimulpb_dx fdsimulpb_dy ],... 
    'BackgroundColor',pushb_bgr_col,...
    'ForegroundColor',pushb_fg_col,...
    'String','Simulate',... 
    'Tooltipstring','Execute simulation',...
    'HorizontalAlignment','center',...
    'Style','pushbutton',... 
    'enable', 'off', ...
    'Tag','fdsimul_uic_fdsimulpb',... 
    'UserData',''); 
  fdsimul_uic_modelframe = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_modelframe'',''fdsimul_uic_modelframe'');',... 
    'Units','pixels',...
    'Position',[ modelframe_offsx modelframe_offsy modelframe_dx modelframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','Amplitudes',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','fdsimul_uic_modelframe',... 
    'Enable','off',... 
    'UserData',''); 
  fdsimul_uic_mgrb(4) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_mgrb(4)'',''fdsimul_uic_mgrb(4)'');',... 
    'Units','pixels',...
    'Position',[ mg4rb_offsx mg4rb_offsy mg4rb_dx mg4rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Output of ECPM',... 
    'tooltipstring','Output of Evaluate or Compare Plant Models block',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_mgrb(4)',... 
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_mgrb(3) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_mgrb(3)'',''fdsimul_uic_mgrb(3)'');',... 
    'Units','pixels',...
    'Position',[ mg3rb_offsx mg3rb_offsy mg3rb_dx mg3rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Best of CAMS outputs',... 
    'tooltipstring','Best of Computer Aided Model Selection block results',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_mgrb(3)',... 
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_mgrb(2) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_mgrb(2)'',''fdsimul_uic_mgrb(2)'');',... 
    'Units','pixels',...
    'Position',[ mg2rb_offsx mg2rb_offsy mg2rb_dx mg2rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Output of EPM',... 
    'tooltipstring','Output of Estimate Plant Model block',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_mgrb(2)',... 
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_mgrb(5) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_mgrb(5)'',''fdsimul_uic_mgrb(5)'');',... 
    'Units','pixels',...
    'Position',[ mg5rb_offsx mg5rb_offsy mg5rb_dx mg5rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Import data',... 
    'tooltipstring','Read data object to add noise to',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_mgrb(5)',... 
    'Interruptible', 'off', ...
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_mgrb(1) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_mgrb(1)'',''fdsimul_uic_mgrb(1)'');',... 
    'Units','pixels',...
    'Position',[ mg1rb_offsx mg1rb_offsy mg1rb_dx mg1rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Import model',... 
    'tooltipstring','Read fidmodel object',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_mgrb(1)',... 
    'Interruptible', 'off', ...
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_amplhlp1 = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_amplhlp1'',''fdsimul_uic_amplhlp1'');',... 
    'Units','pixels',...
    'Position',[ hlp1pb_offsx hlp1pb_offsy hlp1pb_dx hlp1pb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','info',... 
    'tooltipstring','Info on Amplitude Data',...
    'Style','pushbutton',... 
    'Tag','fdsimul_uic_amplhlp1',... 
    'Interruptible', 'off', ...
    'enable','off',...
    'Userdata', 'fdsimul_uic_helppb'); 
  fdsimul_uic_amplhlp2 = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_amplhlp2'',''fdsimul_uic_amplhlp2'');',... 
    'Units','pixels',...
    'Position',[ hlp2pb_offsx hlp2pb_offsy hlp2pb_dx hlp2pb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','plot',... 
    'tooltipstring','Plot Amplitude Data',...
    'Style','pushbutton',... 
    'Tag','fdsimul_uic_amplhlp2',... 
    'Interruptible', 'off', ...
    'Enable', 'off', ...
    'Userdata', 'fdsimul_uic_helppb'); 
  
  
  fdsimul_uic_modelhdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ modelhdtext_offsx modelhdtext_offsy modelhdtext_dx modelhdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Amplitudes',... 
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','fdsimul_uic_modelhdtext',... 
    'UserData',''); 
  guititle(fdsimul_uic_modelhdtext);
  fdsimul_uic_varframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ varframe_offsx varframe_offsy varframe_dx varframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','Variances',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','fdsimul_uic_varframe',... 
    'Enable','off',... 
    'UserData',''); 
  %   fdsimul_uic_varrb(4) = uicontrol(... 
  %      'Parent',fig,...
  %      'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_varrb(4)'',''fdsimul_uic_varrb(4)'');',... 
  %      'Units','pixels',...
  %      'Position',[ var4rb_offsx var4rb_offsy var4rb_dx var4rb_dy ],... 
  %      'BackgroundColor',radiob_bgr_col,...
  %      'ForegroundColor',radiob_fg_col,...
  %      'String','Import noise models',...
  %      'tooltipstring','Import models to generate input and output noises from them',...
  %      'HorizontalAlignment','left',...
  %      'Style','radiobutton',... 
  %      'Tag','fdsimul_uic_varrb(4)',... 
  %      'enable','on',...
  %      'Value',0,...
  %      'UserData','');  
  fdsimul_uic_varrb(3) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_varrb(3)'',''fdsimul_uic_varrb(3)'');',... 
    'Units','pixels',...
    'Position',[ var3rb_offsx var3rb_offsy var3rb_dx var3rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','VA variance result',...
    'tooltipstring','Variance calculated earlier by Variances and/or Averaging block',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_varrb(3)',... 
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_varrb(2) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_varrb(2)'',''fdsimul_uic_varrb(2)'');',... 
    'Units','pixels',...
    'Position',[ var2rb_offsx var2rb_offsy var2rb_dx var2rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','Import variances',...
    'tooltipstring','Read variances from fiddata object',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Interruptible', 'off', ...
    'Tag','fdsimul_uic_varrb(2)',... 
    'Value',0,...
    'UserData',''); 
  fdsimul_uic_varrb(1) = uicontrol(... 
    'Parent',fig,...
    'CallBack','fdtool(''callback'',''fdsimul'',''fdsimul_uic_varrb(1)'',''fdsimul_uic_varrb(1)'');',... 
    'Units','pixels',...
    'Position',[ var1rb_offsx var1rb_offsy var1rb_dx var1rb_dy ],... 
    'BackgroundColor',radiob_bgr_col,...
    'ForegroundColor',radiob_fg_col,...
    'String','''Mean'' SNR',...
    'tooltipstring','Approximate mean SNR value',...
    'HorizontalAlignment','left',...
    'Style','radiobutton',... 
    'Tag','fdsimul_uic_varrb(1)',... 
    'Value',1,...
    'UserData',''); 
  fdsimul_uic_varhdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ varhdtext_offsx varhdtext_offsy varhdtext_dx varhdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Variances',... 
    'HorizontalAlignment','center',...
    'Style','text',...
    'Tag','fdsimul_uic_varhdtext',... 
    'UserData',''); 
  guititle(fdsimul_uic_varhdtext);
  fdsimul_uic_intext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ intext_offsx intext_offsy intext_dx intext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','input:',... 
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','fdsimul_uic_intext',... 
    'UserData',''); 
  fdsimul_uic_inedit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''fdsimul'',''ui_edit'',''fdsimul_uic_inedit'');',...
    'Units','pixels',...
    'Position',[ inedit_offsx inedit_offsy inedit_dx inedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','40',... 
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','fdsimul_uic_inedit',...
    'tooltipstring','Input SNR',...
    'UserData',''); 
  fdsimul_uic_dbintext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ dbintext_offsx dbintext_offsy dbintext_dx dbintext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','dB',... 
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','fdsimul_uic_dbintext',... 
    'UserData',''); 
  fdsimul_uic_outtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ outtext_offsx outtext_offsy outtext_dx outtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','output:',... 
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','fdsimul_uic_outtext',... 
    'UserData',''); 
  fdsimul_uic_outedit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''fdsimul'',''ui_edit'',''fdsimul_uic_outedit'');',...
    'Units','pixels',...
    'Position',[ outedit_offsx outedit_offsy outedit_dx outedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','40',... 
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','fdsimul_uic_outedit',... 
    'tooltipstring','Output SNR',...
    'UserData',''); 
  fdsimul_uic_dbouttext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ dbouttext_offsx dbouttext_offsy dbouttext_dx dbouttext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','dB',... 
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','fdsimul_uic_dbouttext',... 
    'UserData',''); 
  fdsimul_uic_alltext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',... 
    'Position',[ alltext_offsx alltext_offsy alltext_dx alltext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','off',...
    'Enable','on',...
    'String','Scaling factor',...
    'tooltipstring','Multiplicative factor to rescale variance values (for Import, and VA result)',...
    'HorizontalAlignment','center',...
    'Style','text',... 
    'Tag','fdsimul_uic_alltext',... 
    'UserData',''); 
  fdsimul_uic_multext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',... 
    'Position',[ multext_offsx multext_offsy multext_dx multext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'Visible','off',...
    'Enable','on',...
    'String','x',... 
    'HorizontalAlignment','right',...
    'Style','text',... 
    'Tag','fdsimul_uic_multext',... 
    'UserData',''); 
%    'fontsize', text_font_size,...
  fdsimul_uic_muledit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''fdsimul'',''ui_edit'',''fdsimul_uic_muledit'');',...
    'Position',[ muledit_offsx muledit_offsy muledit_dx muledit_dy ],...
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',... 
    'tooltipstring','Multiplicative factor to rescale variance values (for Import, and VA result)',...
    'HorizontalAlignment','right',... 
    'Style','edit',... 
    'Enable','on',...
    'visible','off',...
    'Tag','fdsimul_uic_muledit',... 
    'UserData','');    
   save_text = uicontrol('Parent',fig, ...
      'style', 'checkbox',...   
      'Units','pixels', ...
      'Position',[savetext_offsx savetext_offsy savetext_dx savetext_dy], ...
      'String','Save var to object', ...
      'tooltipstring','Save variance data to generated object',...
      'callback', 'fdtool(''callback'',''fdsimul'',''ui_savetext'',''fdsimul_savetext'')',...
      'enable','on',...
      'value',1,...
      'Tag','fdsimul_savetext');
  fdsimul_uic_tdtext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ tdtext_offsx tdtext_offsy tdtext_dx tdtext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Delay:',...
    'tooltipstring','Delay to wait for the end of system transients',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','fdsimul_uic_tdtext',... 
    'UserData',''); 
  fdsimul_uic_tdedit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''fdsimul'',''ui_edit'',''fdsimul_uic_tdedit'');',...
    'Units','pixels',...
    'Position',[ tdedit_offsx tdedit_offsy tdedit_dx tdedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','0',... 
    'tooltipstring','Delay to wait for the end of system transients',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','fdsimul_uic_tdedit',... 
    'UserData',''); 
  fdsimul_uic_tdtext2 = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ tdtext2_offsx tdtext2_offsy tdtext2_dx tdtext2_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','sample',...
    'tooltipstring','Delay to wait for the end of system transients',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','fdsimul_uic_tdtext2',... 
    'UserData',''); 
  fdsimul_uic_ptpop = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'', ''fdsimul'', ''fdsimul_uic_ptpop'', ''fdsimul_uic_ptpop'')',...
    'Units','pixels',... 
    'Position',[ ptpop_offsx ptpop_offsy ptpop_dx ptpop_dy ],... 
    'BackgroundColor',popup_bgr_col,... 
    'ForegroundColor',popup_fg_col,...
    'HorizontalAlignment','right',... 
    'String',{'Periodic','One-shot'},...
    'tooltipstring','Repeat input signal periodically, or apply it just once',...
    'Style','popup',... 
    'Tag','fdsimul_uic_ptpop',... 
    'UserData',''); 
  fdsimul_uic_pttext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ pttext_offsx pttext_offsy pttext_dx pttext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','Apply input signal as:',...
    'tooltipstring','Repeat input signal periodically, or apply it just once',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','fdsimul_uic_pttext',... 
    'UserData','');
  fdsimul_uic_netext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ netext_offsx netext_offsy netext_dx netext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','# of experiments:',...
    'tooltipstring','Number of experiments to be generated',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','fdsimul_uic_netext',... 
    'UserData',''); 
  fdsimul_uic_needit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''fdsimul'',''ui_edit'',''fdsimul_uic_needit'');',...
    'Units','pixels',...
    'Position',[ needit_offsx needit_offsy needit_dx needit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','5',... 
    'tooltipstring','Number of experiments to be generated',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','fdsimul_uic_needit',... 
    'UserData',''); 
  fdsimul_uic_retext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ retext_offsx retext_offsy retext_dx retext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','# of repetitions:',...
    'tooltipstring','Number of consecutive repetitions of signal',...
    'HorizontalAlignment','left',...
    'Style','text',... 
    'Tag','fdsimul_uic_retext',... 
    'UserData',''); 
  fdsimul_uic_reedit = uicontrol(... 
    'Parent',fig,...
    'CallBack', 'fdtool(''callback'',''fdsimul'',''ui_edit'',''fdsimul_uic_reedit'');',...
    'Units','pixels',...
    'Position',[ reedit_offsx reedit_offsy reedit_dx reedit_dy ],... 
    'BackgroundColor',edit_bgr_col,...
    'ForegroundColor',edit_fg_col,...
    'String','1',... 
    'tooltipstring','Number of consecutive repetitions of signal',...
    'HorizontalAlignment','right',...
    'Style','edit',... 
    'Tag','fdsimul_uic_reedit',... 
    'UserData',''); 
  fdsimul_uic_statusframe = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statusframe_offsx statusframe_offsy statusframe_dx statusframe_dy ],... 
    'BackgroundColor',frame_bgr_col,...
    'ForegroundColor',frame_fg_col,...
    'String','statusframe',... 
    'HorizontalAlignment','left',...
    'Style','frame',... 
    'Tag','fdsimul_uic_statusframe',... 
    'Enable','off',... 
    'UserData','');
  fdsimul_uic_statustext = uicontrol(... 
    'Parent',fig,...
    'Units','pixels',...
    'Position',[ statustext_offsx statustext_offsy statustext_dx statustext_dy ],... 
    'BackgroundColor',text_bgr_col,...
    'ForegroundColor',text_fg_col,...
    'String','',... 
    'HorizontalAlignment','left',...
    'Style','text',...
    'Tag','fdsimul_uic_statustext',... 
    'UserData','');
  
  %  Menu Object Creation 
  %
  guimenus(Me,'simulation','fdsimul');
  % set rb groups
  set(fdsimul_uic_varrb,   'UserData', 'fdsimul_uic_varrb');
  set(fdsimul_uic_mgrb,    'UserData', 'fdsimul_uic_mgrb');
  
  
  % init help fcns
  helpmgr('init_help', '', myfcn, myfig );
  
  if nargin==2  % session load: fdsimul('init', initvar)
    storewin('restore', Me, p2);
  else
    % fdsimul('init', 'FREQ' or 'TIME', 'gfdd' or 'gettime')
    caller_info=struct('ID', p2, 'fcn', p3);
    switch p2
    case 'FREQ'
      status=guidtard('getfreq_main', 'STATUS_SIMULATION');
    case 'TIME'
      status=guidtard('gettime_main', 'STATUS_SIMULATION');
    end
    storewin('restore', Me, status);
    guidtawr(Me, 'DATA_OUTDATA', 'direct', '')  % clear previous result
    guidtawr(Me, 'DATA_CALLER_INFO', 'direct', caller_info)
  end
  
  fdsimul('check_rb_settings') % check and correct rb settings if necesssary
  hexpno=findobj(allchild(myfig), 'flat', 'tag', 'fdsimul_uic_needit');
  hexptext=findobj(allchild(myfig), 'flat', 'tag', 'fdsimul_uic_netext');
  input_data=guidtard('fdtool_main', 'OUTPUT_excitation');
  if ~isempty(input_data)&(get(input_data,'expnumber')>1)
    set(hexpno,'string',get(input_data,'expnumber'),'enable','off')
    set(hexptext,'enable','off')
  end
  set(fig,'visible','on'); 
  winmenu(myfig);
  setscale(myfig) % scale editbox init
  setdelay(myfig) % delay editbox init
  fdsimul('simulate_enable', 'set') % close/simulate init
  fdsimul('status', 'Ready.')
  
elseif strcmp(p1,'status')
  status=findobj(allchild(myfig), 'flat', 'tag', 'fdsimul_uic_statustext');
  statusfr=findobj(allchild(myfig), 'flat', 'tag', 'fdsimul_uic_statusframe');
  glstatus(myfig, status, statusfr, p2)
  
elseif strcmp(p1, 'mouse_motion')   
  guiready(myfig, 'fdsimul')
  
elseif strcmp(p1,'fdsimul_uic_donepb')
  outdata=guidtard(Me, 'DATA_OUTDATA');

  if isempty(outdata)
    fdsimul('simulate')
    outdata=guidtard(Me, 'DATA_OUTDATA');
  end
  if isempty(outdata) % simulation failed: do not close
    return   
  end
  fdsimul('status', 'Closing...')
  
  caller_info=guidtard(Me, 'DATA_CALLER_INFO');
  ID=caller_info.ID; fcn=caller_info.fcn;
  status=storewin('store_all', Me);
  
  switch ID
  case 'FREQ'
    guidtawr('getfreq_main', 'STATUS_SIMULATION', 'direct', status);
  case 'TIME'
    guidtawr('gettime_main', 'STATUS_SIMULATION', 'direct', status);
  end
  guiclose('fdsimulation'), drawnow
  feval(fcn, 'simulation_ready', 'done', outdata);  
  
  
elseif strcmp(p1,'fdsimul_uic_cancelpb')
  fdsimul('status', 'Canceling...', Me);
  caller_info=guidtard(Me, 'DATA_CALLER_INFO');
  ID=caller_info.ID; fcn=caller_info.fcn;
  guiclose('fdsimulation')
  feval(fcn, 'simulation_ready', 'cancel', '');  
  
elseif strcmp(p1,'fdsimul_uic_fdsimulpb') | strcmp(p1, 'simulate')
  input_data=guidtard('fdtool_main', 'OUTPUT_excitation');
  h= findobj(allchild(myfig), 'tag', 'fdsimul_uic_mgrb(5)');
  if isempty(input_data) & ~get(h, 'value')
    fdsimul('status', 'Error: Missing Excitation. Import data or generate Excitation Signal first.')
    return
  end
  guifreez(Me, 'freeze', 'fdsimul_simulation');
  fdsimul('status', 'Simulation in progress...', Me);
  caller_info=guidtard(Me, 'DATA_CALLER_INFO');
  mode=caller_info.ID; fcn=caller_info.fcn;
  c=allchild(myfig);
  h_var=findobj(c, 'flat', 'userdata', 'fdsimul_uic_varrb', 'value', 1);
  t_var=get(h_var, 'tag');
  if any(findstr(t_var, '(3)')) % VA variance result
    fdat=guidtard('fdtool_main', 'OUTPUT_average');
    var=fdat;
  elseif any(findstr(t_var, '(2)')) % Import variance
    var=guidtard(Me, 'IMPORTDATA_VARIANCE');
  else % Set SNR
    varin =str2num(get(findobj(c, 'flat', 'tag', 'fdsimul_uic_inedit') ,'string'));
    varout=str2num(get(findobj(c, 'flat', 'tag', 'fdsimul_uic_outedit'),'string'));
    var=[varin, varout]; 
  end
  if isempty(var)
    msg='No variance data for simulation in specified fdata';
    fdsimul('status', ['Error: ' msg])
    guifreez(Me, 'unfreeze', 'force');
    error(msg)
  end
  h_mod=findobj(c, 'flat', 'userdata', 'fdsimul_uic_mgrb', 'value', 1);
  t_mod=get(h_mod, 'tag');
  moddat='';
  if any(findstr(t_mod,'(5)')) % Import FRF of TIME
    moddat=guidtard(Me, 'IMPORTDATA_FRF_TIME'); 
    % warning ! This is not model data ^^^^ if-then later
    
    % now all other cases are similar, data already in 'IMPORTDATA_MODEL'
  elseif any(findstr(t_mod, '(1)')) % Import model
    moddat=guidtard(Me, 'IMPORTDATA_MODEL');
  elseif any(findstr(t_mod, '(2)')) % Output of EPM
    moddat=guidtard(Me, 'IMPORTDATA_MODEL');
  elseif any(findstr(t_mod, '(3)')) % Best of CAMS outputs
    moddat=guidtard(Me, 'IMPORTDATA_MODEL');
  elseif any(findstr(t_mod, '(4)')) % Output of ECPM
    moddat=guidtard(Me, 'IMPORTDATA_MODEL');
  end
  if isempty(moddat)
    msg='Specified model is missing in simulation';
    fdsimul('status', ['Error: ' msg])
    guifreez(Me, 'unfreeze', 'force');
    error(msg)
  end
  No_exp=str2num(get(findobj(c, 'flat', 'tag', 'fdsimul_uic_needit') ,'string'));
  No_rep=str2num(get(findobj(c, 'flat', 'tag', 'fdsimul_uic_reedit') ,'string')); %
  if No_rep>1
    pl=input_data.periodlength;
    if isempty(pl), pl=1/dfcalc(input_data); end
    if ~isempty(pl)&(abs(rem(input_data.samplenumber*input_data.ts/pl+0.5,1)-0.5)>100*eps)
      fdsimul('status','Error: signal with fractional periods is repeated')
      error('Signal with fractional periods is repeated')
    end
  end
  %input_data=guidtard('fdtool_main', 'OUTPUT_excitation');
  %Now simulation follows
  
  if strcmp(mode,'FREQ')
    if ~isempty(input_data)
      freqvect=input_data.inputfrequencies;
    else %input_data is missing
      if ~isa(moddat,'iddat')
        error('With no excitation data only ''Import data'' may be used')
      end
      freqvect=moddat.inputfreqpoints;
      input_data=moddat; %fiddata
    end
    if isempty(freqvect)
      if isa(input_data,'tiddata')
        freqvect=[1:input_data.samplen/2-1]'/input_data.samplen/input_data.ts;
        input_data.inputfrequencies=freqvect;
      else
        error('Input_data is not tiddata')
      end
    end
    %
    freqexc=freqvect;
    %dirty fix to make tim2fou work
    input_data.output=input_data.input;
    %input_data.frequencies=input_data.inputfrequencies;
    if isa(input_data,'tiddata')
      if ~guiinfos('islinear')&israndomized(input_data)
        freqs=input_data.frequencies; N=input_data.samplenumber;
        input_data.frequencies=1/input_data.Ts*[1:floor((N-1)/2)]/N;  
        fdata=tim2fou(input_data);
        input_data.frequencies=freqs;         
        fdata.frequencies=freqs;
        freqexc=freqvect; freqvect=fdata.freqpoints;
      else
        fdata=tim2fou(input_data);
      end
      fdata.output=[];
    else
      fdata=input_data; %copy fiddata
    end
    cx=fdata.input;
    if (size(var,1)==1)&(size(var,2)==2) %1x2 vector
      if isa(moddat,'fidmodel')
        tf=tfcalc(moddat,freqvect);
        if iscell(cx), cx1=cx{1}; else cx1=cx; end
        meanx=mean(abs(cx1(ismember(freqvect,freqexc))));
        meany=mean(abs(tf(ismember(freqvect,freqexc)).*cx1(ismember(freqvect,freqexc))));
      else %fiddata
        if moddat.expn==1
          meanx=mean(abs(moddat.input(ismember(freqvect,freqexc))));
          meany=mean(abs(moddat.output(ismember(freqvect,freqexc))));
        else
          meanx=mean(abs(moddat.input{1}(ismember(freqvect,freqexc))));
          meany=mean(abs(moddat.output{1}(ismember(freqvect,freqexc)))); 
        end
      end
      vx=meanx^2/10^(var(1)/10);
      vy=meany^2/10^(var(2)/10);
      vxy=[vx,vy];
    else %variance array from fiddata
      if ~isa(var,'fiddata')
        error(['var is not given in form of fiddata: frequency vector ',...
            'cannot be obtained'])
      end
      if ~isa(moddat,'fidmodel'), freqvect=moddat.freqpoints; end
      vara=var.SiSoVariance; fva=var.freqpoints;
      if size(vara,1)==1, vara=kron(ones(length(fva),1),vara); end
      vara=[vara(1,:);vara;vara(size(vara,1),:)];
      fva=[0;fva(:);max([fva(:);freqvect])+1];
      vxy=interp1(fva,vara,freqvect); %interpolate to freqvect
      scalefact=str2num(get(findobj(c,'flat','tag','fdsimul_uic_muledit'),...
        'string'));
      vxy=scalefact*vxy;
    end
    %Now calculate simulated data
    if isa(moddat,'fidmodel')
      if ~isstable(moddat), fdsimul('status','#yWarning: unstable model'), end
      NaNv=NaN;
      if isnumeric(cx), yall=NaNv(ones(size(cx)));
      else yall=cx; for ii=1:length(cx), yall{ii}=NaNv(ones(size(cx{ii}))); end
      end
      exdat=fiddata(yall,cx,freqvect);
      exdat.SiSoVariance=vxy;
      try, simdat=simfou(moddat,exdat,No_exp); ok=1; catch, ok=0; end
      if ok==0
        fdsimul('status',['#fdsimul error: ',lasterr]), return
      end
      x=simdat.input; if iscell(x), x=cat(1,x{:}); end
      y=simdat.output; if iscell(y), y=cat(1,y{:}); end
      lx=length(x);
      F=length(freqvect);
    else %fiddata
      u=moddat.input; if iscell(u), u=u{1}; end
      F=size(u,1);
      y=moddat.output; if iscell(y), y=y{1}; end 
      freqvect=moddat.freqpoints; %make freqvect equal to the one in fiddata
      Fe=size(u,1)*No_exp;
      if (size(vxy,1)>1)&(size(vxy,1)<Fe)
        vxym=kron(ones(Fe/size(vxy,1),1),vxy);
      else
        vxym=vxy;
      end
      ind0=find(freqvect==0); ind00=ind0;
      for ii=2:No_exp
        ind0=[ind0;ind00+(ii-1)*length(freqvect)];
      end
      x=kron(ones(No_exp,1),u)+sqrt(vxym(:,1)).*(randn(Fe,1)+j*randn(Fe,1));
      y=kron(ones(No_exp,1),y)+sqrt(vxym(:,2)).*(randn(Fe,1)+j*randn(Fe,1));
      if ~isempty(ind0) %correct for zero frequencies
        if size(vxy,1)==1
          x(ind0)=real(x(ind0))+sqrt(vxym(:,1))*(randn(length(ind0),1));
          y(ind0)=real(y(ind0))+sqrt(vxym(:,2))*(randn(length(ind0),1));
        else
          x(ind0)=real(x(ind0))+sqrt(vxym(:,1)).*(randn(Fe,1));
          y(ind0)=real(y(ind0))+sqrt(vxym(:,2)).*(randn(Fe,1));
        end
      end
      if size(vxy,2)>=3
        warning('cuy is not yet considered')
        vxy=vxy(:,1:2);
      end
    end
    %
    if size(vxy,2)==3, cxy=vxy(:,3); else cxy=[]; end
    if size(vxy,2)==3, cxy=vxy(:,3); else cxy=[]; end
    if No_exp>1
      ysav=y; xsav=x; y=cell(1,No_exp); x=y;
      for ii=1:No_exp
        x{ii}=xsav((ii-1)*F+[1:F]);
        y{ii}=ysav((ii-1)*F+[1:F]);
      end
    end
    savevar=get(findobj(myfig,'tag','fdsimul_savetext'),'Value');
    if savevar
      outdata=fiddata(y,x,freqvect,2*vxy(:,2),2*vxy(:,1),2*cxy);
    else
      outdata=fiddata(y,x,freqvect);
    end
    if ~guiinfos('islinear')
      if israndomized(input_data)
        outdata.frequencies=freqexc;
      end
    end
    if No_exp>1
      if fdata.expn>1
        outdata.synchronization=fdata.synchronization;
      else
        outdata.synchronization='on';       
        if ~guiinfos('islinear')
          if ~israndomized(input_data)
            set(outdata,'synchronization','samepower')
          end
        end
      end
    end
    %reference signal is not necessary
    if fdata.expnumber>1, set(outdata,'Reference',fdata.input), end
    %
  else % 'TIME'
    if isa(moddat,'tiddata') %Simulation from tiddata
      u0=moddat.input; if ~iscell(u0), u0={u0}; end
      %if iscell(u0), u0=u0{1}; end
      y0=moddat.output; if ~iscell(y0), y0={y0}; end
      %if iscell(y0), y0=y0{1}; end
      for ii=1:length(u0)
        if No_rep~=1
          u0{ii}=kron(ones(No_rep,1),u0{ii});
          y0{ii}=kron(ones(No_rep,1),y0{ii});
        end
        ts=moddat.ts;
        pl=moddat.periodlength;
        freqvect=moddat.frequencies;
      end
    else %Simulation from model
      hm=findobj(c,'flat','Tag','fdsimul_uic_ptpop');
      strs=get(hm,'string');
      if strcmp(strs{get(hm,'value')},'Periodic')
        mode='periodic';
      elseif strcmp(strs{get(hm,'value')},'One-shot')
        mode='transient';
      else
        error('Simulation mode is invalid')
      end
      hd=findobj(c,'flat','Tag','fdsimul_uic_tdedit');
      delay=str2num(get(hd,'string'));
      if ~isstable(moddat), fdsimul('status','#yWarning: unstable model'), end
      if any(findstr(moddat.variable,'z'))
        fsm=moddat.fs;
        fs=1/input_data.ts;
        if abs(fsm-fs)>1e-10*max(fsm,fs)
          fdsimul('status','#rError: Sampling frequencies of model and signal differ')
          return
        end
      end
      %
      u=input_data.input;
      uch=input_data.inputcharacter; 
      if isnumeric(u), u={u}; end
      if isstr(uch)
        uch={uch};
      end
      if No_rep~=1
        for ii=1:length(u), u{ii}=kron(ones(No_rep,1),u{ii}); end
      end
      u0=[]; y0=[];
      for ii=1:No_exp
        uchii=uch{1};
        if strcmp(uchii,'ZOH'), mode2=[mode,'ZOH']; else mode2=mode; end
        uind=min(ii,size(u,2));
        try
          [u0ii,y0ii]=simtime(moddat,u{uind},0,1,0,1,mode2,1/input_data.ts,1,delay); ok=1;
          Np=input_data.periodl/input_data.ts; N=length(u0ii);
          if ~isempty(Np)&(Np<N)&(rem(Np,1)==0)&(rem(N,Np)==0)
            %Force periodicity
            u0ii=reshape(u0ii,Np,N/Np); mu0ii=mean(u0ii,2); u0ii=kron(ones(N/Np,1),mu0ii);
          end
          u0{1,ii}=u0ii; y0{1,ii}=y0ii;
        catch
          ok=0; break
        end
      end
      if ok==0
        fdsimul('status',['#rfdsimul error: ',lasterr]), return
      end
      ts=input_data.ts;
      pl=input_data.periodlength;
      freqvect=input_data.frequencies;
    end
    %u0, y0 done
    if ~iscell(u0), u0={u0}; y0={y0}; end
    if (size(var,1))==1&(size(var,2)==2)
      meanx=std(cat(1,u0{:})); meany=std(cat(1,y0{:}));
      stdx=meanx/10^(var(1)/20);
      stdy=meany/10^(var(2)/20);
    else error('var is not a 1x2 vector')
    end
    %u=cell(1,No_exp); y=u;
    Ref=u0;
    for ii=1:No_exp
      if length(u0)<No_exp, ind=1; else ind=ii; end
      u0{1,ii}=u0{1,ind}+stdx*randn(size(u0{1,ind}));
      y0{1,ii}=y0{1,ind}+stdy*randn(size(y0{1,ind}));
    end
    outdata=tiddata(y0,u0,ts);
    if ~isempty(input_data.referencedata')
      set(outdata,'referencedata',input_data.referencedata)
    else
      set(outdata,'referencedata',Ref,'noconsistency')
    end
    savevar=get(findobj(myfig,'tag','fdsimul_savetext'),'Value');
    if savevar
      if isa(moddat,'fidmodel') %Simulation from model
        set(outdata,'inputvariance',stdx^2,'outputvariance',stdy^2,'noconsistency');
      end
    end
    if No_exp>1
      if input_data.expn>1
        outdata.synchronization=input_data.synchronization;  
      else
        outdata.synchronization='on';       
      end
    end
    set(outdata,'inputchar','BL','Outputchar','BL','frequencies',freqvect,'periodlength',pl);
    %if input_data.expnumber>1, set(outdata,'Reference',input_data.input), end
  end
  
  addhist(outdata, 'Simulated data.');
  guidtawr(Me, 'DATA_OUTDATA', 'direct', outdata)
  
  % if simulate pb pressed then plot result 
  if strcmp(p1,'fdsimul_uic_fdsimulpb') 
    if isa(outdata, 'tiddata')
      arrplot('tim_sim_update')
    else % fiddata
      arrplot('freq_sim_update')
    end
  end
  fdsimul('status', 'Simulation ready', Me);
  guifreez(Me, 'unfreeze', 'fdsimul_simulation');
  % end of simulation

elseif strcmp(p1,'fdsimul_uic_mgrb(4)') % EPCM
  rbtag(sender);
  moddat=guidtard('fdtool_main', 'OUTPUT_compare');
  guidtawr(Me, 'IMPORTDATA_MODEL', 'direct', moddat) 
  
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  fdsimul('amplitude_selection', 'on')
  fdsimul('status', 'Model selected from output of ECPM')
  
elseif strcmp(p1,'fdsimul_uic_mgrb(3)') % CAMS
  rbtag(sender);
  
  moddat=guidtard('fdtool_main', 'OUTPUT_aided');
  if isa(moddat, 'cell')
    Error('Old cell format !!!!')
  end
  % find best model here
  best_crit=inf;
  best_ix=1;
  for ix=1:length(moddat)
    tmp=moddat(:,:,ix); fit=tmp.fitinfo;
    if isstruct(fit)
      AIC=fit.AIC;
    else
      AIC=fit(12);
    end
    if AIC < best_crit
      best_crit=AIC;
      best_ix=ix;
    end
  end
  moddat=moddat(:,:,best_ix);
  guidtawr(Me, 'IMPORTDATA_MODEL', 'direct', moddat) 
  
  fdsimul('amplitude_selection', 'on')
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  fdsimul('status', 'Model selected from output of CAMS')
  
elseif strcmp(p1,'fdsimul_uic_mgrb(2)') % EPM
  rbtag(sender);
  moddat=guidtard('fdtool_main', 'OUTPUT_select');
  guidtawr(Me, 'IMPORTDATA_MODEL', 'direct', moddat) 
  
  fdsimul('amplitude_selection', 'on')
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  fdsimul('status', 'Model selected from output of EPM')
  
elseif strcmp(p1,'fdsimul_uic_mgrb(1)') % Import model
  rbtag(sender);
  fdsimul('status','Opening Import Model ')
  fdsimul('simulate_enable', 'off') % disable sim/close while import is open
  guiimpv('init', myfcn, 'MODEL', [], 'filter: fidmodel object');
  fdsimul('status','Done. ')
  
elseif strcmp(p1,'fdsimul_uic_mgrb(5)') % Import time or freq data
  rbtag(sender);
  fdsimul('status','Opening Import Data... ')
  fdsimul('simulate_enable', 'off')% disable sim/close while import is open
  
  info=guidtard(Me, 'DATA_CALLER_INFO'); mode=info.ID;
  if strcmp(mode, 'TIME')
    filter='filter: tiddata Object';
  else
    filter='filter: fiddata Object';
  end
  fdsimul('status','Specify Amplitude data in Import box.')
  guiimpv('init', myfcn, 'FRF/TIME', [], filter);
  fdsimul('status','Done. ')
  
elseif strcmp(p1,'fdsimul_uic_varrb(4)') 
  % NOT USED !!!!!
  rbtag(sender);
  
elseif strcmp(p1,'fdsimul_uic_varrb(3)')
  rbtag(sender);
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  setscale(myfig)
  fdsimul('status', 'Variance taken from VA result')
  
elseif strcmp(p1,'fdsimul_uic_varrb(2)')
  rbtag(sender);
  fdsimul('status','Opening Import ... ')
  setscale(myfig)
  fdsimul('simulate_enable', 'off')
  guiimpv('init', myfcn, 'VARIANCE', [], 'filter: fiddata Object with Variance');
  fdsimul('status','Done. ')
  
elseif strcmp(p1,'fdsimul_uic_varrb(1)')
  rbtag(sender);
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  setscale(myfig)
  fdsimul('status', 'Set SNR of input and output channels')
  
elseif strcmp(p1, 'import_ready')
  switch  p2
  case 'cancel'
    switch p3 % caller_ID
    case 'MODEL'  % cancel Import model
      fdsimul('amplitude_selection', 'off')
    case 'FRF/TIME'    % cancel Import data
      fdsimul('amplitude_selection', 'off')
    case 'VARIANCE' % cancel Import variances
      rbtag('fdsimul_uic_varrb(1)')
      setscale(myfig)
    end
  case 'done'
    data=guidtard('fdtool_importfig', 'IMPORTED_VAR');
    switch p3 % caller_ID
    case 'MODEL'
      fdsimul('status', 'Model data loaded')
      guidtawr(Me,'IMPORTDATA_MODEL','direct',data);
      fdsimul('amplitude_selection', 'on')
    case 'FRF/TIME'    %  Import data
      fdsimul('status', 'Amplitude data loaded')
      guidtawr(Me,'IMPORTDATA_FRF_TIME','direct',data);
      fdsimul('amplitude_selection', 'on')
    case 'VARIANCE'
      if ~isempty(data)
        fdsimul('status', 'Variance data loaded')
        guidtawr(Me,'IMPORTDATA_VARIANCE','direct',data);
      else
        fdsimul('status', 'Error: No variance available in imported data.')
        rbtag('fdsimul_uic_varrb(1)')
      end
      setscale(myfig)
    end
  
  end
  fdsimul('simulate_enable', 'set')
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  
elseif strcmp(p1, 'ui_list')
  % This is to make replay possible
  h=findobj(myfig,'tag',sender);
  str=get(h,'string');
  ix=-1;
  for i=1:length(str);
    if strcmpi(str(i),p2), ix=i; end
  end %for i
  if ix ~=-1, 
    set(h,'value',ix), 
    guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  else
    errordlg(['Fdsimul replay failed, bad parameter: ',p2],'Error','replace');
    error(['Fdsimul replay failed']);
  end
  
elseif strcmp(p1,'ui_savetext')
  
elseif strcmp(p1,'ui_edit') % checks and corrects input value
  h=findobj(myfig,'tag',sender);
  edstr=get(h,'string');
  ednum=str2num(edstr);
  if any(isnan(ednum)), ednum=[]; end
    orig_num=ednum;
    if strcmp(sender, 'fdsimul_uic_needit')|strcmp(sender, 'fdsimul_uic_reedit')  
       % number of experiments | number of repetitions
       if isempty(ednum) | any(ednum < 1)
          ednum=10;
       else
          ednum=floor(ednum(1,1));
       end
       edstr=num2str(ednum);
       set(h,'string',edstr);
    elseif strcmp(sender, 'fdsimul_uic_tdedit') % delay 
      if isempty(ednum)|isnan(ednum)
        ednum=Inf;
      elseif  any(ednum < 0)
        ednum=0;
      else
        ednum=floor(ednum(1,1));
      end
      %ednum=0; %Temporarily, delay cannot be set
      edstr=num2str(ednum);
      set(h,'string',edstr);
    
  elseif strcmp(sender, 'fdsimul_uic_muledit') % scale factor
    if isempty(ednum)| any(ednum < 0)
      ednum=1;
    else
      ednum=ednum(1,1);
    end
    edstr=num2str(ednum);
    set(h,'string',edstr);
  else % SNR values
    if isempty(ednum)
      ednum=10;
    else
      ednum=ednum(1,1);
    end
    edstr=num2str(ednum);
    set(h,'string',edstr);
  end
  if ~isequal(orig_num, ednum)
    fdsimul('status', 'Warning: Bad input value automatically corrected.')
  else
    fdsimul('status', 'Input value accepted')
  end
  guidtawr(Me, 'DATA_OUTDATA', 'direct', '') % clear prev sim result if any
  
elseif strcmp(p1, 'simulate_enable')   
  % p2= 'on' or 'off' or 'set'
  % enable/disable simulate and close pbs
  % 'set' checks amplitude settings and sets enable according to it
  c=allchild(myfig);
  h_pb=[findobj(c, 'flat', 'Tag','fdsimul_uic_fdsimulpb'),...
    findobj(c, 'flat', 'Tag','fdsimul_uic_donepb'),...
    findobj(c, 'Tag','simulation_menu_file_close')];  % <- menu, not flat !
  if strcmp(p2, 'set')
    h_ampl=findobj(allchild(myfig), 'flat', ...
    'userdata', 'fdsimul_uic_mgrb', ...
    'value', 1);
    if isempty(h_ampl)
      p2='off';
    else
      p2='on';
    end
  end
  set(h_pb, 'enable', p2)
  
elseif strcmp(p1, 'amplitude_selection')   
  % p2= 'on' or 'off'
  % on: one of the amplitude rbs is selected
  % off: none of the amplitude rbs is selected
  fdsimul('simulate_enable', p2)
  if strcmp(p2, 'off')
    h=findobj(allchild(myfig), 'flat', 'userdata', 'fdsimul_uic_mgrb');
    set(h, 'value', 0);
  end
  setdelay(myfig)  % enable/disable delay editbox 
  % set info pb's
  h=[findobj(allchild(myfig), 'flat', 'tag', 'fdsimul_uic_amplhlp1');
    findobj(allchild(myfig), 'flat', 'tag', 'fdsimul_uic_amplhlp2')];
    set(h, 'enable', p2)
  
elseif strcmp(p1,'check_rb_settings')
  % check and correct rb settings according to current fdtool state
  c=allchild(myfig);
  %---- VA variance result
  info=guidtard(Me, 'DATA_CALLER_INFO'); mode=info.ID;
  h=findobj(c, 'flat', 'Tag','fdsimul_uic_varrb(3)');
  arr_status=boxmgr('enquirearrow', 'fdtool_main', 6);
  if strcmp(arr_status, '-')
    set(h, 'enable', 'off')
    if get(h, 'value')==1
      rbtag('fdsimul_uic_varrb(1)')
    end
  else   
    set(h, 'enable', 'on')
  end
  %---- If TIME, disable VA and import var
  if strcmp(mode, 'TIME')
    h1=findobj(c, 'flat', 'Tag','fdsimul_uic_varrb(2)');
    set([h h1], 'visible', 'off')
  else %frequency
    h2=[findobj(c, 'flat', 'Tag','fdsimul_uic_tdtext');
      findobj(c, 'flat', 'Tag','fdsimul_uic_tdedit');
      findobj(c, 'flat', 'Tag','fdsimul_uic_tdtext2');
      findobj(c, 'flat', 'Tag','fdsimul_uic_pttext');
      findobj(c,'flat', 'Tag', 'fdsimul_uic_ptpop');
      findobj(c, 'flat', 'Tag','fdsimul_uic_retext');
      findobj(c, 'flat', 'Tag','fdsimul_uic_reedit')];
      set(h2, 'visible', 'off') 
  end
  
  %---- Amplitudes
  excsig=guidtard('fdtool_main', 'OUTPUT_excitation');
  if isempty(excsig)
    % if no ecitation signal exists, only Import data can be enabled
    for ii=1:4
      h=findobj(c, 'flat', 'Tag',['fdsimul_uic_mgrb(' num2str(ii) ')']);
      set(h, 'enable', 'off')
      if get(h, 'value')==1
        fdsimul('amplitude_selection', 'off')
      end
    end %for
  else   
    %---- Output of EPM, CAMS, and ECPM
    for ii=2:4
      h=findobj(c, 'flat', 'Tag',['fdsimul_uic_mgrb(' num2str(ii) ')']);
      arr_status=boxmgr('enquirearrow', 'fdtool_main', ii+7);
      if strcmp(arr_status, '-')
        set(h, 'enable', 'off')
        if get(h, 'value')==1
          fdsimul('amplitude_selection', 'off')
        end
      else   
        set(h, 'enable', 'on')
      end
    end %for
  end
  
elseif findstr(p1, 'fdsimul_uic_ptpop')
  %Nothing to do
  
elseif findstr(p1, 'fdsimul_uic_amplhlp')   
  % help on amplitude settings: text info or plot
  mode=any(findstr(p1, '2'));  % 0: info, 1: plot
  c=allchild(myfig);
  h_mod=findobj(c, 'flat', 'userdata', 'fdsimul_uic_mgrb', 'value', 1);
  t_mod=get(h_mod, 'tag');
  moddat='';
  if isempty(h_mod)
    % no amplitude specified
    ampl_dat='';
    FirstLine='No amplitude data specified yet. Select on option.';
  elseif any(findstr(t_mod,'(5)')) % Import FRF of TIME
    ampl_dat=guidtard(Me, 'IMPORTDATA_FRF_TIME'); 
    FirstLine=['Info on simulation/amplitude (' get(h_mod, 'string') ')'];
  else
    % model specified
    ampl_dat=guidtard(Me, 'IMPORTDATA_MODEL');
    FirstLine=['Info on simulation/amplitude (' get(h_mod, 'string') ')'];
  end
  
  if mode ==0 
    garrinfo(1001, ampl_dat, FirstLine)
  else
    if isa(ampl_dat, 'fidmodel')
      arrplot('fidmodel', ampl_dat);
    elseif isa(ampl_dat, 'fiddata') 
      arrplot('fiddata', ampl_dat);
    elseif isa(ampl_dat, 'tiddata') 
      % if more experiments, select first
      %small_dat=tiddata(ampl_dat.output{1}, ampl_dat.output{1}, ampl_dat.ts); 
      %arrplot('tiddata', small_dat); 
      arrplot('tiddata',ampl_dat); 
    end
  end
  
elseif strcmp(p1,'fdsimul_uic_print')
  %fdsimul print command
  fdgprint(Me)
  fdsimul('status','Print figure done.')
  
elseif strcmp(p1,'fdsimul_mod_print_ps')
  %fdsimul print command
  fdgprint(Me,'ps')
  
elseif strcmp(p1, 'preload')
  % precompile, nothing to do
  
elseif strcmp(p1,'resize')
    return  
  mindx=500;
  mindy=280;
  scr=get(0,'screensize');
  mainfigmaxx=scr(3);
  mainfigmaxy=scr(4);
  
  
  pos=get(findobj(myfig, 'tag','fdsimulation_main'),'position');
  fig_offsx=pos(1);
  fig_offsy=pos(2);
  fig_dx=pos(3);
  fig_dy=pos(4);
  if fig_dx < mindx
    fig_dx=mindx;
  end;
  if fig_dy < mindy
    fig_dy=mindy;
  end;
  %      if fig_offsx+fig_dx > mainfigmaxx
  %         fig_offsx=10;
  %      end;
  if fig_offsy+fig_dy > mainfigmaxy
    fig_offsy=20;
  end;
  set(myfig,'position',[fig_offsx fig_offsy fig_dx fig_dy]);
  fromframe_dx=60;
  fromevalpb_dy=60;
  pos=get(findobj(myfig, 'tag','fdsimul_uic_varframe'),'position');
  frame_offsx=pos(1);
  frame_dx=pos(3);
  gr_offsy=fig_dy-20-(pos(2)+pos(4));
  frame_dx=(fig_dx-50)/2;
  set(findobj(myfig, 'tag','fdsimul_uic_varframe'),'position',[pos(1) pos(2)+gr_offsy frame_dx pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_varhdtext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_varhdtext'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_varrb(1)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_varrb(1)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_dbintext'),'position');
  dbin_dx=pos(3);
  dbin_offsx=frame_offsx+frame_dx-5-dbin_dx;
  set(findobj(myfig, 'tag','fdsimul_uic_dbintext'),'position',[dbin_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_inedit'),'position');
  inedit_dx=pos(3);
  inedit_offsx=dbin_offsx-5-inedit_dx;
  set(findobj(myfig, 'tag','fdsimul_uic_inedit'),'position',[inedit_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_intext'),'position');

  intext_dx=pos(3);
  intext_offsx=inedit_offsx-5-intext_dx;
  set(findobj(myfig, 'tag','fdsimul_uic_intext'),'position',[intext_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_dbouttext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_dbouttext'),'position',[dbin_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_outedit'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_outedit'),'position',[inedit_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_outtext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_outtext'),'position',[intext_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_alltext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_alltext'),'position',[inedit_offsx-inedit_dx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_muledit'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_muledit'),'position',[inedit_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_multext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_multext'),'position',[inedit_offsx-inedit_dx-5 pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_varrb(2)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_varrb(2)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_varrb(3)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_varrb(3)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]);
  %pos=get(findobj(myfig, 'tag','fdsimul_uic_varrb(4)'),'position')
  %set(findobj(myfig, 'tag','fdsimul_uic_varrb(4)'),'position',[pos(1) pos(2)+gr_offsy pos(3) pos(4)]); 
  pos=get(findobj(myfig, 'tag','fdsimul_uic_modelframe'),'position');
%  gr_offsx=fig_dx-20-frame_dx-pos(1);
  gr_offsx=0;
  set(findobj(myfig, 'tag','fdsimul_uic_modelframe'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy frame_dx pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_modelhdtext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_modelhdtext'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_mgrb(5)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_mgrb(5)'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_mgrb(1)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_mgrb(1)'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_mgrb(2)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_mgrb(2)'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_mgrb(3)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_mgrb(3)'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_mgrb(4)'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_mgrb(4)'),'position',[pos(1)+gr_offsx pos(2)+gr_offsy pos(3) pos(4)]);
  
  pos=get(findobj(myfig, 'tag','fdsimul_uic_netext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_netext'),'position',[pos(1) pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_needit'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_needit'),'position',[pos(1) pos(2) pos(3) pos(4)]);
  
  pos=get(findobj(myfig, 'tag','fdsimul_uic_retext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_retext'),'position',[pos(1) pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_reedit'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_reedit'),'position',[pos(1) pos(2) pos(3) pos(4)]);
  
  pos=get(findobj(myfig, 'tag','fdsimul_uic_statusframe'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_statusframe'),'position',[pos(1) pos(2) fig_dx pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_statustext'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_statustext'),'position',[pos(1) pos(2) fig_dx-6 pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_donepb'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_donepb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_cancelpb'),'position');
  cancelpb_offsx=fig_dx-pos(3)-20;
  set(findobj(myfig, 'tag','fdsimul_uic_cancelpb'),'position',[fig_dx-pos(3)-20 pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_fdsimulpb'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_fdsimulpb'),'position',[cancelpb_offsx pos(2) pos(3) pos(4)]);
  pos=get(findobj(myfig, 'tag','fdsimul_uic_ptpop'),'position');
  set(findobj(myfig, 'tag','fdsimul_uic_ptpop'),'position',[pos(1) pos(2) pos(3) pos(4)]);
  
else 
  if guiinfos('isdevelopment')
    error(['Error: fdsimul.m called with incorrect command:' p1]) 
  end
end
%End of fdsimul

function setscale(myfig)
% enable/disable scale editbox
c=allchild(myfig);
hsc=[findobj(c,'flat','tag','fdsimul_uic_muledit'),...
  findobj(c,'flat','tag','fdsimul_uic_multext'),...
  findobj(c,'flat','tag','fdsimul_uic_alltext')];
varset=findobj(c,'flat', 'UserData', 'fdsimul_uic_varrb','value',1);
if findstr(get(varset,'tag'),'(1)'), setval='off'; setvxy='on';
else setval='on'; setvxy='off';
end
set(hsc,'enable',setval,'visible',setval)
hvxy=[findobj(c,'flat','tag','fdsimul_uic_intext'),...
  findobj(c,'flat','tag','fdsimul_uic_inedit'),...
  findobj(c,'flat','tag','fdsimul_uic_dbintext'),...
  findobj(c,'flat','tag','fdsimul_uic_outtext'),...
  findobj(c,'flat','tag','fdsimul_uic_outedit'),...
  findobj(c,'flat','tag','fdsimul_uic_dbouttext')];
set(hvxy,'enable',setvxy)


function setdelay(myfig)
% enable/disable delay editbox and Periodic/One-shot pulldown
% Ampl. source     Delay      Periodic           option
% ------------------------------------------------------
% None             grey        grey                 0
% Import data      grey        grey                 1
% Model (z)        active      active               2
% Model (~z)       grey(Inf)   grey(Periodic)       3
c=allchild(myfig);
h=findobj(c,'flat','userdata','fdsimul_uic_mgrb', 'value', 1);
if isempty(h)
  option=0;
else
  str=get(h, 'tag'); 
  index=str2num(str(18)); % num char in tag
  if index==5 % import data
    option=1;
  else
    moddata=guidtard(get(myfig, 'tag'), 'IMPORTDATA_MODEL');
    domain=moddata.variable;
    if any(findstr(domain, 'z'))
      option=2;
    else
      option=3;
    end
  end
end

h_delay=[findobj(c,'flat','tag','fdsimul_uic_tdtext');...
  findobj(c,'flat','tag','fdsimul_uic_tdedit');...
  findobj(c,'flat','tag','fdsimul_uic_tdtext2')];
h_period=[findobj(c,'flat','tag','fdsimul_uic_ptpop');...
  findobj(c,'flat','tag','fdsimul_uic_pttext')];


switch option
case {0,1}
  set(h_delay, 'enable', 'off');
  set(h_period, 'enable', 'off');
case 2
  set(h_delay, 'enable', 'on');
  set(h_period, 'enable', 'on');
  set(h_delay(3), 'string', 'samples');
case 3
  set(h_delay, 'enable', 'off'); 
  set(h_delay(2), 'string', 'Inf');
  set(h_delay(3), 'string', 's');
  set(h_period, 'enable', 'off', 'value', 1); % 'Periodic'
end
set(h_delay,'visible','off') %Delay is not yet implemented
%
            
