function getcald(p1,p2,p3,p4,p5,seltype);
% get calibration data for measurement window
% helper fcn of fdtool

% p1: init   - full list
%     init2  - no take data

Me='fdtool_getcaldatafig';
MyHand=findall(0, 'tag',Me);
myfcn='getcald';  

if nargin >0 & ~any(findstr(p1, 'init'))
   if nargin == 6
      sender=p5;                
   else                                                
      seltype=get(MyHand,'selectiontype');
      eval(['sender=p', num2str(nargin) ';']);
   end
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                 INITIALIZATION
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



if nargin == 0 | any(findstr(p1, 'init'))
   if ~isempty(MyHand), delete(MyHand), end
   f = figure('Units','pixels', ...
      'Position',windspos(Me), ...
      'color', get(0,'defaultuicontrolbackgroundcolor'),...
      'Numbertitle', 'off', ...
      'IntegerHandle', 'off',...
      'Handlevisibility', 'off',...
      'resize', 'off', ...
      'closerequestfcn',['fdtool(''callback'',''',myfcn ''',''ui_cancel'',''getcaldata_cancel'')'],...
      'Name', 'Calibration', ...
      'windowstyle', 'modal', ...
      'visible','off',...
      'Tag', Me);
   MyHand=f;
   fdwindef(f);  % set default window properties
   
   getcaldata_import1 = uicontrol('Parent',f, ...
      'Units','pixels', ...
      'Position',[15 150 140 25], ...
      'String','Import fiddata...', ...
      'Tooltipstring','Read fiddata object from workspace, or from file',...      
      'callback', 'fdtool(''callback'',''getcald'',''ui_import_fiddata'',''getcaldata_import1'')', ...
      'interruptible', 'off', ...
      'Tag','getcaldata_import1');
   
   getcaldata_import2 = uicontrol('Parent',f, ...
      'Units','pixels', ...
      'Position',[15 115 140 25], ...
      'String','Import fidmodel...', ...
      'Tooltipstring','Read fidmodel object from workspace, or from file',...      
      'callback', 'fdtool(''callback'',''getcald'',''ui_import_fidmodel'',''getcaldata_import2'')', ...
      'interruptible', 'off', ...
      'Tag','getcaldata_import2');
   
   if findstr(p1, '2')
      take_enable='off';
   else
      take_enable='on';
   end
   getcaldata_take = uicontrol('Parent',f, ...
      'Units','pixels', ...
      'Position',[15 80 140 25], ...
      'String','Take data...', ...
      'Tooltipstring','Take calibration data from ',...      
      'callback', 'fdtool(''callback'',''getcald'',''ui_import_takedata'',''getcaldata_import3'')', ...
      'interruptible', 'off', ...
      'enable', take_enable, ...
      'Tag','getcaldata_import3');
   
   h = uicontrol('Parent',f, ...
      'Units','pixels', ...
      'Position',[40 20 90 25], ...
      'String','Cancel', ...
      'Tooltipstring','Close window without action',...
      'callback', 'fdtool(''callback'',''getcald'',''ui_cancel'',''getcaldata_cancel'')', ...
      'interruptible', 'off', ...
      'Tag','getcaldata_cancel');
   
   
   guimenus(Me,'getcaldata','getcaldata');
   helpmgr('init_help', '', myfcn, MyHand );
   
%   if nargin >1 
%      storewin('restore_all', Me, p2) % bring up window with settings in p2
%   else
%      storewin('recover', Me); % restore previous settings if any
%   end
   
   intoscr({Me});
   
   % The above function, intoscr positions the windows given by their labels
   % into the actual screen. This might come handy when the session has been saved 
   % on a machine with different resolution than that of the present machine.
   
   set(MyHand, 'visible', 'on');
   ulevctrl; 
   
else % not init
   
   if findstr(p1, 'ui_import')
      guiclose('getcaldata')
      if findstr(p1,'fidmodel')
         fdmeasw('calibration_selection', 'fidmodel')
      elseif findstr(p1,'fiddata')
         fdmeasw('calibration_selection', 'fiddata')
      else
         fdmeasw('calibration_selection', 'take')
      end
      
   elseif strcmp(p1, 'ui_cancel')
      guiclose('getcaldata')
      fdmeasw('calibration_selection', 'cancel')
      
      
   elseif strcmp(p1,'status')
      fdmeasw('status', p2)
      
   end % of last command
end % of commands


