function Z=orthz(parr,domain)
%ORTHZ Determine Z vector (array) from array of orthogonal polynomials
%
%       Z=ORTHZ(parr,domain)
%
%       Output arguments:
%       Z = vector of recursion coefficients
%
%       Input arguments:
%       parr = array of orthogonal polynomials
%       domain = domain we use
%
%       See also: ORTHOPOL.
%
%       Usage: Z=orthz(parr,domain);

%       Copyright (c) I. Kollar and Vrije Universiteit Brussel, ELEC, 1991-2001
%       All rights reserved.
%       $Revision: $
%       Last modified: 07-Oct-2001

error(nargchk(2,2,nargin))
if diff(size(parr))~=0, error('parr is not quadratic'), end
ord=size(parr,1)-1;
if any(domain=='sp')
  Z=zeros(ord+1,1);
  for r=ord:-1:1
    Z(r+1)=parr(r,ord+2-r)/parr(r+1,ord+1-r);
  end
  Z(1)=1/parr(1,ord+1);
else %'z'
  Z=zeros(ord+1,ord+1);
  error('not yet ready')
end
%
%End of orthz
