function [LongHelp, ShortHelp, Name]=fdhlpstr(WinTag, ObjTag)
% function [LongHelp, ShortHelp, Name]=fdhlpstr(WinTag, ObjTag)
% FDTool help file

% This is a machine generated file ----DO NOT EDIT----
% Help text written by IK.
% Converter by GYS. Converter version: 1998.05.31
%                   Modified:          1999.09.06

% File generated: 2005. 06. 26.  17:10

switch WinTag
case 'fdtool_main'
   switch ObjTag
   case {'fdtool_main'}
      Name='Fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            '!@!Identification in General!@!\n' ...
            'In this toolbox we identify a transfer function model of a system, \n' ...
            'starting from measured input-output data. The data can be collected in \n' ...
            'time or in frequency domain. The model can be discrete- or \n' ...
            'continuous-time. Tools are provided to select the best model and to \n' ...
            'calculate uncertainty bounds on the identified model (transfer function, \n' ...
            'poles and zeros, or model parameters). The presence of nonlinear \n' ...
            'distortions can also be detected.\n' ...
            '!@!About the GUI!@!\n' ...
            'The Graphical User Interface for frequency domain system identification is \n' ...
            'based on a flow graph. Blocks represent actions, and arrows represent \n' ...
            'data. A double-click or a right-button mouse click opens the desired \n' ...
            'object. This is true in general for the whole GUI: double-click on many \n' ...
            'objects will open them, or zoom-in, or bring up additional information.\n' ...
            '\n' ...
            'The states of the individual elements are color-coded (see Colors). Some \n' ...
            'blocks only become selectable when data appear on their input.\n' ...
            '\n' ...
            'When an inadequate setting is detected, the interface gracefully returns \n' ...
            'for correction with a warning or an error message. The only situation it \n' ...
            'cannot cope with occurs when during execution of an action, the mouse \n' ...
            'selects another control, which starts a parallel action. Therefore, start \n' ...
            'a new action only when the previous one is done (see the status line at \n' ...
            'the bottom of the main window).\n' ...
            '\n' ...
            'In most cases the user is prevented from too early actions by making the \n' ...
            'marker inactive (hourglass-form). However, parallel execution can cause \n' ...
            'such possibilities on certain platforms. When this happens, the marker may \n' ...
            'remain inactive. In such a case move the cursor a little bit over a \n' ...
            'window. This will allow again the continuation of the work. If this does \n' ...
            'not help, select "File" / "Unfreeze GUI" in the main window.\n' ...
            '!@!Different User Levels!@!\n' ...
            'Uitoggletools can set "UserLevel", and by this, modify the complexity of \n' ...
            'the GUI. At this moment "Automatic", and "Interactive" levels are \n' ...
            'available.\n' ...
            '\n' ...
            'At level "Automatic", a number of default settings and automatic \n' ...
            'processing steps are made. This includes automatic data preprocessing and \n' ...
            'automatic order selection (see the help of the block "Estimate Plant \n' ...
            'Model", when you already have preprocessed data at its input).\n' ...
            '\n' ...
            'At level "Intermediate", settings can be set manually. Moreover, at \n' ...
            'intermediate level excitation signals can be designed, and complex aspects \n' ...
            'of the models can be viewed.\n' ...
            '\n' ...
            '!@!Colors!@!\n' ...
            'Meaning of colors on the main block diagram:\n' ...
            '\n' ...
            '- gray means disabled block or empty arrow (a gray block cannot be opened \n' ...
            'because of lack of input data or too low UserLevel setting),\n' ...
            '- blue means an enabled block (it can be opened) which has not yet been \n' ...
            'used, or its input and output data do not belong together (the input data \n' ...
            'were changed later)\n' ...
            '- green means that data are already present,\n' ...
            '- light green arrow means presence of secondary data overshadowed by data \n' ...
            'of the other arrow (can be made primary by selection),\n' ...
            '- dark green marks an arrow with directly loaded data,\n' ...
            '- cyan is the color of a currently opened block.\n' ...
            '\n' ...
            'In the graphs with frequency domain data, which open up later, the general \n' ...
            'rules are as follows. Every quantity is shown by defaults in dB (except \n' ...
            'for phase diagrams (degrees) and explicitly denoted linear-in-amplitude \n' ...
            'plots)\n' ...
            '- green + marks denote the measured data\n' ...
            '- yellow x marks denote the variances\n' ...
            '- red line denotes the estimated transfer function\n' ...
            '- cyan is the color of the residuals (the difference between the measured \n' ...
            'data and the estimated transfer function)\n' ...
            '\n' ...
            '!@!Blocks!@!\n' ...
            'Blocks are the key action elements. Only blue or green blocks can be \n' ...
            'opened, by double-click (or right button click). Blocks are in general \n' ...
            'allowed for use if their necessary input data are available. An exception \n' ...
            'is the block "Excitation Signal Design" which also needs for use that \n' ...
            '"UserLevel" is set to "Interactive" or higher. \n' ...
            '\n' ...
            'At start only the blocks "Read Time Domain Data" and "Read Freq. Domain \n' ...
            'Data" can be opened.\n' ...
            '\n' ...
            'Blocks return output data after the Close command. In this case their \n' ...
            'color becomes green. The Cancel command closes them without affecting \n' ...
            'either their output or their previous setting.\n' ...
            '\n' ...
            'When a block is already opened, and we click on another one, a warning \n' ...
            'comes up. We can then immediately cancel the previous block and go to the \n' ...
            'new one.\n' ...
            ' \n' ...
            'There are three special automatic actions if the menu "UserLevel" is set \n' ...
            'to "Automatic". After importing the data into the block "Read Time Domain \n' ...
            'Data", it automatically preprocesses them with automatic period length \n' ...
            'determination and default settings. Similarly, "Read Frequency Domain \n' ...
            'Data" will automatically execute after "Close". \n' ...
            'The block "Variances and/or Averaging" also automatically proceeds after \n' ...
            'any of the Read blocks or after having opened it (at least if this is \n' ...
            'possible), and the block "Estimate Plant Model" automatically closes after \n' ...
            'estimation, and the block "Evaluate or Compare Plant Models" opens up.\n' ...
            '!@!Arrows!@!\n' ...
            'Arrows can be opened in any state by double-click (or right button click), \n' ...
            'but the commands Save/Plot/Activate are only accessible if data are \n' ...
            'present.\n' ...
            ' \n' ...
            '"Load" is a special possibility to directly bring/restore data to the GUI \n' ...
            'without activating a block. It is intelligent in the sense that it checks \n' ...
            'the data type before loading. After "Load", a special dark green color \n' ...
            'shows that data were directly loaded instead of generating them using a \n' ...
            'block.\n' ...
            '\n' ...
            '"Save" is the opposite pair of "Load". It stores the data of the selected \n' ...
            'arrow into a file or to the workspace.\n' ...
            '\n' ...
            '"Activate" means that two different arrows contain data at the input of a \n' ...
            'block (Variances and/or Averaging, or Compare and Evaluate Models), and we \n' ...
            'want to activate the "secondary" arrow. \n' ...
            '!@!Helps!@!\n' ...
            'There are several levels of help on the main window and on the next level \n' ...
            'windows.\n' ...
            '\n' ...
            'The quickest and simplest facility is provided by pop-up helps. When the \n' ...
            'mouse is moved over an object, usually a "balloon help" pops up with the \n' ...
            'most essential information. Exceptions are "patches" (colored areas in \n' ...
            'block diagrams) and axes which do not yet have this possibility in MATLAB \n' ...
            '- for these a simple click on the object brings up a brief help in the \n' ...
            'bottom line of the window, or even better, the facility "Help on Object" \n' ...
            'can be used.\n' ...
            '\n' ...
            'Help can also be gotten through the Help menu, for the GUI in general, and \n' ...
            'for the current window. The menu item "Help on Object" allows getting help \n' ...
            'on most visible objects in a window, by clicking on them with the question \n' ...
            'mark.\n' ...
            '\n' ...
            'Many ideas and examples are available from the demonstrations, available \n' ...
            'from the "Help" menu of the main window.\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'export-import'}
      Name='Export/Import Data';
      LongHelp=sprintf( ...
         [ ...
            '!@!Loading data!@!\n' ...
            'Data can be directly loaded (imported) or assembled from vectors/files in \n' ...
            'the two "Read ... Data" blocks. \n' ...
            '\n' ...
            'When the data are available as workspace variables or ASCII files or \n' ...
            'variables in MAT-files, the "Compose" command allows to assemble them. The \n' ...
            'fields of the Compose window can be filled in with valid MATLAB commands, \n' ...
            'like variables, subscripted variables like data(:,2), or special file \n' ...
            'references (use "Browse" at the appropriate places). When assembling the \n' ...
            'objects, the function checks the data if they are consistent indeed, and \n' ...
            'give warnings if they are not.\n' ...
            '\n' ...
            'The "Import" procedure checks the type of the data: they must be \n' ...
            '''tiddata'' or ''fiddata'' objects, or maybe ''iddata'' objects (see \n' ...
            'System Identification Toolbox, V5.x or later). The first two types of \n' ...
            'objects can be created by the functions "tiddata" and "fiddata" from your \n' ...
            'own vectors - see "Help / Getting Started... / Using Time Domain Data", or \n' ...
            '"Help / Getting Started... / Using Freq. Domain Data", and the corresponding \n' ...
            'function helps for details. The objects allow the use of the ''get'' and \n' ...
            '''set'' functions: e.g. get(dat).\n' ...
            '\n' ...
            'In time domain, automatic determination of the period length, the \n' ...
            'excitation frequencies, and the Fourier coefficients is provided. However, \n' ...
            'if you can set the first two or at least the second one properly, this can \n' ...
            'improve speed and calculation accuracy. So, if you can, do not forget to \n' ...
            'fill in the "Frequencies" and/or the "PeriodLength" property, e.g. \n' ...
            '\n' ...
            '     data.periodlength = 0.03;\n' ...
            '\n' ...
            'and/or\n' ...
            '\n' ...
            '     data.frequencies = 1e3*[1:2:19];\n' ...
            '\n' ...
            'If  the data of more than one experiments are used, and measurements are \n' ...
            'properly synchronized, set also the property "synchronization", e.g. \n' ...
            '\n' ...
            '     data.synchronization=''on'';\n' ...
            '\n' ...
            'otherwise unnecessarily long processing time may be wasted later, during \n' ...
            'the execution of the "Variance Analysis" block.\n' ...
            '\n' ...
            'Saving/loading intermediate data can be done by double-clicking on the \n' ...
            'appropriate arrow, and selecting "Save arrow data" or "Load arrow data". \n' ...
            'The whole session can also be saved for later use by the File/Save/Session \n' ...
            'menu of the main window.\n' ...
            '!@!Preparing time domain object!@!\n' ...
            'Here an example is given how to prepare a proper tiddata object for \n' ...
            'importing into the GUI, if the "Compose" window is not used.\n' ...
            'Let us assume that we have measured 4096 time domain samples, which are \n' ...
            'stored in the vectors ''inp'' and ''outp''. The sampling frequency is fs = \n' ...
            '40960 Hz, the period length in each signal is Tp = 1/80 s (there are 8 \n' ...
            'periods). The frequency content is fv = [1:2:15]/Tp.\n' ...
            '\n' ...
            '%%Make the object:\n' ...
            'obj = tiddata(outp,inp,1/40960);\n' ...
            '%%Set some properties:\n' ...
            'obj.periodlength = 1/80;\n' ...
            'obj.frequencies = [1:2:15]/80;\n' ...
            'get(obj) %%check properties\n' ...
            '\n' ...
            'Now the variable obj can be imported to the block "Read Time Domain \n' ...
            'Data".\n' ...
            '!@! Preparing time domain object, 5 exp!@!\n' ...
            'Here an example is given how to prepare a proper tiddata object from \n' ...
            'multiple experiments for loading into the GUI, if the "Compose" window is \n' ...
            'not used.\n' ...
            'Assume that we have multiple experiments, and let us assume that we have \n' ...
            'measured five times 1024 time domain samples, which are stored in the 1024 \n' ...
            'x 5 arrays inp and outp. The sampling frequency is fs = 40960 Hz, the \n' ...
            'period length in each signal is 1/160 s (there are 4 periods in each \n' ...
            'record).\n' ...
            '\n' ...
            '%%First prepare the data in 1 x 5 cell arrays:\n' ...
            'u = num2cell(inp,1); y = num2cell(outp,1);\n' ...
            '%%Now make the object:\n' ...
            'obj = tiddata(y,u,1/40960);\n' ...
            '%%Set some properties:\n' ...
            'obj.periodlength = 1/160;\n' ...
            'obj.frequencies = [1:2:25]/160;\n' ...
            'obj.synchronization=''on'';\n' ...
            'get(obj) %%check properties\n' ...
            '\n' ...
            'Now the variable obj can be imported to the block "Read Time Domain \n' ...
            'Data".\n' ...
            '!@! Preparing object from FRF data!@!\n' ...
            'FRF data can be best processed in the "Compose" window, or some more hints \n' ...
            'can be read on the WEB, at \n' ...
            'http://elecwww.vub.ac.be/fdident/frf-data.html\n' ...
            'Here is an example how to prepare a proper fiddata object for loading into \n' ...
            'the GUI, if the "Compose" window is not used.\n' ...
            '\n' ...
            'Let us assume that we have measured gain and phase data at frequency \n' ...
            'points [100 Hz - 40 kHz], at 50 Hz steps. The gain data are in dB, the \n' ...
            'phase data are in degrees.\n' ...
            '\n' ...
            'The frequency vector is\n' ...
            '\n' ...
            '     freqv = [100/50:40e3/50]''*50; %%assure proper number of points\n' ...
            '\n' ...
            'Now size(freqv), size(gain) and size(phase) should be in general the same, \n' ...
            'all column vectors.\n' ...
            '\n' ...
            '     FRF = 10.^(gain/20).*exp(j*phase/360*2*pi);\n' ...
            '     obj = fiddata(FRF,ones(size(FRF)),freqv);\n' ...
            '\n' ...
            'It is also possible for multiple experiments that that ''gain'' and \n' ...
            '''phase'' are cell row vectors with equal-sized column vectors as \n' ...
            'elements.\n' ...
            '\n' ...
            'Now the variable obj can be imported into the block "Read Frequency Domain \n' ...
            'Data".\n' ...
            '!@!Saving models!@!\n' ...
            'The end results can be saved either by selecting the File/Save menu of any \n' ...
            'of the last three blocks, or by double-clicking on an arrow containing a \n' ...
            'model or a set of models. Remark: model saving is not accessible in trial \n' ...
            'versions, but otherwise the toolbox is fully functional for trial.\n' ...
            '\n' ...
            'The saved variable is a fidmodel object. Its properties contain all \n' ...
            'important information about the model. If the name of the variable is \n' ...
            '"modobj", for a list of the properties, issue "get(modobj)" or \n' ...
            '"help(fidmodel)", and get the value of a property as e.g. numv=modobj.num. \n' ...
            'Another possibility is to use the command "exppar(object,filename)" in the \n' ...
            'command window to generate an ASCII file with the most important model \n' ...
            'data.\n' ...
            '\n' ...
            'Study the structure of the object and the exact meaning of each property \n' ...
            'carefully, because the meaning of properties may slightly change in \n' ...
            'certain cases. For example, for orthogonal representation, the \n' ...
            'coefficients of the transfer function numerator and denominator are not \n' ...
            'accessible, only the coefficients of the orthogonal polynomials. However, \n' ...
            'functions like "info(modobj)", "pole(modobj)", "plot(modobj)", \n' ...
            '"plotpz(modobj)", "tfcalc(modobj,freqv)" etc. take care of these \n' ...
            'differences automatically, so use the objects primarily in the toolbox \n' ...
            'functions, or transform them to the Control System Toolbox by \n' ...
            '"tf(modobj)", ss(modobj)", etc.\n' ...
            '\n' ...
            'A model set is an array of fidmodel objects. If necessary, models or model \n' ...
            'arrays can be united into a model array as in the command lines:\n' ...
            '\n' ...
            'arr1 = [model1,model2]; %%create model array\n' ...
            'arr2 = [arr1,model3];\n' ...
            'model_array = [arr1,arr2]; %%concatenation of arrays\n' ...
            '\n' ...
            'In the above examples, model<i> denotes a fidmodel object.\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'getting_started'}
      Name='Getting Started...';
      LongHelp=sprintf( ...
         [ ...
            '!@!First hints!@!\n' ...
            'Read first the "Fdident GUI" help texts under the "Help" menu of the main \n' ...
            'window. These give a brief overview of the main features. This should be \n' ...
            'enough for the start: on-line help is available everywhere you need, in \n' ...
            'every window. Most objects (pushbuttons, popup menus, etc) have tooltips: \n' ...
            'when the mouse is moved above them, a short description appears in a small \n' ...
            'window. A more effective way is to select "Help on Object", and click with \n' ...
            'the pointer with the question mark on the object you are interested in. \n' ...
            'This latter facility is available even for objects do not have a tooltip \n' ...
            '(plots, blocks, etc.).\n' ...
            '\n' ...
            'Many possibilities of the GUI are illustrated by the demonstrations \n' ...
            'started from "Introductory Demos" and "Complex Examples and Demos" under \n' ...
            'the main "Help" menu.\n' ...
            '\n' ...
            'The next step can be your first own data processing. Read in some data, \n' ...
            'and perform the necessary steps. See the details under Topics "Using Freq. \n' ...
            'Domain Data" and "Using Time Domain Data". \n' ...
            '\n' ...
            'Several models can be scanned in the "Computer Aided Model Scan" window. \n' ...
            'Their qualities can be compared in the window "Evaluate or Compare Plant \n' ...
            'Models".\n' ...
            '\n' ...
            'You are able to work with your own data as well. See the menu topic\n' ...
            '"Help" / "Export/Import Data".\n' ...
            '!@!Using Freq. Domain Data!@!\n' ...
            'Example: open "Read Freq. Domain Data", "Get data", and import data with \n' ...
            'the choices "From File", "Browse demos". Then you can select data from \n' ...
            'supported files. A good choice is "bandpass.mat", variable \n' ...
            '"bandpass_synch". After viewing the plot, Close the Read Frequency Domain \n' ...
            'Data window. If you left "UserLevel" at "Automatic" in the menu of the \n' ...
            'main window, this will launch automatic execution until opening the \n' ...
            '"Estimate Plant Model" window. Otherwise, open "Variance and/or \n' ...
            'Averaging". This will automatically preprocess your data, and after \n' ...
            'closing it, you can make estimation in the block "Estimate Plant Model". \n' ...
            'The best order selection for the bandpass data is 4/6 in s-domain, but \n' ...
            'other choices may also work well. The results can be studied in the last \n' ...
            'window, "Evaluate or Compare Plant Models".\n' ...
            '\n' ...
            'If you have your data at vectors/arrays in the workspace, use the \n' ...
            '"Compose" button: this allows to automatically assemble your data object \n' ...
            'from common Matlab variables in the workspace. If you have your data in \n' ...
            'files, load them first into the workspace, and then execute "Compose". FRF \n' ...
            'data can also be processed in the "Compose" window, or some more hints can \n' ...
            'be read on the WEB, at \n' ...
            'http://elecwww.vub.ac.be/fdident/frf-data.html\n' ...
            '\n' ...
            'A last possibility is to make your fiddata object in the command window, \n' ...
            'using the functions ''fiddata''.\n' ...
            '!@!Using Time Domain Data!@!\n' ...
            'Example: open "Read Time Domain Data", and import data with the choices \n' ...
            '"Get Data", "From File", "Browse demos", "robotarm.mat", variable \n' ...
            '"robotarm_rawdata". If you have left "UserLevel" set to "Automatic" in the \n' ...
            'menu of the main window, this block will now automatically preprocess the \n' ...
            'data. If "UserLevel" is set to "Interactive" or higher, you may experiment \n' ...
            'with the settings at each step.\n' ...
            '\n' ...
            'If you have your data at vectors/arrays in the workspace, use the \n' ...
            '"Compose" button: this allows to automatically assemble your data object \n' ...
            'from common Matlab variables in the workspace. If you have your data in \n' ...
            'files, load them first into the workspace, and then execute "Compose".\n' ...
            '\n' ...
            'When you generate your own data in the command window with the function \n' ...
            '''tiddata'', keep in mind how you want to process the data. You must have \n' ...
            'either at least 3 experiments, or at least 3 segments from one experiment. \n' ...
            'Either automatic preprocessings needs to be used, or proper manual \n' ...
            'segmentation can only be done if the period length of the data is known. \n' ...
            'Therefore, fill in one of the tiddata properties "PeriodLength" or \n' ...
            '"Frequencies", e.g.\n' ...
            '\n' ...
            '     data.periodlength = 0.03;\n' ...
            '\n' ...
            'and/or\n' ...
            '\n' ...
            '     data.frequencies = 1e3*[1:2:19];\n' ...
            '\n' ...
            'If you have more than on experiment, it is important to tell if the \n' ...
            'experiments were synchronized (proper triggering was used always at the \n' ...
            'same phase of the excitation signal), otherwise lengthy tests follow. \n' ...
            'E.g.\n' ...
            '\n' ...
            '     data.synchronization=''on'';\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'nonlinearities'}
      Name='Analyze nonlinearities';
      LongHelp=sprintf( ...
         [ ...
            'The toolbox is capable to analyze nonlinear behavior of systems. For this, \n' ...
            'appropriate signals have to be designed, special data preprocessing is to \n' ...
            'be executed, and identification needs to be done using the nonlinear \n' ...
            'errors.\n' ...
            '\n' ...
            'The simplest introductions to these are provided by the demonstrations \n' ...
            'available under the "Examples: how to..." menu items under the Help menu.\n' ...
         ]);
      ShortHelp='';
      return
   case {'rect_excitation'}
      Name='Excitation Signal Design';
      LongHelp=sprintf( ...
         [ ...
            'Design of different periodic excitation signals. Types of signals: \n' ...
            'multisine, discrete interval binary signal (DIBS), discrete interval \n' ...
            'three-level signal (DITS) or pseudo random binary signal (PRBS or MLBS).\n' ...
            '\n' ...
            'This block is enabled only if "UserLevel" is "Interactive" or higher.\n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- gray means block disabled for some reason (e.g. because UserLevel is \n' ...
            '"Automatic"),\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click), the block has not yet been used\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The data are available on the output arrow, either \n' ...
            'for one of the next blocks (e.g. for simulation), or by double-clicking on \n' ...
            'the arrow, and selecting "Save Arrow Data". in the resulting object (let \n' ...
            'us name it ''obj''), the basic data are as follows:\n' ...
            '  get(obj) %show all properties\n' ...
            '  obj.u %sample vector\n' ...
            '  obj.Ts %sampling time\n' ...
            '  obj.frequencies %vector of excited frequencies\n' ...
         ]);
      ShortHelp='Design excitation signal';
      return
   case {'rect_gettime'}
      Name='Read Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'Read in time domain data, preprocess them, and convert them to frequency \n' ...
            'domain. For a detailed description, see "Help / Export/import data" in \n' ...
            'this window.\n' ...
         ]);
      ShortHelp='Get time domain data: import, then convert to frequency domain';
      return
   case {'rect_gettime_measurement'}
      Name='Read Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'If UserLevel is set to Interactive, it can do also simulation and/or \n' ...
            'direct measurement.\n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click) which is not yet used, or the input and output data do not \n' ...
            'belong together (the input data were changed later)\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The Cancel command closes it without affecting either \n' ...
            'its output or its previous setting.\n' ...
         ]);
      ShortHelp='Instead of import, one can simulate or measure data before conversion to frequency domain';
      return
   case {'rect_getfreq'}
      Name='Read Frequency Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'Read in frequency domain data. For a detailed description, see "Help / \n' ...
            'Export/import data" in this window. \n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click) which is not yet used, or the input and output data do not \n' ...
            'belong together (the input data were changed later)\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The Cancel command closes it without affecting either \n' ...
            'its output or its previous setting.\n' ...
         ]);
      ShortHelp='Get frequency domain data: import.';
      return
   case {'rect_average'}
      Name='Variances and/or Averaging';
      LongHelp=sprintf( ...
         [ ...
            'Select the source of Fourier amplitudes (average of experiments or a \n' ...
            'single experiment), and get the associated variance data. \n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- gray means disabled block (it cannot be opened because input data are \n' ...
            'missing),\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click) which is not yet used, or the input and output data do not \n' ...
            'belong together (the input data were changed later)\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The Cancel command closes it without affecting either \n' ...
            'its output or its previous setting.\n' ...
         ]);
      ShortHelp='Define or calculate the Fourier amplitudes and the related variances';
      return
   case {'rect_select'}
      Name='Estimate Plant Model';
      LongHelp=sprintf( ...
         [ ...
            'The main identification tool. The basic choices, like domain, \n' ...
            'numerator/denominator orders, fixed or variable delay, etc. can be \n' ...
            'selected, and the iteration can be performed. \n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- gray means disabled block (it cannot be opened because input data are \n' ...
            'missing),\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click) which is not yet used, or the input and output data do not \n' ...
            'belong together (the input data were changed later)\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The Cancel command closes it without affecting either \n' ...
            'its output or its previous setting.\n' ...
         ]);
      ShortHelp='Select model parameters and make a fit';
      return
   case {'rect_aided'}
      Name='Computer Aided Model Scan';
      LongHelp=sprintf( ...
         [ ...
            'Scan a given set of models, with different combinations of numerator and \n' ...
            'denominator orders. The quality of models can be compared later by the \n' ...
            'next tool. \n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- gray means disabled block (it cannot be opened because input data are \n' ...
            'missing),\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click) which is not yet used, or the input and output data do not \n' ...
            'belong together (the input data were changed later)\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The Cancel command closes it without affecting either \n' ...
            'its output or its previous setting.\n' ...
         ]);
      ShortHelp='Scan a set of models for later comparisons';
      return
   case {'rect_compare'}
      Name='Evaluate or Compare Plant Models';
      LongHelp=sprintf( ...
         [ ...
            'Evaluate the quality of a model, validate against other data, and compare \n' ...
            'to other models.\n' ...
            '\n' ...
            'Meaning of the color of the block:\n' ...
            '\n' ...
            '- gray means disabled block (it cannot be opened because input data are \n' ...
            'missing),\n' ...
            '- blue means an enabled block (it can be opened by double-click or right \n' ...
            'button click) which is not yet used, or the input and output data do not \n' ...
            'belong together (the input data were changed later)\n' ...
            '- green means that data are already present in the block, the block may be \n' ...
            'reopened\n' ...
            '- cyan is the color of the block if it is currently opened.\n' ...
            '\n' ...
            'The block returns output data after the Close command. In this case its \n' ...
            'color becomes green. The Cancel command closes it without affecting either \n' ...
            'its output or its previous setting.\n' ...
         ]);
      ShortHelp='Evaluate models; compare different models and select the optimal one';
      return
   case {'fdtool_menu_load_session'}
      Name='Load session';
      LongHelp=sprintf( ...
         [ ...
            'Load session data from file. This allows continuing work from a given \n' ...
            'state of the GUI.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_load_default_session'}
      Name='Load default session';
      LongHelp=sprintf( ...
         [ ...
            'If there is a session file named "fddefses.mat" on the path, the GUI will \n' ...
            'read its contents.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_load_arrow_data'}
      Name='Load arrow data';
      LongHelp=sprintf( ...
         [ ...
            'Double-click on an arrow to manipulate with its data.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_load_input_data'}
      Name='Load input data';
      LongHelp=sprintf( ...
         [ ...
            'Give a hint how to load data from a file or from the workspace.\n' ...
            '\n' ...
            'Time domain data can be loaded by opening the block "Read Time Domain \n' ...
            'Data". The data must be in "tiddata" format, or maybe "iddata" (see Sysid \n' ...
            'toolbox). On the generation of the object, type "help tiddata" in the \n' ...
            'command window. If you have your data in a *.tnt, or *tim, or *.tbn file, \n' ...
            'you can alternatively use the command obj=tiddata(filename).\n' ...
            '\n' ...
            'Frequency domain data can be loaded by opening the block "Read Frequency \n' ...
            'Domain Data". The data must be in "fiddata" format, or maybe "iddata" (see \n' ...
            'Sysid toolbox). On the generation of this, type "help fiddata" in the \n' ...
            'command window. If you have your data in a *.fnt, or *.fou, or *.fbn file, \n' ...
            'you can alternatively use the command obj=fiddata(filename).\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_load_workspace_data'}
      Name='Load workspace data';
      LongHelp=sprintf( ...
         [ ...
            'Load variables from a MAT-file to the main workspace.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_save_session'}
      Name='Save session';
      LongHelp=sprintf( ...
         [ ...
            'Save complete session to file. The work can be continued later with the \n' ...
            'same settings and data.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_save_default_session'}
      Name='Save default session';
      LongHelp=sprintf( ...
         [ ...
            'Save session to file "fddefses.mat" in the working directory. This file \n' ...
            'will be read at every startup of the GUI.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_save_arrow_data'}
      Name='Save arrow data';
      LongHelp=sprintf( ...
         [ ...
            '#fdtool_menu_load_arrow_data#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_save_results'}
      Name='Save results';
      LongHelp=sprintf( ...
         [ ...
            'Give a hint how to save results to a file or to the workspace.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_closewindows'}
      Name='Close all windows';
      LongHelp=sprintf( ...
         [ ...
            'Close all fdident GUI related windows, except the main window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_forget_settings'}
      Name='Clear Panel settings';
      LongHelp=sprintf( ...
         [ ...
            'Reset settings of GUI panels to default values. The UserLevel and arrow \n' ...
            'data are not touched.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_forget_data'}
      Name='Clear Arrow data';
      LongHelp=sprintf( ...
         [ ...
            'Clear all arrow data in GUI. Otherwise panel settings etc. remain valid.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_forget_all'}
      Name='Clear GUI';
      LongHelp=sprintf( ...
         [ ...
            'Set the GUI to default state: clear all arrow data, and reset settings of \n' ...
            'GUI panels to default values. The same as performing the other two clear \n' ...
            'items.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_reset'}
      Name='Restart GUI';
      LongHelp=sprintf( ...
         [ ...
            'Restart the whole GUI with default settings.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_unfreeze'}
      Name='Unfreeze GUI';
      LongHelp=sprintf( ...
         [ ...
            'After certain not completely legal actions (e.g. Ctrl/C in the command \n' ...
            'window during run of the GUI) the GUI might stay in a "frozen" state \n' ...
            '(mouse partly inactive, and shows hourglass form). Movement of the mouse \n' ...
            'usually terminates this strange state. If the mouse movement does not \n' ...
            'help, this command stops this freezing.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_advanced_on'}
      Name='Enable/Disable Advanced Level';
      LongHelp=sprintf( ...
         [ ...
            'Enable/disable access to UserLevel "Advanced". This is usually not \n' ...
            'necessary for regular users. It gives access to certain special settings, \n' ...
            'e.g. increasing the number of iterations if the data require more than 50 \n' ...
            'steps. This is rarely needed. \n' ...
            '\n' ...
            'If you are interested, you may experiment with this option, but please \n' ...
            'acknowledge that this is not standard use and has not been fully tested in \n' ...
            'the toolbox.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_record', 'fdtool_menu_demo_open'}
      Name='Open Recorder';
      LongHelp=sprintf( ...
         [ ...
            'Open the action recorder. This can replay demos, record and replay GUI \n' ...
            'actions, and test GUI.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_demo_stop'}
      Name='Stop Recorder';
      LongHelp=sprintf( ...
         [ ...
            'Stop action recorder. This item can be used to take away control from the \n' ...
            'recorder, and go into usual interactive state\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_demo_close'}
      Name='Close Recorder';
      LongHelp=sprintf( ...
         [ ...
            'Remove action recorder from desktop.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_demo_open2'}
      Name='Open Recorder in development mode';
      LongHelp=sprintf( ...
         [ ...
            'Open the action recorder in development mode. This allows seeing extra \n' ...
            'details of the individual action in the records, set special handling, and \n' ...
            'so on.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_exit'}
      Name='Exit GUI';
      LongHelp=sprintf( ...
         [ ...
            'Close GUI (after an affirmative question).\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_userlevel'}
      Name='UserLevel';
      LongHelp=sprintf( ...
         [ ...
            'The UserLevel can be set to three different modes.\n' ...
            '\n' ...
            '"Automatic" means that the user need not make certain decisions: default \n' ...
            'decisions and automatic processing steps are made at every possible stage. \n' ...
            'The excitation signal design is disabled, and some information is given in \n' ...
            'the simplest form.\n' ...
            '\n' ...
            '"Interactive" means that all implemented GUI controls are accessible.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_modeltype'}
      Name='Model type';
      LongHelp=sprintf( ...
         [ ...
            'The model identified in the GUI can be of two different types.\n' ...
            '\n' ...
            '"Linear": Identify a linear transfer function model.\n' ...
            '\n' ...
            '"Nonlinear errors": Identify a linear model, paying attention to possible \n' ...
            'nonlinear disturbances.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_modeltype_linear'}
      Name='Model type: Linear';
      LongHelp=sprintf( ...
         [ ...
            'Identify a linear transfer function model in the Fdident GUI.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_modeltype_nonlinear_errors'}
      Name='Model type: Nonlinear errors';
      LongHelp=sprintf( ...
         [ ...
            'Analyze a system with nonlinearities. Pressing this button changes the \n' ...
            'behavior of the GUI in most windows, allowing the analysis of nonlinear \n' ...
            'errors. See the "Example: how to..." menu items under the Help menu.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_text_modeltype'}
      Name='Model type';
      LongHelp=sprintf( ...
         [ ...
            '#fdtool_menu_modeltype#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_userlevel_basic'}
      Name='User level: Automatic';
      LongHelp=sprintf( ...
         [ ...
            'Set user level to Automatic. This means that the user need not make \n' ...
            'certain decisions: default decisions and automatic processing steps are \n' ...
            'made at every possible stage. Some of the information is given in simple \n' ...
            'form.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_userlevel_intermediate'}
      Name='User level: Interactive';
      LongHelp=sprintf( ...
         [ ...
            'Set user level to Interactive. This means that all implemented GUI \n' ...
            'controls are accessible during processing. The user has the possibility to \n' ...
            'select from several options.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_userlevel_advanced'}
      Name='User level: Advanced';
      LongHelp=sprintf( ...
         [ ...
            'Set user level to Advanced. This means in addition to user level \n' ...
            '"Interactive" that fine-tuning of the run of certain individual function \n' ...
            'M-files is also possible.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_start'}
      Name='Getting started...';
      LongHelp=sprintf( ...
         [ ...
            'Hints for somebody who first starts the GUI.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the GUI with a set of topics.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Explain how the main GUI window works.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_object'}
      Name='Help on Object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_help_introductions'}
      Name='Introductory demonstrations';
      LongHelp=sprintf( ...
         [ ...
            'Illustrate the use of the toolbox on a few simple examples.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_help_introductions_gui'}
      Name='Introductory demonstrations on the GUI';
      LongHelp=sprintf( ...
         [ ...
            'Illustrate the use of the toolbox on a few simple examples.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_help_introductions_ident'}
      Name='Introductory demonstrations on identification';
      LongHelp=sprintf( ...
         [ ...
            'Illustrate frequency domain system identification on a few simple examples.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_help_examples'}
      Name='Examples and demos';
      LongHelp=sprintf( ...
         [ ...
            'Run demos to illustrate the power and the possibilities of the toolbox.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_devb_web'}
      Name='Developers'' WEB Page';
      LongHelp=sprintf( ...
         [ ...
            'Connect through default WEB browser to the developers'' page of the \n' ...
            'toolbox:\n' ...
            'http://elecwww.vub.ac.be/fdident/\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_dev_mail'}
      Name='Technical Support';
      LongHelp=sprintf( ...
         [ ...
            'Display help how to reach technical support.\n' ...
            'Email address: fdident@vub.ac.be\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_data_web'}
      Name='Data Sheet from WEB';
      LongHelp=sprintf( ...
         [ ...
            'Data sheet in PDF form, shown in the default browser\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_lic'}
      Name='License Information';
      LongHelp=sprintf( ...
         [ ...
            'Display license terms and conditions.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_manual_int'}
      Name='Manual (PDF, internal browser)';
      LongHelp=sprintf( ...
         [ ...
            'Open manual in PDF form, using built-in browser of Matlab. This manual \n' ...
            'describes the basic functionalities of the toolbox, and contains a guide \n' ...
            'to the backward compatible command-line calls of the functions (compatible \n' ...
            'with toolbox version 2.0.3, distributed with Matlab 5.x).\n' ...
            '\n' ...
            'Each function also has a new, simple calling form, based on the objects. \n' ...
            'To learn about these, simply type ''help <function>'' or ''usage \n' ...
            '<function>'' in the command line.\n' ...
            '\n' ...
            'The graphical user interface has its own, built-in helps.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_manual'}
      Name='Manual (PDF)';
      LongHelp=sprintf( ...
         [ ...
            'Open manual in PDF form. This manual describes the basic functionalities \n' ...
            'of the toolbox, and contains a guide to the backward compatible \n' ...
            'command-line calls of the functions (compatible with toolbox version \n' ...
            '2.0.3, distributed with Matlab 5.x).\n' ...
            '\n' ...
            'Each function also has a new, simple calling form, based on the objects. \n' ...
            'To learn about these, simply type ''help <function>'' or ''usage \n' ...
            '<function>'' in the command line.\n' ...
            '\n' ...
            'The graphical user interface has its own, built-in helps.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_menu_help_about'}
      Name='About fdident';
      LongHelp=sprintf( ...
         [ ...
            'Display basic data of this fdident version.\n' ...
         ]);
      ShortHelp='';
      return
   case {'l1', 'l2', 'l3'}
      Name='Output of ESD';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: excitation signal, a tiddata object. See Help / \n' ...
            'Fdident GUI / Arrows for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Excitation signal: tiddata object';
      return
   case {'l4', 'l5'}
      Name='Input of VA';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: raw frequency data, an fiddata object. See Help / \n' ...
            'Fdident GUI / Arrows for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data,\n' ...
            '- a light green arrow means presence of secondary data overshadowed by \n' ...
            'data of the other arrow (can be made primary by selection).\n' ...
         ]);
      ShortHelp='Raw frequency data: fiddata object';
      return
   case {'l6', 'l7', 'l8'}
      Name='Output of VA';
      LongHelp=sprintf( ...
         [ ...
            'Preprocessed data: fiddata object with variance. See Help / Fdident GUI / \n' ...
            'Arrows for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Preprocessed data: fiddata object with variance';
      return
   case {'l9', 'l9'}
      Name='Output of EPM';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: identified model, an fidmodel object. See Help / \n' ...
            'Fdident GUI / Arrows for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data,\n' ...
            '- a light green arrow means presence of secondary data overshadowed by \n' ...
            'data of the other arrow (can be made primary by selection).\n' ...
         ]);
      ShortHelp='Identified model: fidmodel object';
      return
   case {'l10'}
      Name='Output of CAMS';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: identified model(s), fidmodel object or fidmodel \n' ...
            'object array. See Help / Fdident GUI / Arrows for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data,\n' ...
            '- a light green arrow means presence of secondary data overshadowed by \n' ...
            'data of the other arrow (can be made primary by selection).\n' ...
         ]);
      ShortHelp='Identified models: fidmodel object or cell array of fidmodel objects';
      return
   case {'l11'}
      Name='Output of ECPM';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: selected model, an fidmodel object. See Help / \n' ...
            'Fdident GUI / Arrows for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Selected model: fidmodel object';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'excitation_main'
   switch ObjTag
   case {'excitation_main'}
      Name='Excitation Signal Design';
      LongHelp=sprintf( ...
         [ ...
            'This is the window for the design of different periodic excitation \n' ...
            'signals. Types of signals: multisine, discrete interval binary signal \n' ...
            '(DIBS), discrete interval ternary signal (DITS), or pseudo random binary \n' ...
            'signal (PRBS or MLBS). \n' ...
            '\n' ...
            'The proper design of excitation signals is not easy. Many design \n' ...
            'parameters are interdependent (e.g. the density of the DFT grid, \n' ...
            'determined by the clock frequency and the number of samples: df=fc/N, puts \n' ...
            'an upper limit to the number of harmonics we may have in a given band). \n' ...
            'Therefore \n' ...
            '\n' ...
            '- the value of the clock frequency and the number of samples must be \n' ...
            'carefully chosen, and\n' ...
            '\n' ...
            '- there is some aid in the window to assure consistency: after setting the \n' ...
            'parameters: the buttons "Adjust freqs" or "Adjust samples" set the \n' ...
            'consistency of the design parameters. After having any of them pushed, all \n' ...
            'design parameters will be set properly.\n' ...
            '\n' ...
            'During View and Design the algorithm checks consistency and identification \n' ...
            'relevance of the parameter settings, and\n' ...
            '\n' ...
            '- either gives a warning if they are violated: then you may proceed on \n' ...
            'your own risk,\n' ...
            '\n' ...
            '- or, in more serious cases, an error message is generated: then there is \n' ...
            'no other solution than to manually change the design parameters or/and to \n' ...
            'push either of the "Adjust" buttons.\n' ...
            '\n' ...
            'For PRBS, the number of samples is determined from the given length of the \n' ...
            'shift register; for other signals, it can be explicitly set, and together \n' ...
            'with the clock frequency it determines the DFT grid.\n' ...
            '\n' ...
            'The block allows to either save the designed data through the "File / Save \n' ...
            'signal" menu, as an object (see below) or a vector, or returns output data \n' ...
            'after the Close command. The data are then available on the output arrow, \n' ...
            'either for one of the next blocks (e.g. for simulation), or by \n' ...
            'double-clicking on the arrow, and selecting "Save Arrow Data".\n' ...
            '\n' ...
            'In the resulting object (let us name it ''obj''), the basic data are as \n' ...
            'follows:\n' ...
            '  get(obj) %show all properties\n' ...
            '  obj.u %sample vector\n' ...
            '  obj.Ts %sampling time\n' ...
            '  obj.frequencies %vector of excited frequencies\n' ...
            '\n' ...
            'The Cancel command closes the block without affecting either its output or \n' ...
            'its previous setting.\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_file_save_vector'}
      Name='Save signal to vector';
      LongHelp=sprintf( ...
         [ ...
            '!@!Save the signal!@!\n' ...
            'When the signal has been designed, it can be saved through this item as a \n' ...
            'vector.\n' ...
            '\n' ...
            'The contents of the vector is the time domain samples to be downloaded \n' ...
            'into an arbitrary signal generator. The vector in the workspace usually \n' ...
            'needs to be written into an ASCII file, using the command fprintf(...) in a \n' ...
            'cycle (see an example separately).\n' ...
            '!@!Sample program: make ASCII file!@!\n' ...
            'When the samples are in a vector, e.g. ''samples'', a simple program can \n' ...
            'generate a text file for further use. Modify the enclosed commands \n' ...
            'according to your needs.\n' ...
            '\n' ...
            'Filename = ''excsig.txt''; %%name of the text file\n' ...
            'delete(filename) %%delete earlier attempt\n' ...
            'fnid=fopen(filename,''a+''); %%file identifier\n' ...
            'Amax = 511; %%maximum value allowed\n' ...
            '%%Now make integers of each sample:\n' ...
            'smod = round(Amax*signal/max(abs(signal))); \n' ...
            'for ii = 1:length(smod)\n' ...
            '   fprintf(fnid,''%%.0f\\n' ...
            ''',smod(ii))\n' ...
            'end\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_file_save_object'}
      Name='Save signal to object';
      LongHelp=sprintf( ...
         [ ...
            '!@!Save the signal!@!\n' ...
            'When the signal has been designed, it can be saved through this item as a \n' ...
            'tiddata object.\n' ...
            '\n' ...
            'The object contains every information concerning the signal. Its \n' ...
            'properties are easily available. If its name is "signal", get(signal) \n' ...
            'lists all the properties, and e.g. signal.input returns the time domain \n' ...
            'data vector of the samples, signal.Ts returns the delay between samples, \n' ...
            'etc. A complete description of the properties is available through two \n' ...
            'helper calls: help(tiddata), and help(iddat).\n' ...
            '!@!Sample program: make ASCII file!@!\n' ...
            'A simple program can generate a text file for further use. Modify the \n' ...
            'enclosed commands according to your needs.\n' ...
            '\n' ...
            'filename = ''excsig.txt''; %%name of the text file\n' ...
            'delete(filename) %%delete earlier attempt\n' ...
            'fnid=fopen(filename,''a+''); %%file identifier\n' ...
            'Amax = 511; %%maximum value allowed\n' ...
            '%%Now make integers of each sample:\n' ...
            'smod = round(Amax*signal.input/max(abs(signal.input))); \n' ...
            'for ii = 1:length(smod)\n' ...
            '   fprintf(fnid,''%%.0f\\n' ...
            ''',smod(ii))\n' ...
            'end\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'export-import'}
      Name='Saving signals';
      LongHelp=sprintf( ...
         [ ...
            '!@!Possibilities!@!\n' ...
            'The signal designed within this window can be used in two ways.\n' ...
            '\n' ...
            '1) Forward the signal to the output arrow of the block diagram\n' ...
            '\n' ...
            '2) Save the signal to the workspace of to a file.\n' ...
            '!@!Forward in the block diagram!@!\n' ...
            'The standard way is to forward the signal to the output arrow of the block \n' ...
            '"Excitation Signal Shape Design" in the main block diagram. The signal \n' ...
            'appears there after pushing the "Close" button of the window ESD. The \n' ...
            'signal can be used in the desired "Read ..." block, or saved as a tiddata \n' ...
            'object after double-clicking in the arrow.\n' ...
            '!@!Save the signal!@!\n' ...
            'Under the menu File of the window "Excitation Signal Shape Design", there \n' ...
            'is an item "Save signal". When the signal has been designed, it can be \n' ...
            'saved through this item as a vector, or as a tiddata object.\n' ...
            '\n' ...
            'The contents of the vector is the time domain samples to be downloaded \n' ...
            'into an arbitrary signal generator. The vector in the workspace usually \n' ...
            'needs to be written into an ASCII file, using the command fprintf(...) in a \n' ...
            'cycle (see an example separately).\n' ...
            '\n' ...
            'The object contains every information concerning the signal. Its \n' ...
            'properties are easily available. If its name is "signal", get(signal) \n' ...
            'lists all the properties, and e.g. signal.input returns the time domain \n' ...
            'data vector of the samples, signal.Ts returns the delay between samples, \n' ...
            'etc. A complete description of the properties is available through two \n' ...
            'helper calls: help(tiddata), and help(iddat).\n' ...
            '!@!Sample program: make ASCII file!@!\n' ...
            'When the samples are in a vector, e.g. ''samples'', a simple program can \n' ...
            'generate a text file for further use. Modify the enclosed commands \n' ...
            'according to your needs.\n' ...
            '\n' ...
            'Filename = ''excsig.txt''; %%name of the text file\n' ...
            'delete(filename) %%delete earlier attempt\n' ...
            'fnid=fopen(filename,''a+''); %%file identifier\n' ...
            'Amax = 511; %%maximum value allowed\n' ...
            '%%Now make integers of each sample:\n' ...
            'smod = round(Amax*signal/max(abs(signal))); \n' ...
            'for ii = 1:length(smod)\n' ...
            '   fprintf(fnid,''%%.0f\\n' ...
            ''',smod(ii))\n' ...
            'end\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_main_menu_file_print'}
      Name='Print';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_main_menu_file_print_ps'}
      Name='Print to PS file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to the postscript file fdidgui.ps.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_stsgrb(1)'}
      Name='Multisine';
      LongHelp=sprintf( ...
         [ ...
            'A multisine is a sum of harmonically related sinusoids. During design, its \n' ...
            'crest factor can be minimized by setting the individual phases properly. \n' ...
            'In the M-file msinclip, a signal is generated, then its peaks are clipped, \n' ...
            'an FFT is performed, the desired amplitudes are combined with the new \n' ...
            'phases, an IFFT is made, and so on. The iteration can be controlled by a \n' ...
            'pull-down menu.\n' ...
            '\n' ...
            'For details in setting the design parameters, see the Help / Help on \n' ...
            'Object applied to the buttons "Adjust freqs" and "Adjust samples".\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_startpop'}
      Name='Starting phases';
      LongHelp=sprintf( ...
         [ ...
            'Iteration for a multisine start from a set of phases. These can be set in \n' ...
            'two different ways: "Schroeder" follows the suggestion of the pioneer of \n' ...
            'multisine design, "Random" means (pseudo-)randomly generated phases each \n' ...
            'time. "Fixed" starts each time from the same state of the random \n' ...
            'generator.\n' ...
            '\n' ...
            'The design of DIBS and DITS signals also starts from random phase \n' ...
            'multisines. Selection of "Random" generates new pseudorandom numbers each \n' ...
            'time when the Design button is pushed, while "Fixed" starts from the same \n' ...
            'state of the random generator.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_starttext'}
      Name='Starting phases';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_startpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_iteredit'}
      Name='Number of iterations';
      LongHelp=sprintf( ...
         [ ...
            'Number of iterations in signal shape optimization functions\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_itertext'}
      Name='Number if iterations';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_iteredit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_stateedit'}
      Name='Initial state';
      LongHelp=sprintf( ...
         [ ...
            'Initial state of the random generator for generating starting values of \n' ...
            'the iteration. It must be an integer number.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_statetext'}
      Name='Initial state';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_stateedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_stsgrb(2)'}
      Name='DIBS';
      LongHelp=sprintf( ...
         [ ...
            'A Discrete Interval Binary Sequence is a binary signal which may change \n' ...
            'its value at discrete time instants only. The signal is designed by the \n' ...
            'M-file dibs to approximate the given spectrum. If necessary, the even \n' ...
            'harmonics (every second harmonic) can be exactly suppressed.\n' ...
            '\n' ...
            'For details in setting the design parameters, see the Help / Help on \n' ...
            'Object applied to the buttons "Adjust freqs" and "Adjust samples". \n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_stsgrb(4)'}
      Name='DITS';
      LongHelp=sprintf( ...
         [ ...
            'A Discrete Interval Three-level (Ternary) Sequence is a signal very \n' ...
            'similar to a DIBS, except it may have in excess to 2 levels: Apeak, and \n' ...
            '-Apeak also 0. It may change its value at discrete time instants only. The \n' ...
            'signal is designed to approximate the given spectrum. Every second and/or \n' ...
            'third harmonic can be exactly suppressed if the proper option under \n' ...
            '"Frequencies" is selected.\n' ...
            '\n' ...
            'For details in setting the design parameters, see the Help / Help on \n' ...
            'Object applied to the buttons "Adjust freqs" and "Adjust samples".\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_stsgrb(3)'}
      Name='PRBS';
      LongHelp=sprintf( ...
         [ ...
            'A Pseudo Random Binary Sequence (Maximum Length Binary Sequence) is a \n' ...
            'binary signal with almost white spectrum. Its length is 2^M-1 where M is \n' ...
            'an integer.\n' ...
            '\n' ...
            'When "Odd frequencies" are selected, the algorithm designs a so-called \n' ...
            'inverse repeat sequence in which all even harmonics are set to zero.\n' ...
            '\n' ...
            'For details in setting the design parameters, see the Help / Help on \n' ...
            'Object applied to the buttons "Adjust freqs" and "Adjust samples".\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_recfilttext'}
      Name='Smoothing filter';
      LongHelp=sprintf( ...
         [ ...
            'Signal samples are usually led to a digital-analog converter (DAC). Then \n' ...
            'the signal is staircase-like (ZOH). It can be applied to the device under \n' ...
            'test as it is (keeping the signal amplitude constant between the samples), \n' ...
            'or through a smoothing filter (lowpass filter), in order to make the \n' ...
            'signal continuous in amplitude, without modifying the low frequency \n' ...
            'spectral content.\n' ...
            '\n' ...
            'The application of the DAC (the zero-order hold, ZOH) slightly modifies \n' ...
            'the spectral content in both cases, therefore spectral precompensation is \n' ...
            'applied for the design to provide the desired spectral lines at the output \n' ...
            'of the DAC.\n' ...
            '\n' ...
            'For discrete intercal signals (DIBS, DITS, MLBS) the smoothing filter does \n' ...
            'not play a role in signal design, its effect is only used in the amplitude \n' ...
            'setting of the generated signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_recfiltrb(1)'}
      Name='Smoothing filter on';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_recfilttext#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_recfiltrb(2)'}
      Name='Smoothing filter off';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_recfilttext#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(16)', 'essd_uic_figrb(17)'}
      Name='Bit frequency';
      LongHelp=sprintf( ...
         [ ...
            'The frequency of the bits generated for the signal.\n' ...
            '\n' ...
            'For PRBS (or MLBS), this is the clock frequency of the feedback shift \n' ...
            'register which generates the pseudorandom sequence.\n' ...
            '\n' ...
            'The bit frequency is usually equal to the Clock frequency, that is, each \n' ...
            'bit is sent to the D/A converter just once. But this is not obligatory. If \n' ...
            ' fc > fb  (the clock frequency, see upper right, is larger than the bit \n' ...
            'frequency), the discrete interval signal is oversampled. Thus the spectrum \n' ...
            'can  be extended, e.g. an approximately lowpass spectrum can be achieved \n' ...
            'for the PRBS. If fb is not an integer fraction of fc, the spectrum is \n' ...
            'distorted.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(16)_saved'}
      Name='Bit frequency';
      LongHelp=sprintf( ...
         [ ...
            'In DIBS or DITS, this is the frequency of instants when the signal may \n' ...
            'change its value.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(18)', 'essd_uic_figrb(19)'}
      Name='log2(Np+1)';
      LongHelp=sprintf( ...
         [ ...
            'Bit length of the feedback shift register which generates the pseudorandom \n' ...
            'sequence. It determines the length of a sequence.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_agedit(21)'}
      Name='RMS';
      LongHelp=sprintf( ...
         [ ...
            'RMS value of the signal to be generated. This parameter has no effect on \n' ...
            'the design, but when exporting the signal, this will be automatically \n' ...
            'scaled to have the given RMS value. When smoothing filter is assumed, the \n' ...
            'smoothed signal will have the given RMS value.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_agtext(20)'}
      Name='RMS';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_agedit(21)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_agedit_peak(21)'}
      Name='Apeak';
      LongHelp=sprintf( ...
         [ ...
            'Peak value of the signal to be generated. This parameter has no effect on \n' ...
            'the design, but when exporting the signal, this will be automatically \n' ...
            'scaled to have the given Apeak value. When smoothing filter is assumed, \n' ...
            'the smoothed signal will have the given peak value.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_agtext_peak(20)'}
      Name='Apeak';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_agedit_peak(21)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_adjustpb'}
      Name='Adjust freqs';
      LongHelp=sprintf( ...
         [ ...
            'This button checks consistency of parameter settings in the window, and \n' ...
            'makes adjustments in freqs, fmin, fmax if necessary, to select frequencies \n' ...
            'on the DFT grid. The sample number and the generator clock frequency are \n' ...
            'kept constant.\n' ...
            '\n' ...
            'For multisine, DIBS and DITS, the calculated frequency vector is adjusted \n' ...
            'to the DFT grid set by the given parameters (clock frequency, number of \n' ...
            'samples). fmin and fmax are then approximately set, covering the DFT \n' ...
            'points selected by fmin and fmax. If necessary, freqs is set last to its \n' ...
            'true value with the given parameters.\n' ...
            '\n' ...
            'If freqs is a small number, the algorithm selects the appropriate number \n' ...
            'of harmonics on the DFT grid from the possible ones. This sometimes \n' ...
            'results in a funny set of frequencies. If you want to have the maximum \n' ...
            'possible number of frequencies in the given band, set "freqs" to a large \n' ...
            'number, and push "Adjust freqs". Then all harmonics will be selected which \n' ...
            'are allowed by the given window settings.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_adjustpbn'}
      Name='Adjust samples';
      LongHelp=sprintf( ...
         [ ...
            'For multisine, DIBS and DITS, this button checks consistency of parameter \n' ...
            'settings in the window, and makes adjustments in the clock frequency and \n' ...
            'the number of samples if necessary. In this adjustment, fmin, fmax and \n' ...
            'freqs are kept approximately constant. The aim is to assure that just one \n' ...
            'period, or an integer number of periods is generated.\n' ...
            '\n' ...
            'First the clock frequency is checked, and adjusted to 4*fmax if it is \n' ...
            'smaller than 2*fmax. Then the sample number is adjusted to assure \n' ...
            'approximately the existence of the desired number of frequencies (freqs) \n' ...
            'with the given spectrum shape (odd, special odd, etc) on the DFT grid. The \n' ...
            'frequency vector will be adjusted to the DFT grid. If necessary, freqs is \n' ...
            'set last to its true value (close to the desired one) with the given \n' ...
            'parameters.\n' ...
            '\n' ...
            'For PRBS, the bit frequency (the clock of the generating shift register) \n' ...
            'is set to an integer part of the clock frequency, then the number of \n' ...
            'samples is adjusted on the basis of the bit number to cover full sequences.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_viewpb'}
      Name='View Spectrum';
      LongHelp=sprintf( ...
         [ ...
            'Determine frequencies and amplitudes, and show shape of the desired \n' ...
            'spectrum in a plot. This spectrum is arbitrarily scaled in amplitude: the \n' ...
            'proper scaling will be determined after design, using also Apeak (see the \n' ...
            'menu item Plots / Plot spectrum).\n' ...
            'If the parameters are inconsistent, a warning or an error message is sent \n' ...
            'to the window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_designpb'}
      Name='Design';
      LongHelp=sprintf( ...
         [ ...
            'Design signal according to the design parameters set. If the parameters \n' ...
            'are inconsistent, a warning or an error message is sent to the window. \n' ...
            'Consistency of the design parameters can be assured by using the buttons \n' ...
            '"Adjust freqs" or "Adjust samples".\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(2)', 'essd_uic_figrb(5)'}
      Name='fmin';
      LongHelp=sprintf( ...
         [ ...
            'Minimum frequency contained in the signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(3)', 'essd_uic_figrb(6)'}
      Name='fmax';
      LongHelp=sprintf( ...
         [ ...
            'Maximum frequency contained in the signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_genpop'}
      Name='Type of generator';
      LongHelp=sprintf( ...
         [ ...
            'The displayed item of this menu determines the parameter values that can \n' ...
            'be set for the excitation signal. In general, these parameters are \n' ...
            'determined by the signal generator to be used. The toolbox offers here 4 \n' ...
            'built-it "generator types", and in addition, a "Generic" one which imposes \n' ...
            'no limitation on the parameter settings, only assumes the use of a DAC.\n' ...
            '\n' ...
            'The built-in "generators" correspond to the possible ways of generating an \n' ...
            'analog signal from the discrete sample sequence.\n' ...
            '\n' ...
            '"DAC"\n' ...
            'The samples are led to a DAC. The design needs inverse ZOH precompensation \n' ...
            'of the amplitudes. No overshoot is assumed between samples.\n' ...
            '\n' ...
            '"Filtered DAC"\n' ...
            'The signal is led to a DAC, then an analog lowpass filter is applied. The \n' ...
            'design needs inverse ZOH precompensation of the amplitudes. Overshoot is \n' ...
            'considered between samples, so this needs to be considered.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_genpop/advanced'}
      Name='Type of generator';
      LongHelp=sprintf( ...
         [ ...
            'The displayed item of this menu determines the parameter values that can \n' ...
            'be set for the excitation signal. In general, these parameters are \n' ...
            'determined by the signal generator to be used. The toolbox offers here 4 \n' ...
            'built-it "generator types", and in addition, a "Generic" one which imposes \n' ...
            'no limitation on the parameter settings, only assumes the use of a DAC.\n' ...
            '\n' ...
            'The built-in "generators" correspond to the possible ways of generating an \n' ...
            'analog signal from the discrete sample sequence.\n' ...
            '\n' ...
            '"DAC"\n' ...
            'The samples are led to a DAC. The design needs inverse ZOH precompensation \n' ...
            'of the amplitudes. No overshoot is assumed between samples.\n' ...
            '\n' ...
            '"Filtered DAC"\n' ...
            'The signal is led to a DAC, then an analog lowpass filter is applied. The \n' ...
            'design needs inverse ZOH precompensation of the amplitudes. Overshoot is \n' ...
            'considered between samples, so this needs to be considered.\n' ...
            '\n' ...
            '"Interpolator"\n' ...
            'The discrete samples will be interpolated by bandlimited interpolation. \n' ...
            'The design considers the maximum amplitude of the continuous-time signal. \n' ...
            'This possibility (sample interpolation) is available for multisine design \n' ...
            'only, and only for this "generator".\n' ...
            '\n' ...
            '"Discrete Seq."\n' ...
            'The signal (the discrete sequence) is designed for a discrete system. No \n' ...
            'continuous reconstruction is assumed.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_genpop_measurement'}
      Name='Type of generator';
      LongHelp=sprintf( ...
         [ ...
            'The user-defined function M-file "fdhwfun.m" may add possible items to the \n' ...
            'predefined ones - see the M-file "fdhwfsigl.m" for an example and the \n' ...
            'specifications.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_gentypetext'}
      Name='Type of generator';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_genpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_gentypetext/advanced'}
      Name='Type of generator';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_genpop/advanced#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_ssedit'}
      Name='Number of signal samples';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_cfedit'}
      Name='Clock frequency';
      LongHelp=sprintf( ...
         [ ...
            'The frequency of the generator clock (the rate of samples sent to the D/A \n' ...
            'converter). This frequency, together with the number of samples, N, \n' ...
            'determines the DFT grid (df = fc/N). The band between fmin and fmax must \n' ...
            'cover a part of this grid.\n' ...
            '\n' ...
            'The clock frequency is usually equal to the Bit frequency (the rate of \n' ...
            'bits generated, see lower left) which is also accessible for PRBS. This \n' ...
            'means that each bit is sent to the D/A converter just once. But this is \n' ...
            'not obligatory. If  fc > fb,  the discrete interval signal is oversampled. \n' ...
            'Thus the spectrum can be extended, e.g. an approximately lowpass spectrum \n' ...
            'can be achieved for the PRBS. If fb is not an integer fraction of fc, the \n' ...
            'spectrum is distorted.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(21)'}
      Name='Number of periods';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figrb(7)'}
      Name='Data for frequency lines';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_figpopup(4)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_figpopup(4)'}
      Name='Frequency lines';
      LongHelp=sprintf( ...
         [ ...
            'The number of excitation frequency lines can be given in several ways, \n' ...
            'according to the corresponding popup menu:\n' ...
            '\n' ...
            'df: average frequency distance of frequencies in Hz\n' ...
            '\n' ...
            'freqs: number of frequency lines\n' ...
            '\n' ...
            'df/fmin: frequency distance of frequencies, relative to the minimum \n' ...
            'frequency\n' ...
            '\n' ...
            'df/fmax: frequency distance of frequencies, relative to the maximum \n' ...
            'frequency\n' ...
            '\n' ...
            'df/f: relative resolution\n' ...
            '\n' ...
            'Nf/oct: number of frequency lines per octave\n' ...
            '\n' ...
            'Nf/dec: number of frequency lines per decade\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_cycledit'}
      Name='Optimization iterations';
      LongHelp=sprintf( ...
         [ ...
            'Number of iterations in the optimization for a model. This is an important \n' ...
            'parameter: if too many iterations are selected, the spectrum will have \n' ...
            'optimal shape concerning the distribution of the given power, but the \n' ...
            'crest factor minimization of a multisine will be very difficult. \n' ...
            'Therefore, at the maximum a few iterations are recommended.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_repedit'}
      Name='Repetitions';
      LongHelp=sprintf( ...
         [ ...
            'The designed signal segment will be repeated at the output "Repetitions" \n' ...
            'times. The total number of samples will be the given number of samples \n' ...
            'multiplied by the number of repetitions.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_reptext'}
      Name='Repetitions';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_repedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_expedit'}
      Name='Experiments';
      LongHelp=sprintf( ...
         [ ...
            'Multisines with random phases (or discrete interval signals derived from \n' ...
            'random phase multisines) will be designed and exported for the testing of \n' ...
            'nonlinearities. Signal optimization will not be performed, since this \n' ...
            'destroys randomness.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_exptext'}
      Name='Experiments';
      LongHelp=sprintf( ...
         [ ...
            '#essd_uic_expedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_help_save'}
      Name='Help on saving signals';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to saving signals\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_plots_on'}
      Name='Plots on';
      LongHelp=sprintf( ...
         [ ...
            'Show plots during iteration\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_plots_rare'}
      Name='Plots rare';
      LongHelp=sprintf( ...
         [ ...
            'Show only a few plots during iteration (fast execution)\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_plot_spectrum'}
      Name='Plot spectrum';
      LongHelp=sprintf( ...
         [ ...
            'Plot spectrum of designed signal. This shows the absolute values of the \n' ...
            'complex Fourier coefficients.\n' ...
         ]);
      ShortHelp='';
      return
   case {'excitation_menu_plot_signal'}
      Name='Plot signal';
      LongHelp=sprintf( ...
         [ ...
            'Plot designed signal. We design an input signal, therefore in the plot \n' ...
            'only the inputs are plotted, the outputs are empty.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(5)'}
      Name='Matlab expression';
      LongHelp=sprintf( ...
         [ ...
            'Matlab expression of frequency vector. The expression may contain fc \n' ...
            '(clock frequency) and/or df (DFT resolution). The expression will be \n' ...
            'exactly followed for multisine design, but only approximately for DIBS and \n' ...
            'DITS. In the latter cases, power may appear at the non-given frequencies, \n' ...
            'too.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(4)'}
      Name='Import...';
      LongHelp=sprintf( ...
         [ ...
            'Import frequency vector from workspace. The vector will be exactly \n' ...
            'followed for multisine design, but only approximately for DIBS and DITS. \n' ...
            'In the latter cases, power may appear at the non-given frequencies, too.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(2)'}
      Name='Odd linear';
      LongHelp=sprintf( ...
         [ ...
            'Odd frequencies: (2*i+1)*df from DFT grid\n' ...
            '\n' ...
            'For PRBS, the algorithm designs an inverse repeat sequence, which is of \n' ...
            'length 2*(2^B-1), and contains no even harmonics.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(6)'}
      Name='Odd, no third harmonics';
      LongHelp=sprintf( ...
         [ ...
            'The even and third harmonic frequencies are left out from the DFT grid.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(6)_randomized'}
      Name='Randomized odd linear';
      LongHelp=sprintf( ...
         [ ...
            'The odd frequencies, (2*i+1)*df from DFT grid, are modified in the \n' ...
            'following way: from each exclusive 3-element group of adjacent DFT lines \n' ...
            'one line is randomly left out.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(9)'}
      Name='Quasilog';
      LongHelp=sprintf( ...
         [ ...
            'Quasilogarithmically distributed frequencies from the DFT grid.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(9)_old'}
      Name='Special odd';
      LongHelp=sprintf( ...
         [ ...
            'Special selection of frequency grid, to facilitate the detection and \n' ...
            'analysis of slight nonlinearities.\n' ...
            '\n' ...
            'For multisine: [1+i*8,3+i*8]*df\n' ...
            '\n' ...
            'For DITS: no second, no third harmonics.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(3)'}
      Name='Odd quasilog';
      LongHelp=sprintf( ...
         [ ...
            'Odd, quasilogarithmically distributed frequencies from the DFT grid.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(3)_randomized'}
      Name='Randomized odd quasilog';
      LongHelp=sprintf( ...
         [ ...
            'The odd, quasilogarithmically distributed frequencies from the DFT grid, \n' ...
            'are modified in the following way: from each exclusive 3-element group of \n' ...
            'adjacent DFT lines one line is randomly left out, if all 3 lines are \n' ...
            'otherwise included in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(7)'}
      Name='All DFT frequencies';
      LongHelp=sprintf( ...
         [ ...
            'All possible DFT frequencies (determined by fs and N) will be used.\n' ...
         ]);
      ShortHelp='';
      return
   case {'essd_uic_fgrb(8)'}
      Name='Most DFT frequencies';
      LongHelp=sprintf( ...
         [ ...
            'All possible DFT frequencies (determined by fs and N) will be used, except \n' ...
            'the ones at DC and fs/2. Independently of the fact if they are present or \n' ...
            'not in the signal, these will not be used later in the identification.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'gettime_main'
   switch ObjTag
   case {'gettime_main'}
      Name='Read Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'Read in time domain data, preprocess them, and convert them to frequency \n' ...
            'domain.\n' ...
            '\n' ...
            'If the menu "UserLevel" is set to "Automatic", after loading the data into \n' ...
            'the block "Read Time Domain Data", this window automatically preprocesses \n' ...
            'them with default settings. The period length of the signal will also be \n' ...
            'automatically determined, and those frequency lines are kept which\n' ...
            '\n' ...
            '- are closest in frequency to the frequencies given in the input object if \n' ...
            'the excitation frequencies are given, or\n' ...
            '\n' ...
            '- have the input signal-to-noise ratio at least 20 dB if the excitation \n' ...
            'frequencies are not given.\n' ...
         ]);
      ShortHelp='';
      return
   case {'rect_gettdata'}
      Name='Get Data';
      LongHelp=sprintf( ...
         [ ...
            'Get time domain data: usually import from the workspace or from a file. If \n' ...
            'UserLevel is "Interactive", it can also do simulation and/or direct \n' ...
            'measurement.\n' ...
         ]);
      ShortHelp='Get time domain data';
      return
   case {'arr1'}
      Name='Output of Get data';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: raw time domain data, a tiddata object. See Help / \n' ...
            'Fdident GUI / Arrows in the main window for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Raw time domain data: tiddata object';
      return
   case {'arr12'}
      Name='Output of Get data';
      LongHelp=sprintf( ...
         [ ...
            '#arr1#\n' ...
         ]);
      ShortHelp='Raw time domain data: tiddata object';
      return
   case {'rect_segment'}
      Name='Segmentation';
      LongHelp=sprintf( ...
         [ ...
            'When a periodic waveform is analyzed, one can consider each period as an \n' ...
            'individual experiment, and average and make variance analysis across these \n' ...
            'experiments. Shorter/longer segments an also be defined. Selection of \n' ...
            'these segments is performed in this block.\n' ...
         ]);
      ShortHelp='Segment long record for variance analysis and averaging';
      return
   case {'arr2'}
      Name='Output of Segmentation';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: segmented data, a tiddata object. See Help / \n' ...
            'Fdident GUI / Arrows in the main window for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Segmented data: tiddata object';
      return
   case {'rect_convert'}
      Name='Conversion to frequency domain';
      LongHelp=sprintf( ...
         [ ...
            'Each  experiment is transformed to frequency domain, and excited \n' ...
            'frequencies are selected for further processing\n' ...
         ]);
      ShortHelp='Convert data to frequency domain';
      return
   case {'arr3'}
      Name='Output of Conv. To Freq.';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: converted data, an fiddata object. See Help / \n' ...
            'Fdident GUI / Arrows in the main window for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Converted data: fiddata object';
      return
   case {'rect_freqsel'}
      Name='Frequency selection';
      LongHelp=sprintf( ...
         [ ...
            'Frequencies can be selected for use where the transfer functions or the \n' ...
            'input and output amplitudes are large enough.\n' ...
         ]);
      ShortHelp='Select desired frequencies for better identification';
      return
   case {'arr4'}
      Name='Output of Freq. Sel.';
      LongHelp=sprintf( ...
         [ ...
            'Contents of the arrow: selected data, an fiddata object. See Help / \n' ...
            'Fdident GUI / Arrows in the main window for more details.\n' ...
            '\n' ...
            'The arrow can be opened in any state by double-click (or right button \n' ...
            'click), but the commands Save/Plot/Activate are only accessible if data \n' ...
            'are present.\n' ...
            '\n' ...
            'Meaning of colors:\n' ...
            '\n' ...
            '- gray means an inactive arrow,\n' ...
            '- green means that data are already present,\n' ...
            '- dark green marks an arrow with directly loaded data.\n' ...
         ]);
      ShortHelp='Selected data: fiddata object';
      return
   case {'gettime_check_memory'}
      Name='Save memory';
      LongHelp=sprintf( ...
         [ ...
            'The GUI stores each intermediate result in the corresponding green arrow. \n' ...
            'This may consume quite a lot of memory for large time domain objects. When \n' ...
            'the checkbox "Save memory" is checked, the data which are not any more in \n' ...
            'use are cleared after each step of the process in the "Get Time Domain \n' ...
            'Data" window. By this, memory consumption can be reduced.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_auto_convert'}
      Name='Autoconvert';
      LongHelp=sprintf( ...
         [ ...
            'Perform automatic Fourier and variance analysis. In this state the toolbox \n' ...
            'automatically determines the period length of the input signal, calculates \n' ...
            'the Fourier coefficients and their variances, and keeps those frequency \n' ...
            'lines, which\n' ...
            '\n' ...
            '- are closest in frequency to the frequencies given in the input object if \n' ...
            'the excitation frequencies are given, or\n' ...
            '\n' ...
            '- have the input signal-to-noise ratio at least 20 dB if the excitation \n' ...
            'frequencies are not given.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_zoh_compensatezoh'}
      Name='ZOH compensation';
      LongHelp=sprintf( ...
         [ ...
            'When the system is excited through a DAC (ZOH), and the input signal is \n' ...
            'given as a series of the samples led to the DAC, the "natural" choice is \n' ...
            'to identify a z-domain model. Namely, ZOH data are prefect for this \n' ...
            'purpose.\n' ...
            '\n' ...
            'However, if an s-domain model is sought, we better compensate for the \n' ...
            'half-sample delay and the amplitude distortion of the ZOH. This way, we \n' ...
            'can simulate the results of a band-limited measurement, at least if there \n' ...
            'is not too much aliasing at the measurement of the output signal. This \n' ...
            'compensation can be automatically done with the GUI, by switching on this \n' ...
            'option.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_zoh_compensatebl'}
      Name='ZOH compensation';
      LongHelp=sprintf( ...
         [ ...
            'When bandlimited measurement of the input is available, the "natural" \n' ...
            'choice is to identify an s-domain model. Bandlimited data are prefect for \n' ...
            'this purpose.\n' ...
            '\n' ...
            'However, if a z-domain model is sought, we better "simulate" the \n' ...
            'half-sample delay and the amplitude distortion of the ZOH. This way, we \n' ...
            'obtain "ZOH" data. This compensation can be automatically done with the \n' ...
            'GUI, by switching on this option. The bandlimited measurement of the \n' ...
            'output eliminates overlapping by straight sampling. We cannot compensate \n' ...
            'for this - the model will incorporate an additional lowpass (bandlimiting) \n' ...
            'filter.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_zoh_compensatefoh'}
      Name='ZOH compensation';
      LongHelp=sprintf( ...
         [ ...
            'When the system is excited through a first order hold (FOH), and the input \n' ...
            'is given as a series of the samples led to it, without pretreatment the \n' ...
            'data are not proper for identification \n' ...
            '\n' ...
            'If an s-domain model is sought, we better compensate for the delay and the \n' ...
            'amplitude distortion of the FOH. This way, we can simulate the results of \n' ...
            'a band-limited measurement, at least if there is not too much aliasing at \n' ...
            'the measurement of the output signal. This compensation can be \n' ...
            'automatically done with the GUI, by switching on this option.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_button_cancel'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            'Close the window without saving data or window settings\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_button_done'}
      Name='Autofinish/Close';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'frame_status'}
      Name='Information frame';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_main_ax'}
      Name='Axes';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_menu_file'}
      Name='File';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettime_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'gettdatafig'
   switch ObjTag
   case {'gettdatafig'}
      Name='Read Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'Read in time domain data.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_import'}
      Name='Import';
      LongHelp=sprintf( ...
         [ ...
            'Import time domain data from the workspace or from a file. The data may be \n' ...
            'a tiddata object (see help tiddata), or iddata (see System Identification \n' ...
            'Toolbox, Version 5.x). For more details, see "Help / Export/import data" \n' ...
            'in the main window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_compose'}
      Name='Compose';
      LongHelp=sprintf( ...
         [ ...
            'Compose tiddata object from workspace variables, given strings, and/or \n' ...
            'from variables in binary file(s), using a question/answer window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_simulation'}
      Name='Simulate';
      LongHelp=sprintf( ...
         [ ...
            'Generate simulated data using the settings in the opening Simulation \n' ...
            'window.\n' ...
            '\n' ...
            'Enabled only when "UserLevel" is "Interactive" or higher.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_measurement'}
      Name='Measure';
      LongHelp=sprintf( ...
         [ ...
            'Measure data using the settings in the Measurement window.\n' ...
            '\n' ...
            'Enabled only when "UserLevel" is "Interactive" or higher.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the GUI with a set of topics.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Explain how the window works.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_menu_help_object'}
      Name='Help on Object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_compinput_time_main'
   switch ObjTag
   case {'fdtool_compinput_time_main'}
      Name='Import Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            '!@!Introduction to Object Composition with GUI!@!\n' ...
            'Compose a tiddata object from workspace variables, given strings, and/or \n' ...
            'from variables in binary file(s), using a question/answer window.\n' ...
            '\n' ...
            'Properties can be set with edit boxes or with popup menus. Edit boxes are \n' ...
            'described in a separate topic, the use of the latter is straightforward.\n' ...
            '\n' ...
            'Obligatory properties are given in red color, recommended (but not \n' ...
            'obligatory) ones in green .\n' ...
            '\n' ...
            'The Compose button executes the object creation, without creating an \n' ...
            'output. If some obligatory fields are not filled in, they flash in red. \n' ...
            'When everything is OK, the Done button saves the object. The menu item \n' ...
            '"File" / "Save object" allow manual saving.\n' ...
            '!@!Edit boxes!@!\n' ...
            'Edit boxes may contain MATLAB code executable in the main workspace, using \n' ...
            'the variables defined there. Examples:\n' ...
            'var1(:,2)\n' ...
            '[1;2;3]\n' ...
            '''Voltage''\n' ...
            'date\n' ...
            '\n' ...
            'An exception is the field "Notes" which is just a text without quotation \n' ...
            'marks.\n' ...
            '\n' ...
            'An additional possibility is to define the contents of an edit box on the \n' ...
            'basis of a file. To read about this, please select the relevant topic.\n' ...
            '!@!Referring to files!@!\n' ...
            'A file reference can be given in the edit boxes between < > marks, e.g.\n' ...
            '<data.mat>\n' ...
            '<c:\\temp\\data.mat>\n' ...
            '<data.txt>\n' ...
            '\n' ...
            'The "Browse..." buttons do this with the help of the GUI.\n' ...
            '\n' ...
            'For MAT-files, in addition a variable name can be written after the file \n' ...
            'name, separated by a colon:\n' ...
            '<c:\\temp\\data.mat>:freqs\n' ...
            'When there is only one variable in the file, the variable name is not \n' ...
            'needed.\n' ...
            '\n' ...
            'For ASCII files, the load command will be executed on the named ASCII \n' ...
            'file. The result needs to be a MATLAB column vector or an array. Example:\n' ...
            '<data.txt>\n' ...
            '\n' ...
            'A subscript can be added to the above described contents of the edit box, \n' ...
            'similarly as to regular MATLAB variables. Examples:\n' ...
            '<data.mat>:freqs(1:20)\n' ...
            '<c:\\temp\\data.txt>(1:8,2)\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_synch'}
      Name='Synchronization';
      LongHelp=sprintf( ...
         [ ...
            'When multiple experiments have been done, averaging of results is only \n' ...
            'possible without extra manipulation when the experiments are synchronized \n' ...
            'with respect to the excitation signal. Synchronization ''on'' marks this \n' ...
            'case. \n' ...
            '''samepower'' means that random phase multisines were used, same power, \n' ...
            'but differing phases. \n' ...
            'Synchronization ''off'' refers to any other case (even to non-periodic \n' ...
            'excitation, if it is non-periodic).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_synch'}
      Name='Synchronization';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Synch#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_state'}
      Name='State (steady or transient)';
      LongHelp=sprintf( ...
         [ ...
            'When the excitation is periodic, the measurements are either is \n' ...
            'steady-state, or in transient state. Processing is different, so proper \n' ...
            'description of the measurements is important.\n' ...
            '\n' ...
            'For non-periodic excitation, the state is always transient.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_state'}
      Name='State (steady or transient)';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_State#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_character_inp'}
      Name='InputCharacter';
      LongHelp=sprintf( ...
         [ ...
            'Signals are represented with samples. Therefore, correct description of \n' ...
            'the measurement setup includes the intersample behavior of the \n' ...
            'continuous-time signal. The two main cases are:\n' ...
            '\n' ...
            '"BL" (signal measured and sampled using an anti-alias filter), and\n' ...
            '\n' ...
            '"ZOH" (zero-order hold, the analog signal generated from the samples by \n' ...
            'using a DAC, a kind of ZOH).\n' ...
            '\n' ...
            'There are two, more rarely used options for input signals:\n' ...
            '\n' ...
            '"samples" (signal sampled without the inclusion of any anti-alias filter - \n' ...
            'this is theoretically not proper), and\n' ...
            '\n' ...
            '"discrete" means simulated discrete sequence, with no intersample behavior \n' ...
            'defined.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_character_out'}
      Name='OutputCharacter';
      LongHelp=sprintf( ...
         [ ...
            'Signals are represented with samples. Therefore, correct description of \n' ...
            'the measurement setup includes the intersample behavior of the \n' ...
            'continuous-time signal. The two main cases are:\n' ...
            '\n' ...
            '"BL" (signal measured and sampled using an anti-alias filter), and\n' ...
            '\n' ...
            '"samples" (signal sampled without the inclusion of any anti-alias filter - \n' ...
            'this corresponds to the "ZOH" setting, with character "ZOH" at the \n' ...
            'input).\n' ...
            '\n' ...
            'There is a third, more rarely used option:\n' ...
            '\n' ...
            '"discrete" means simulated discrete sequence, with no intersample behavior \n' ...
            'defined.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_character'}
      Name='Character';
      LongHelp=sprintf( ...
         [ ...
            'Signals are represented with samples. Therefore, we need to describe the \n' ...
            'intersample behavior (characters of channels).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_notes'}
      Name='Notes';
      LongHelp=sprintf( ...
         [ ...
            'Textual information you want to be stored along with the object.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_notes'}
      Name='Notes';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Notes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_date'}
      Name='Date';
      LongHelp=sprintf( ...
         [ ...
            'Date of construction of the object, or date of measurement.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_date'}
      Name='Date';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Date#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_name_inp'}
      Name='InputName';
      LongHelp=sprintf( ...
         [ ...
            'Name of the input channel, for physical identification (Voltage, Force, \n' ...
            'Acceleration, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_name_out'}
      Name='OutputName';
      LongHelp=sprintf( ...
         [ ...
            'Name of the output channel, for physical identification (Voltage, Force, \n' ...
            'Acceleration, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_name'}
      Name='Name';
      LongHelp=sprintf( ...
         [ ...
            'Names of the output and input channels, for physical identification \n' ...
            '(Voltage, Force, Acceleration, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_unit_inp'}
      Name='InputUnit';
      LongHelp=sprintf( ...
         [ ...
            'Unit of the input channel samples, to allow physical scaling (Volt, m/s^2, \n' ...
            'etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_unit_out'}
      Name='OutputUnit';
      LongHelp=sprintf( ...
         [ ...
            'Unit of the output channel samples, to allow physical scaling (Volt, \n' ...
            'm/s^2, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_unit'}
      Name='Unit';
      LongHelp=sprintf( ...
         [ ...
            'Units of the output and input channel samples, to allow physical scaling \n' ...
            '(Volt, m/s^2, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_output'}
      Name='Output';
      LongHelp=sprintf( ...
         [ ...
            'Header of output-related properties.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_input'}
      Name='Input';
      LongHelp=sprintf( ...
         [ ...
            'Header of input-related properties.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_inp'}
      Name='InputData';
      LongHelp=sprintf( ...
         [ ...
            'Input channel samples. Column vector for one experiment, (1 x expno)-size \n' ...
            'cell array of equal-size column vectors for multiple experiments.\n' ...
            '\n' ...
            'If several experiments are given in the form of a numerical array, like \n' ...
            '(samplenumber x expno), the simplest conversion to a cell array is \n' ...
            'u=num2cell(uarr,1);\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_out'}
      Name='OutputData';
      LongHelp=sprintf( ...
         [ ...
            'Output channel samples. Column vector for one experiment, (1 x expno)-size \n' ...
            'cell array of equal-size column vectors for multiple experiments.\n' ...
            '\n' ...
            'If several experiments are given in the form of a numerical array, like \n' ...
            '(samplenumber x expno), the simplest conversion to a cell array is \n' ...
            'y=num2cell(yarr,1);\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_data_ref'}
      Name='Browse for Reference Data';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_excitfreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_ref'}
      Name='Reference Data';
      LongHelp=sprintf( ...
         [ ...
            'Reference data. Used for synchronization of complex amplitudes generated \n' ...
            'from random phase multisines.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_ref'}
      Name='Reference Data';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_data_ref#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_data'}
      Name='Data';
      LongHelp=sprintf( ...
         [ ...
            'Output and input channel samples.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_done'}
      Name='Done';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_cancel'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            'Close the window without saving data or window settings\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_clear'}
      Name='Clear';
      LongHelp=sprintf( ...
         [ ...
            'Reset settings of window to initial state.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_compose'}
      Name='Compose';
      LongHelp=sprintf( ...
         [ ...
            'Check settings of window: try to generate object, but do not save it.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_data_inp'}
      Name='Browse for InputData';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_excitfreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_data_out'}
      Name='Browse for OutputData';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_excitfreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_object'}
      Name='Help on Object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_this'}
      Name='Help on This Window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_fdid'}
      Name='Help on Fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the GUI with a set of topics.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_demo'}
      Name='Demo on Use';
      LongHelp=sprintf( ...
         [ ...
            'This demonstration illustrates the main possibilities of the window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_file_cancel'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_pb_cancel#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_file_done'}
      Name='Done';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_pb_done#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_file_save_object'}
      Name='Save object to workspace';
      LongHelp=sprintf( ...
         [ ...
            'Save composed object to a variable in the main workspace.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_excitfreq'}
      Name='Browse for Excitation Frequencies';
      LongHelp=sprintf( ...
         [ ...
            'Allow to browse binary (MAT) files and ASCII files to load data from them. \n' ...
            'The "Browse" command writes the reference to the file into the edit box \n' ...
            'beside.\n' ...
            '\n' ...
            'For MAT-files, in addition a variable name can be written after the file \n' ...
            'name, separated by a colon:\n' ...
            '<c:\\temp\\data.mat>:freqs\n' ...
            'When there is only one variable in the file, the variable name is not \n' ...
            'needed.\n' ...
            '\n' ...
            'For ASCII files, only the file name needs to be in the edit box, and the \n' ...
            'load command will be executed on this file. The result needs to be a \n' ...
            'MATLAB column vector. Example:\n' ...
            '<data.txt>\n' ...
            '\n' ...
            'A subscript can be added to the above described contents of the edit box, \n' ...
            'similarly as to regular MATLAB variables. Examples:\n' ...
            '<data.mat>:freqs(1:20)\n' ...
            '<c:\\temp\\data.txt>(1:8,2)\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_excitfreq'}
      Name='Excitation Frequencies';
      LongHelp=sprintf( ...
         [ ...
            'Column vector of excited frequencies in the periodic input signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_excitfreq'}
      Name='Excitation Frequencies';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_ExcitFreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_ts'}
      Name='Sampling time interval';
      LongHelp=sprintf( ...
         [ ...
            'Sampling interval: distance of sampling instants.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_ts'}
      Name='Sampling time interval';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Ts#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_periodlength'}
      Name='PeriodLength';
      LongHelp=sprintf( ...
         [ ...
            'Period length of the excitation signal. This usually can be determined \n' ...
            'from the frequency contents, but it is more reliable to have it explicitly \n' ...
            'given.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_periodlength'}
      Name='PeriodLength';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_periodlength#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_tstart_inp'}
      Name='InputTstart';
      LongHelp=sprintf( ...
         [ ...
            'First sampling instant of the input signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_tstart_inp'}
      Name='InputTstart';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Tstart_inp#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_tstart_out'}
      Name='OutputTstart';
      LongHelp=sprintf( ...
         [ ...
            'First sampling instant of the output signal.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'getfreq_main'
   switch ObjTag
   case {'getfreq_main'}
      Name='Read Frequency Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'Read in frequency domain data. \n' ...
         ]);
      ShortHelp='';
      return
   case {'getfreq_main_measurement'}
      Name='Read Frequency Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'If "UserLevel" is Interactive or higher, it can do also simulation and/or \n' ...
            'direct measurement.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_axes_uaxes'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_axes_laxes'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_frffxfypop'}
      Name='Type of Plot';
      LongHelp=sprintf( ...
         [ ...
            'Two different types of plots can be chosen.\n' ...
            '\n' ...
            '"frf": Frequency Response Function, that is, the nonparametric transfer \n' ...
            'function estimate.\n' ...
            '\n' ...
            '"output-input": The output and input Fourier amplitudes are shown in two \n' ...
            'separate subplots.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_importpb'}
      Name='Import';
      LongHelp=sprintf( ...
         [ ...
            '!@!Import data!@!\n' ...
            'Read fiddata object from workspace, or from file.\n' ...
            '\n' ...
            'The reading procedure checks the type of the data: they must be "fiddata" \n' ...
            'objects. Such objects can be created by the function "fiddata" from your \n' ...
            'own vectors - see "Help / Getting Started... / Using Freq. Domain Data", and \n' ...
            'the corresponding function helps for details. The objects allow the use of \n' ...
            'the "get" and "set" functions: e.g. get(dat). In frequency domain, don''t \n' ...
            'forget to fill in the "Synchronization" property, e.g. \n' ...
            '\n' ...
            '     data.synchronization=''on'';\n' ...
            '\n' ...
            'otherwise unnecessarily long processing time may be necessary later, \n' ...
            'during the execution of the "Variance Analysis" block. If data of more \n' ...
            'than one experiments are used, and measurements are properly synchronized, \n' ...
            'also set the property "synchronization".\n' ...
            '\n' ...
            '!@!Sample program for preparing load!@!\n' ...
            'Let us assume that we have measured five times the input and output \n' ...
            'amplitudes at 25 frequencies. The data are stored in the 25 x 5 arrays inp \n' ...
            'and outp. The frequency vector is freqv.\n' ...
            '\n' ...
            '%%First prepare the data in 1 x 5 cell arrays:\n' ...
            'U = num2cell(inp,1); Y = num2cell(outp,1);\n' ...
            '%%Now make the object:\n' ...
            'obj = fiddata(Y,U,freqv);\n' ...
            '%%Set some properties:\n' ...
            'obj.periodlength = 1/160;\n' ...
            'obj.synchronization=''on'';\n' ...
            'get(obj) %%check properties\n' ...
            '\n' ...
            'Now the variable obj can be imported to this block.\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_composepb'}
      Name='Compose';
      LongHelp=sprintf( ...
         [ ...
            'Compose fiddata object from workspace variables, given strings, and/or \n' ...
            'from variables in binary file(s), using a question/answer window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_simulatepb'}
      Name='Simulate';
      LongHelp=sprintf( ...
         [ ...
            'Generate simulated frequency domain data using the settings in the opening \n' ...
            'Simulation window.\n' ...
            '\n' ...
            'Enabled only when "UserLevel" is "Interactive" or higher.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_measurepb'}
      Name='Measure';
      LongHelp=sprintf( ...
         [ ...
            'Measure frequency domain data using the settings in the Measurement \n' ...
            'window.\n' ...
            '\n' ...
            'Enabled only when "UserLevel" is "Interactive" or higher.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_varonoffpop'}
      Name='Variance on/off in plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_linloghpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_freqselpb'}
      Name='Frequency Selection';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'getfreq_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'getfreq_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'getfreq_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'getfreq_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'getfreq_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_dataframe'}
      Name='Frame with data info';
      LongHelp=sprintf( ...
         [ ...
            'Frame which contains all information fields about the current data object\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_datatext'}
      Name='Frame with data info';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_dataframe\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(1)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            'Field for information about the current data object\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(2)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(3)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(4)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(5)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(6)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(7)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(8)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(9)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   case {'gfdd_uic_infotext(10)'}
      Name='Information field';
      LongHelp=sprintf( ...
         [ ...
            '#gfdd_uic_infotext(1)#\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_guimchsel'
   switch ObjTag
   case {'fdtool_guimchsel'}
      Name='Select Channels';
      LongHelp=sprintf( ...
         [ ...
            'Select more than one channels for input or output\n' ...
         ]);
      ShortHelp='';
      return
   case {'help_pb'}
      Name='Help';
      LongHelp=sprintf( ...
         [ ...
            'Access on-line help\n' ...
         ]);
      ShortHelp='';
      return
   case {'cancel_pb'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            'Change your mind, leave earlier selection untouched.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ok_pb'}
      Name='OK';
      LongHelp=sprintf( ...
         [ ...
            'Accept selection.\n' ...
         ]);
      ShortHelp='';
      return
   case {'list'}
      Name='List of channels';
      LongHelp=sprintf( ...
         [ ...
            'List all channels which can be selected. This list can be used for \n' ...
            'selection (use Ctrl button + select)\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_compinput_freq_main'
   switch ObjTag
   case {'fdtool_compinput_freq_main'}
      Name='Compose Frequency Domain Data';
      LongHelp=sprintf( ...
         [ ...
            '!@!Introduction to Object Composition with GUI!@!\n' ...
            'Compose an fiddata object from workspace variables, given strings, and/or \n' ...
            'from variables in binary file(s), using a question/answer window.\n' ...
            '\n' ...
            'Properties can be set with edit boxes or with popup menus. Edit boxes are \n' ...
            'described in a separate topic, the use of the latter is straightforward.\n' ...
            '\n' ...
            'Obligatory properties are given in red color, recommended (but not \n' ...
            'obligatory) ones in green .\n' ...
            '\n' ...
            'The Compose button executes the object creation, without creating an \n' ...
            'output. If some obligatory fields are not filled in, they flash in red. \n' ...
            'When everything is OK, the Done button saves the object. The menu item \n' ...
            '"File" / "Save object" allow manual saving.\n' ...
            '!@!Data types!@!\n' ...
            'The window allows to import 3 different data types. These can be selected \n' ...
            'using the "Data type" menu.\n' ...
            '\n' ...
            '1) Input/Output data: complex amplitudes in separate column vectors\n' ...
            '2) FRF data, dB/degrees: the data come from a network analyzer, and the \n' ...
            'two available vectors are the gains (magnitudes) in decibels, and the \n' ...
            'phases in degrees\n' ...
            '3) Complex FRF data: column vector of the complex FRF values.\n' ...
            '\n' ...
            'The data can also be cell row vectors with column vectors as elements, or \n' ...
            'arrays with column vectors which are data belonging to different \n' ...
            'experiments.\n' ...
            '\n' ...
            'In each case, the frequency vector must also be provided in the form of a \n' ...
            'variable or a Matlab expression, in Hz.\n' ...
            '!@!Edit boxes!@!\n' ...
            'Edit boxes may contain MATLAB code executable in the main workspace, using \n' ...
            'the variables defined there. Examples:\n' ...
            'var1(:,2)\n' ...
            '[1;2;3]\n' ...
            '''Voltage''\n' ...
            'date\n' ...
            '\n' ...
            'An exception is the field "Notes" which is just a text without quotation \n' ...
            'marks.\n' ...
            '\n' ...
            'An additional possibility is to define the contents of an edit box on the \n' ...
            'basis of a file. To read about this, please select the relevant topic.\n' ...
            '!@!Referring to files!@!\n' ...
            'A file reference can be given in the edit boxes between < > marks, e.g.\n' ...
            '<data.mat>\n' ...
            '<c:\\temp\\data.mat>\n' ...
            '<data.txt>\n' ...
            '\n' ...
            'The "Browse..." buttons do this with the help of the GUI.\n' ...
            '\n' ...
            'For MAT-files, in addition a variable name can be written after the file \n' ...
            'name, separated by a colon:\n' ...
            '<c:\\temp\\data.mat>:freqs\n' ...
            'When there is only one variable in the file, the variable name is not \n' ...
            'needed.\n' ...
            '\n' ...
            'For ASCII files, the load command will be executed on the named ASCII \n' ...
            'file. The result needs to be a MATLAB column vector or an array. Example:\n' ...
            '<data.txt>\n' ...
            'From ASCII files only real data can be imported. Complex data (input and \n' ...
            'output) need to be assembled in the workspace, then they can be imported \n' ...
            'from there.\n' ...
            '\n' ...
            'A subscript can be added to the above described contents of the edit box, \n' ...
            'similarly as to regular MATLAB variables. Examples:\n' ...
            '<data.mat>:freqs(1:20)\n' ...
            '<c:\\temp\\data.txt>(1:8,2)\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_synch'}
      Name='Synchronization';
      LongHelp=sprintf( ...
         [ ...
            'When multiple experiments have been done, averaging of results is only \n' ...
            'possible without extra manipulation when the experiments are synchronized \n' ...
            'with respect to the excitation signal. Synchronization on marks this case. \n' ...
            'Synchronization off refers to any other case (even to non-periodic \n' ...
            'excitation, if it is non-periodic).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_synch'}
      Name='Synchronization';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Synch#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_state'}
      Name='State (steady or transient)';
      LongHelp=sprintf( ...
         [ ...
            'When the excitation is periodic, the measurements are either is \n' ...
            'steady-state, or in transient state. Processing is different, so proper \n' ...
            'description of the measurements is important.\n' ...
            '\n' ...
            'For non-periodic excitation, the state is always transient.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_state'}
      Name='State (steady or transient)';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_State#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_character_inp'}
      Name='InputCharacter';
      LongHelp=sprintf( ...
         [ ...
            'Signals are represented with samples. Therefore, we need to describe the \n' ...
            'intersample behavior. The two main cases are "BL" (measured using an \n' ...
            'anti-alias filter), and "ZOH" (zero-order hold, the analog signal \n' ...
            'generated from the samples by using a DAC, a kind of ZOH).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_character_out'}
      Name='OutputCharacter';
      LongHelp=sprintf( ...
         [ ...
            'Signals are represented with samples. Therefore, we need to describe the \n' ...
            'intersample behavior. The two main cases are "BL" (measured using an \n' ...
            'anti-alias filter), and "Samples" (measured NOT using an anti-alias \n' ...
            'filter).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_character'}
      Name='Character';
      LongHelp=sprintf( ...
         [ ...
            'Signals are represented with samples. Therefore, we need to describe the \n' ...
            'intersample behavior (characters of channels).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_notes'}
      Name='Notes';
      LongHelp=sprintf( ...
         [ ...
            'Textual information you want to be stored along with the object.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_notes'}
      Name='Notes';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Notes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_date'}
      Name='Date';
      LongHelp=sprintf( ...
         [ ...
            'Date of construction of the object, or date of measurement.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_date'}
      Name='Date';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_Date#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_name_inp'}
      Name='InputName';
      LongHelp=sprintf( ...
         [ ...
            'Name of the input channel, for physical identification (Voltage, Force, \n' ...
            'Acceleration, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_name_out'}
      Name='OutputName';
      LongHelp=sprintf( ...
         [ ...
            'Name of the output channel, for physical identification (Voltage, Force, \n' ...
            'Acceleration, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_name'}
      Name='Name';
      LongHelp=sprintf( ...
         [ ...
            'Names of the output and input channels, for physical identification \n' ...
            '(Voltage, Force, Acceleration, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_unit_inp'}
      Name='InputUnit';
      LongHelp=sprintf( ...
         [ ...
            'Unit of the input channel samples, to allow physical scaling (Volt, m/s^2, \n' ...
            'etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_unit_out'}
      Name='OutputUnit';
      LongHelp=sprintf( ...
         [ ...
            'Unit of the output channel samples, to allow physical scaling (Volt, \n' ...
            'm/s^2, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_unit'}
      Name='Unit';
      LongHelp=sprintf( ...
         [ ...
            'Units of the output and input channel samples, to allow physical scaling \n' ...
            '(Volt, m/s^2, etc.).\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_output'}
      Name='Output';
      LongHelp=sprintf( ...
         [ ...
            'Header of output-related properties.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_input'}
      Name='Input';
      LongHelp=sprintf( ...
         [ ...
            'Header of input-related properties.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_inp'}
      Name='InputData';
      LongHelp=sprintf( ...
         [ ...
            'Input channel data. Column vector for one experiment, (1 x expno)-size \n' ...
            'cell array of equal-size column vectors for multiple experiments.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_out'}
      Name='OutputData';
      LongHelp=sprintf( ...
         [ ...
            'Output channel data. Column vector for one experiment, (1 x expno)-size \n' ...
            'cell array of equal-size column vectors for multiple experiments.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_out_gain'}
      Name='Gain vector';
      LongHelp=sprintf( ...
         [ ...
            'Gain vector given in decibels. Column vector for one experiment, (1 x \n' ...
            'expno)-size cell array of equal-size column vectors for multiple \n' ...
            'experiments.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_out_phase'}
      Name='Phase vector';
      LongHelp=sprintf( ...
         [ ...
            'Phase vector given in degrees. Column vector for one experiment, (1 x \n' ...
            'expno)-size cell array of equal-size column vectors for multiple \n' ...
            'experiments.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_data'}
      Name='Data';
      LongHelp=sprintf( ...
         [ ...
            'Output and input channel data.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_data_ref'}
      Name='Browse for Reference Data';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_excitfreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_data_ref'}
      Name='Reference Data';
      LongHelp=sprintf( ...
         [ ...
            'Reference data. Used for synchronization of complex amplitudes generated \n' ...
            'from random phase multisines.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_ref'}
      Name='Reference Data';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_data_ref#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_done'}
      Name='Done';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_cancel'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            'Close the window without saving data or window settings\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_clear'}
      Name='Clear';
      LongHelp=sprintf( ...
         [ ...
            'Reset settings of window to initial state.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_pb_compose'}
      Name='Compose';
      LongHelp=sprintf( ...
         [ ...
            'Check settings of window: try to generate object, but do not save it.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_data_inp'}
      Name='Browse for InputData';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_excitfreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_data_out'}
      Name='Browse for OutputData';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_excitfreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_object'}
      Name='Help on Object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_this'}
      Name='Help on This Window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_fdid'}
      Name='Help on Fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the GUI with a set of topics.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_help_demo'}
      Name='Demo on Use';
      LongHelp=sprintf( ...
         [ ...
            'This demonstration illustrates the main possibilities of the window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_file_cancel'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_pb_cancel#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_file_done'}
      Name='Done';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_pb_done#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_file_save_object'}
      Name='Save object to workspace';
      LongHelp=sprintf( ...
         [ ...
            'Save composed object to a variable in the main workspace.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_excitfreq'}
      Name='Browse for Excitation Frequencies';
      LongHelp=sprintf( ...
         [ ...
            'Allow to browse binary (MAT) files and ASCII files to load data from them. \n' ...
            'The "Browse" command writes the reference to the file into the edit box \n' ...
            'beside.\n' ...
            '\n' ...
            'For MAT-files, in addition a variable name can be written after the file \n' ...
            'name, separated by a colon:\n' ...
            '<c:\\temp\\data.mat>:freqs\n' ...
            'When there is only one variable in the file, the variable name is not \n' ...
            'needed.\n' ...
            '\n' ...
            'For ASCII files, only the file name needs to be in the edit box, and the \n' ...
            'load command will be executed on this file. The result needs to be a \n' ...
            'MATLAB column vector. Example:\n' ...
            '<data.txt>\n' ...
            '\n' ...
            'A subscript can be added to the above described contents of the edit box, \n' ...
            'similarly as to regular MATLAB variables. Examples:\n' ...
            '<data.mat>:freqs(1:20)\n' ...
            '<c:\\temp\\data.txt>(1:8,2)\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_excitfreq'}
      Name='Excitation Frequencies';
      LongHelp=sprintf( ...
         [ ...
            'Column vector of excited frequencies in the periodic input signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_excitfreq'}
      Name='Excitation Frequencies';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_ExcitFreq#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_freqpoints'}
      Name='Browse for Frequency Points';
      LongHelp=sprintf( ...
         [ ...
            'Allow to browse binary (MAT) files and ASCII files to load data from them. \n' ...
            'The "Browse" command writes the reference to the file into the edit box \n' ...
            'beside.\n' ...
            '\n' ...
            'For MAT-files, in addition a variable name can be written after the file \n' ...
            'name, separated by a colon:\n' ...
            '<c:\\temp\\data.mat>:freqs\n' ...
            'When there is only one variable in the file, the variable name is not \n' ...
            'needed.\n' ...
            '\n' ...
            'For ASCII files, the full name of the file needs to be in the edit box \n' ...
            '(Browse can be used), and the load command will be executed on this file. \n' ...
            'The result needs to be a MATLAB column vector. Example:\n' ...
            '<c:\\temp\\data.txt>\n' ...
            '\n' ...
            'A subscript can be added manually to the above described file reference \n' ...
            'contents of the edit box, similarly as to regular MATLAB variables. \n' ...
            'Examples:\n' ...
            '<c:\\temp\\data.mat>:freqs(1:20)\n' ...
            '<c:\\temp\\data.txt>(1:8,2)\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_freqpoints'}
      Name='Frequency Points';
      LongHelp=sprintf( ...
         [ ...
            'Column vector of frequencies.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_freqpoints'}
      Name='Frequency Points';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_freqpoints#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_coherence'}
      Name='Coherence';
      LongHelp=sprintf( ...
         [ ...
            'Column vector of coherences between complex input and output amplitudes.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_coherence'}
      Name='Coherence';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_coherence#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_covariance'}
      Name='Covariance';
      LongHelp=sprintf( ...
         [ ...
            'Column vector of covariances between complex input and output amplitudes: \n' ...
            'E{conj(Um)*Ym}.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_covariance'}
      Name='Covariance';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_covariance#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_oidelay'}
      Name='Output/Input Delay';
      LongHelp=sprintf( ...
         [ ...
            'Delay between output and input.\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_oidelay'}
      Name='Output/Input Delay';
      LongHelp=sprintf( ...
         [ ...
            '#ui_fdidgui_compinp_edit_oidel#\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_variance_inp'}
      Name='InputVariance';
      LongHelp=sprintf( ...
         [ ...
            'Vector of variances of complex input amplitudes.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_edit_variance_out'}
      Name='OutputVariance';
      LongHelp=sprintf( ...
         [ ...
            'Vector of variances of complex output amplitudes.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'ui_fdidgui_compinp_text_variance'}
      Name='Variance';
      LongHelp=sprintf( ...
         [ ...
            'Vectors of variances of complex output and input amplitudes.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_coherence'}
      Name='Browse for Coherence';
      LongHelp=sprintf( ...
         [ ...
            'Allow to browse binary (MAT) files and ASCII files to load data from them. \n' ...
            'The "Browse" command writes the reference to the file into the edit box \n' ...
            'beside.\n' ...
            '\n' ...
            'For MAT-files, in addition a variable name can be written after the file \n' ...
            'name, separated by a colon:\n' ...
            '<c:\\temp\\data.mat>:freqs\n' ...
            'When there is only one variable in the file, the variable name is not \n' ...
            'needed.\n' ...
            '\n' ...
            'For ASCII files, only the file name needs to be in the edit box, and the \n' ...
            'load command will be executed on this file. The result needs to be a \n' ...
            'MATLAB column vector. Example:\n' ...
            '<c:\\temp\\data.txt>\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_covariance'}
      Name='Browse for Covariance';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_coherence#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_variance_inp'}
      Name='Browse for InputVariance';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_coherence#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdidgui_compinp_pb_browse_variance_out'}
      Name='Browse for OutputVariance';
      LongHelp=sprintf( ...
         [ ...
            '#fdidgui_compinp_pb_browse_coherence#\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_data_type_io'}
      Name='Input/Output data';
      LongHelp=sprintf( ...
         [ ...
            'Complex amplitudes are given in separate column vectors or in columns of \n' ...
            'an array in the workspace.\n' ...
            'The frequency vector must also be provided in the form of a variable or a \n' ...
            'Matlab expression, in Hz.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_data_type_frfdb'}
      Name='FRF data, dB/degrees';
      LongHelp=sprintf( ...
         [ ...
            'The data come from a network analyzer, and the two available vectors are \n' ...
            'the gains (magnitudes) in decibels, and the phases in degrees. These \n' ...
            'vectors can also be columns of an array in the workspace.\n' ...
            'The frequency vector must also be provided in the form of a variable or a \n' ...
            'Matlab expression, in Hz.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   case {'compinput_menu_data_type_frf'}
      Name='Complex FRF data';
      LongHelp=sprintf( ...
         [ ...
            'Column vector of the complex FRF values (or column of an array) in the \n' ...
            'workspace.\n' ...
            'The frequency vector must also be provided in the form of a variable or a \n' ...
            'Matlab expression, in Hz.\n' ...
            '\n' ...
            'Details on possible file references can be read under the menu item "Help \n' ...
            '/ This window / Referring to files".\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'average_main'
   switch ObjTag
   case {'average_main'}
      Name='Variances and/or Averaging';
      LongHelp=sprintf( ...
         [ ...
            'Select the source of Fourier amplitudes (average of experiments or a \n' ...
            'single experiment), and get the associated variance data.\n' ...
            '\n' ...
            'If the menu "UserLevel" is set to "Automatic",\n' ...
            'this block automatically proceeds after being opened (at least if \n' ...
            'automatic setting is possible, based on the data).\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_uaxes'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#agv_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_laxes'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus. \n' ...
            '\n' ...
            'The FRF is shown with green crosses.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_uaxes_variances'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#agv_axes_laxes_variances#\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_laxes_variances'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus. \n' ...
            '\n' ...
            'The FRF is shown with green crosses.\n' ...
            '\n' ...
            'The yellow marks show the noise level of the measurements.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_uaxes_nonlin'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#agv_axes_laxes_nonlin#\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_laxes_nonlin'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus.\n' ...
            '\n' ...
            'The FRF is shown with green crosses.\n' ...
            '\n' ...
            'The yellow marks show the noise level of the measurements.\n' ...
            '\n' ...
            'A measure of the nonlinearity + noise level of the system and the \n' ...
            'measurements is shown with x marks in purple.\n' ...
            '\n' ...
            'The uncertainty of the best linear approximation is shown in light purple.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_uaxes_interp'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#agv_axes_laxes_interp#\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_axes_laxes_interp'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus.\n' ...
            '\n' ...
            'The FRF is shown with green crosses.\n' ...
            '\n' ...
            'The yellow marks show the noise level of the measurements. Light yellow \n' ...
            'diamonds mark the variance of the nonexcited lines.\n' ...
            '\n' ...
            'A measure of the nonlinear error levels caused by odd nonlinearities (plus \n' ...
            'the noise levels added) are shown by triangles in blue.\n' ...
            '\n' ...
            'A measure of the nonlinear error levels caused by even nonlinearities \n' ...
            '(plus the noise levels added) are shown by light purple squares.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_suggestpb'}
      Name='Suggest';
      LongHelp=sprintf( ...
         [ ...
            'Suggest "best" choices in "Data to fit" and "Get variances". \n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_suggestpb'}
      Name='Suggest';
      LongHelp=sprintf( ...
         [ ...
            'Suggest "best" choices in "Data to fit" and "Get variances". \n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_frffxfypop'}
      Name='Type of Plot';
      LongHelp=sprintf( ...
         [ ...
            'Type of plots can be chosen.\n' ...
            '\n' ...
            '"frf": Frequency Response Function, that is, the nonparametric transfer \n' ...
            'function estimate.\n' ...
            '\n' ...
            '"output-input": The output and input Fourier amplitudes are shown in two \n' ...
            'separate subplots.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_muledit'}
      Name='Scaling factor';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_vxedit'}
      Name='Input variances';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_vyedit'}
      Name='Output variances';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_enedit'}
      Name='Experiment number';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_linloghpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'agv_uic_varpop'}
      Name='Variance on/off in plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'agv_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'agv_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'select_main'
   switch ObjTag
   case {'select_main'}
      Name='Estimate Plant Model';
      LongHelp=sprintf( ...
         [ ...
            'The main identification tool. If UserLevel is ''Automatic'' (this is \n' ...
            'selectable in the menu of the main window), only the domain can be \n' ...
            'selected, and automatic model order selection is done. If UserLevel is \n' ...
            'higher, the basic choices, like domain, numerator/denominator orders, \n' ...
            'fixed or variable delay, etc. can be done, and the iteration can be \n' ...
            'performed.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_axes_uaxes'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#sme_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_axes_laxes'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus.\n' ...
            '\n' ...
            'The FRF is shown with green crosses.\n' ...
            '\n' ...
            'The noise level of the measurements is shown with yellow x marks.\n' ...
            '\n' ...
            'When the estimation is done, the estimated model is shown in red, the \n' ...
            'residuals in cyan, and their theoretical 50%% and 95%% bounds in magenta.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_axes_ax'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#sme_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_axes_laxes_nonlin'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot the data contained by the window to the screen. The type of the plot \n' ...
            'can be chosen by popup menus.\n' ...
            '\n' ...
            'The FRF is shown with green crosses.\n' ...
            '\n' ...
            'The nonlinear error (+ noise) levels are shown in purple.\n' ...
            '\n' ...
            'When the estimation is done, the estimated model is shown in red, the \n' ...
            'residuals in cyan, and their theoretical  50%% and 95%% bounds in blue.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_axes_ax_nonlin'}
      Name='Axes for plot';
      LongHelp=sprintf( ...
         [ ...
            '#sme_axes_laxes_nonlin#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_dompop'}
      Name='Domain';
      LongHelp=sprintf( ...
         [ ...
            'The domain can be selected: s-domain or z-domain, and if the UserLevel is \n' ...
            'Interactive, also w-domain (Warburg-domain, sqrt(s)).or r-domain \n' ...
            '(Richards-domain, tanh(s*TauR))\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_domaintext'}
      Name='Domain';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_dompop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_delpop'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            'During estimation, the delay is either fixed to a given value, or \n' ...
            'variable, that is, it is estimated along with the transfer function \n' ...
            'coefficients.\n' ...
            'It has to be given in s (seconds) in the continuous domain (s-domain or \n' ...
            'w-domain), and in T = 1/fs (samples) in the discrete domain (z-domain).\n' ...
            'If UserLevel is ''Automatic'', the delay is fixed to 0.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_delaytext'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_delpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_deledit'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_delpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_valuetext'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_delpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_sectext'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_delpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_raztext'}
      Name='Fix poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_razedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_razpop'}
      Name='Fix poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_razedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_raztext2'}
      Name='Fix poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_razedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_razedit'}
      Name='Number of fixed poles or zeros';
      LongHelp=sprintf( ...
         [ ...
            'In some cases, it is known a priori that in the model zero(s) or pole(s) \n' ...
            'have exact zero value. The GUI allows to assign this fixed zero value to \n' ...
            'either some poles or to some zeros.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_fsedit'}
      Name='Sampling frequency, fs';
      LongHelp=sprintf( ...
         [ ...
            'Sampling frequency for z-domain models\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_fstext'}
      Name='Sampling frequency, fs';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_fsedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_fstext2'}
      Name='Sampling frequency, fs';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_fsedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_tredit'}
      Name='tau-coefficient';
      LongHelp=sprintf( ...
         [ ...
            'tau-coefficient for Richards-domain models: the variable of the rational \n' ...
            'form is tanh(TauR*s)\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_trtext'}
      Name='tau-coefficient';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_tredit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_trtext2'}
      Name='tau-coefficient';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_tredit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_varpop'}
      Name='Variance on/off in plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_linloghpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_deledit'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_odedit'}
      Name='Order of denominator';
      LongHelp=sprintf( ...
         [ ...
            'The order can be given as an integer number. If the word "scan" is given \n' ...
            'for both orders, it makes the toolbox to automatically determine a good \n' ...
            'model order. If UserLevel is ''Automatic'', only automatic model order \n' ...
            'selection is possible.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_onedit'}
      Name='Order of numerator';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_odedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_autoorderpb'}
      Name='Automatic Order Selection';
      LongHelp=sprintf( ...
         [ ...
            'The GUI is capable to automatically determine the desired orders of the \n' ...
            'model. Pushing this button will write the word "auto" into the numerator \n' ...
            'and denominator edit boxes. Pushing "Start" will automatically execute the \n' ...
            'search for the suggested orders.\n' ...
            '\n' ...
            'The result of the order selection will be written into the edit boxes. In \n' ...
            'many cases, a second, "loose" model will also be determined. This will be \n' ...
            'saved along with the selected model, and a warning will appear in the \n' ...
            'status line of the window. This is often a lower-order model which is not \n' ...
            'bad either, but is not verified by systematic means.\n' ...
            '\n' ...
            'Warning: automatic order determination works properly only when the \n' ...
            'variances of the measurement are properly given. If this is not the case, \n' ...
            'for too large variances the orders will be too low (noisy data contain \n' ...
            'little information), for too small variances the orders will be too high \n' ...
            '(details of the FRF are carefully followed). With artifical variances \n' ...
            '(e.g. set to constant by the Variances and/or Averaging window) the \n' ...
            'results are not predictable.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_improvedcb'}
      Name='Improved numerical stability';
      LongHelp=sprintf( ...
         [ ...
            'Transfer function representation of a dynamic system is often badly \n' ...
            'conditioned. This may even prevent proper identification. Conditioning can \n' ...
            'be dramatically improved by the use of orthogonal polynomials. This means \n' ...
            'that instead of dealing with the traditional polynomials of s-powers or \n' ...
            'z^(-1)-powers, we treat a linear combination of polynomials orthogonal to \n' ...
            'each other on the given frequency grid. This requires somewhat more \n' ...
            'numerical calculations than traditional calculations.\n' ...
            '\n' ...
            'Enabled only if "UserLevel" is "Interactive" or higher.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_transientcb'}
      Name='Transient elimination';
      LongHelp=sprintf( ...
         [ ...
            'Frequency domain methods work well first of all on stationary data. \n' ...
            'However, they are also capable to model transients. By this, the \n' ...
            'estimation algorithm can make a parallel estimation of the disturbing \n' ...
            'transient term, allowing more precise determination of the transfer \n' ...
            'function of the system. The cost is slightly improved variance and longer \n' ...
            'calculation time, but the results are much better if transients are indeed \n' ...
            'present.\n' ...
            '\n' ...
            'This method should be used not only when system transients are present, \n' ...
            'but also when nonperiodic excitation signals were used, for example random \n' ...
            'input.\n' ...
            '\n' ...
            'Enabled only if "UserLevel" is "Interactive" or higher, and the domain is \n' ...
            '"s" or "z".\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_complexcb'}
      Name='Enable complex coefficients';
      LongHelp=sprintf( ...
         [ ...
            'In general, the coefficients of the numerator and the denominator are \n' ...
            'real. However, in special applications, it may be necessary to estimate \n' ...
            'complex coefficients. The checkbox makes this possible. It is usable for \n' ...
            'the higher UserLevels only.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_elisparampb'}
      Name='Set elis run parameters';
      LongHelp=sprintf( ...
         [ ...
            'There are a few run parameters which can be modified when UserLevel is \n' ...
            '"Advanced". This pushbutton will bring up in the future a special window \n' ...
            'for this purpose. At this moment, the pull-down menu "Run modifiers" can \n' ...
            'be used for this purpose. The coloring of the string of the pushbutton \n' ...
            'warns about a non-default setting of the run modifiers.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_aml'}
      Name='Starting values: AML';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration with the approximate maximum \n' ...
            'likelihood method.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_iqml'}
      Name='Starting values: IQML';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration with the IQML method: take an \n' ...
            'object, and calculate the denominator of the cost function from this.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_ls'}
      Name='Starting values: LS';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration with the LS method: make the \n' ...
            'denominators of the terms of the cost function all equal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_equ'}
      Name='Starting values: EEM';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration using the equation error method of \n' ...
            'the signal processing toolbox.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_object'}
      Name='Starting values: Selected object';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration from a given object.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_weight'}
      Name='Starting values: Selected weight';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration by setting the denominators of the \n' ...
            'additive terms from a given weight vector.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setobject'}
      Name='Load object';
      LongHelp=sprintf( ...
         [ ...
            'Read in object for initial value setting.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_sme_int'}
      Name='Select initial model: Result of EPM';
      LongHelp=sprintf( ...
         [ ...
            'Take the actual internal result of EPM for initial value setting. This \n' ...
            'allows to re-iterate from the just calculated result, e.g. to adjust the \n' ...
            'orthogonal polynomial basis.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_sme'}
      Name='Select initial model: Output of EPM';
      LongHelp=sprintf( ...
         [ ...
            'Take object for initial value setting from the output of the EPM block.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_cams'}
      Name='Select initial model: Best of CAMS';
      LongHelp=sprintf( ...
         [ ...
            'Take object for initial value setting from the output of the CAMS block: \n' ...
            'if more than objects are there, take the best one.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_caem'}
      Name='Select initial model: Output of ECPM';
      LongHelp=sprintf( ...
         [ ...
            'Take object for initial value setting from the output of the ECPM block.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setweight'}
      Name='Load initial weight';
      LongHelp=sprintf( ...
         [ ...
            'Set the value of the weight vector.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setdefault'}
      Name='Clear run modifiers';
      LongHelp=sprintf( ...
         [ ...
            'Reset all run parameters to default.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_model'}
      Name='Info on Model';
      LongHelp=sprintf( ...
         [ ...
            'Show information on the estimated model.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_advice'}
      Name='Advice on Model';
      LongHelp=sprintf( ...
         [ ...
            'Give advice concerning fit.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_runmod'}
      Name='Modify algorithm';
      LongHelp=sprintf( ...
         [ ...
            'If the UserLevel is set to "Advanced", a few parameters of the estimation \n' ...
            'algorithm can be changed through the menu "Run modifiers". For example, \n' ...
            'the maximum allowed iteration number can be set, or the stability of the \n' ...
            'fitted model can be prescribed.\n' ...
            '\n' ...
            'WARNING! These changes may influence the algorithm in an unwanted manner, \n' ...
            'so the user may change these at own responsibility. E.g., if the iteration \n' ...
            'number is limited to a small number, the algorithm may stop prematurely, \n' ...
            'before reaching a minimum; or, stabilization of the poles may sometimes \n' ...
            'cause a poor fit or even divergence of the algorithm.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_off'}
      Name='Stability Enforcement off';
      LongHelp=sprintf( ...
         [ ...
            'Stability is not enforced\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_refl'}
      Name='Stability by Reflection';
      LongHelp=sprintf( ...
         [ ...
            'Stability is enforced by reflecting the unstable poles with respect to the \n' ...
            'theoretical stability limit after each iteration step, and then, if \n' ...
            'necessary, pulling them to the given stability margin.\n' ...
            '\n' ...
            'The reflection does not change the amplitude response, but it does change \n' ...
            'the phase response. By this, the phase of the fitted model decreases, and \n' ...
            'so for a proper fit a negative delay (noncausal system) would be adequate. \n' ...
            'A reasonable model with delay can sometimes be achieved by selecting a \n' ...
            'variable delay, and starting from a reasonably chosen positive one.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_contr'}
      Name='Stability by Contraction';
      LongHelp=sprintf( ...
         [ ...
            'Stability is enforced by contraction of the unstable poles to the \n' ...
            'stability limit after each iteration step.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_limit'}
      Name='Stability by Limiting Step Length';
      LongHelp=sprintf( ...
         [ ...
            'Stability is enforced\n' ...
            '\n' ...
            '- in the initial step, by reflecting the unstable poles with respect to \n' ...
            'the theoretical stability limit;\n' ...
            '\n' ...
            '- during the further steps, by discarding steps which would yield unstable \n' ...
            'poles.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_off'}
      Name='Enforcement of minimum phase off';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase property is not enforced\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_refl'}
      Name='Minimum Phase by Reflection';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase is enforced by reflecting the non-minimum phase zeros with \n' ...
            'respect to the theoretical minimum phase limit after each iteration step, \n' ...
            'and then, if necessary, pulling them to the given margin (stability \n' ...
            'margin).\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_contr'}
      Name='Minimum Phase by Contraction';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase is enforced by contraction of the non-minimum phase zeros to \n' ...
            'the minimum phase limit (stability margin) after each iteration step.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_limit'}
      Name='Minimum Phase by Limiting Step Length';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase is enforced\n' ...
            '\n' ...
            '- in the initial step, by reflecting the non-minimum phase zeros with \n' ...
            'respect to the theoretical minimum phase limit;\n' ...
            '\n' ...
            '- during the further steps, by discarding steps which would yield \n' ...
            'non-minimum phase zeros.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_margin'}
      Name='User-defined stability and mph margin';
      LongHelp=sprintf( ...
         [ ...
            'Set stability and minimum phase margins.\n' ...
            '\n' ...
            'For s-domain, the default value is 0, and a negative number may be given \n' ...
            '(given in radHz).\n' ...
            '\n' ...
            'For z-domain, the default value is 1, and a number can be given in (0,1].\n' ...
            '\n' ...
            'For w-domain and r-domain, the rule is the same as for s-domain, and is \n' ...
            'evaluated in terms of the poles/zeros transformed to the s-domain. \n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_default'}
      Name='Default iteration limit';
      LongHelp=sprintf( ...
         [ ...
            'Use built-in maximum number of iterations (50).\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_value'}
      Name='User-defined iteration limit';
      LongHelp=sprintf( ...
         [ ...
            'Use maximum number of iterations set by the user\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_set'}
      Name='Set limit to iterations';
      LongHelp=sprintf( ...
         [ ...
            'Define the maximum allowed number of iterations.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_aml'}
      Name='Built-in setting of starting model';
      LongHelp=sprintf( ...
         [ ...
            'Use built-in algorithm to set the starting model\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_object'}
      Name='User-defined starting model';
      LongHelp=sprintf( ...
         [ ...
            'Use starting model set by the user\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setobject'}
      Name='Set starting model';
      LongHelp=sprintf( ...
         [ ...
            'Define the starting model for the iteration\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_autoorder'}
      Name='Automatic order selection';
      LongHelp=sprintf( ...
         [ ...
            'The Toolbox is capable to determine a good order of the model. This is \n' ...
            'done is the numerator and denominator order fields are filled in with the \n' ...
            'string "auto". This can be done by pushing the button "Auto".\n' ...
            '\n' ...
            'The result of the order selection will be written into the edit boxes. In \n' ...
            'many cases, a second, "loose" model will also be determined. This will be \n' ...
            'saved along with the selected model, and a warning will appear in the \n' ...
            'status line of the window. This is often a lower-order model which is not \n' ...
            'bad either, but is not verified by systematic means.\n' ...
            '\n' ...
            'Warning: automatic order determination works properly only when the \n' ...
            'variances of the measurement are properly given. If this is not the case, \n' ...
            'for too large variances the orders will be too low (noisy data contain \n' ...
            'little information), for too small variances the orders will be too high \n' ...
            '(details of the FRF are carefully followed). With artifical variances \n' ...
            '(e.g. set to constant by the Variances and/or Averaging window) the \n' ...
            'results are not predictable.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_autoorder'}
      Name='Automatic order selection';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_autoorder#\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_autoorder_demo'}
      Name='Demonstration of automatic order selection';
      LongHelp=sprintf( ...
         [ ...
            'Open a graphical user interface window, and allow the experimentation with \n' ...
            'a series of cases.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_runmod'}
      Name='Modify elis run parameters';
      LongHelp=sprintf( ...
         [ ...
            'Sometimes it is reasonable to modify the basic run parameters of elis. \n' ...
            'This can be done in Advanced UserLevel only, through the Run parameters \n' ...
            'menu.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_save'}
      Name='Save model';
      LongHelp=sprintf( ...
         [ ...
            'The identified model can be immediately saved to the workspace or to a \n' ...
            'file through the File / Save model menu item, in the form of a fidmodel \n' ...
            'object.\n' ...
            '\n' ...
            'The object contains every information concerning the model and the fit. \n' ...
            'Its properties are easily available. If its name is "model", get(model) \n' ...
            'lists all the properties, and model.num returns the numerator, \n' ...
            'model.variable the variable of the transfer function, and \n' ...
            'model.representation the type (polynomial or orthopol). A complete \n' ...
            'description of the properties is available through the helper call: \n' ...
            'help(fidmodel). Another possibility is to use the command \n' ...
            '"exppar(object,filename)" in the command window to generate an ASCII file \n' ...
            'with the most important model data.\n' ...
            '\n' ...
            'Study the structure of the object and the exact meaning of each property \n' ...
            'carefully, because the meaning of properties may slightly change in \n' ...
            'certain cases. For example, for orthogonal representation, the \n' ...
            'coefficients of the transfer function numerator and denominator are not \n' ...
            'accessible, only the coefficients of the orthogonal polynomials. \n' ...
            '\n' ...
            'However, the properties are usually not necessary. helpc(fidmodel) lists \n' ...
            'the available functions: plot(model), plotpz(model), pole(model), \n' ...
            'zero(model), info(model), tf(model), etc. offer enough functionality and \n' ...
            'flexibility for most applications.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_save'}
      Name='Save model';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_save#\n' ...
         ]);
      ShortHelp='';
      return
   case {'export-import'}
      Name='Saving model';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_save#\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_info'}
      Name='Information on model';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_info#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_info'}
      Name='Information on model';
      LongHelp=sprintf( ...
         [ ...
            'Textual description of model properties and of the quality of fit.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_file_load_model'}
      Name='Load model';
      LongHelp=sprintf( ...
         [ ...
            'Earlier identified models can be loaded into the window in fidmodel object \n' ...
            'format. This means restoring earlier results of the window. Loading will \n' ...
            'also change the input data, to assure consistency.\n' ...
         ]);
      ShortHelp='';
      return
   case {'select_menu_file_save_model'}
      Name='Save model';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_save#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_trordedit'}
      Name='Order of transient numerator';
      LongHelp=sprintf( ...
         [ ...
            'The order of the transient numerator is set here. It may not be smaller \n' ...
            'than the maximum order of the numerator and the denominator minus 1. The \n' ...
            'edit box may contain an expression of the variable "maxord". If the edit \n' ...
            'box is empty, the order is set to the minimum allowed value.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_trordtext'}
      Name='Order of transient numerator';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_trordedit#\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'aided_main'
   switch ObjTag
   case {'aided_main'}
      Name='Computer Aided Model Scan';
      LongHelp=sprintf( ...
         [ ...
            'Scan a given set of models, with different combinations of numerator and \n' ...
            'denominator orders. The quality of models can be compared later by the \n' ...
            'next tool.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_zsdspop'}
      Name='Type of Mouse Action';
      LongHelp=sprintf( ...
         [ ...
            'The mouse can be used over the plot in 3 different modes.\n' ...
            '\n' ...
            '"Zoom": it acts just like for regular zoom: the contents of a rubber box \n' ...
            'is zoomed to full window size.\n' ...
            '\n' ...
            '"Select": the models represented by the points encircled by a rubber box \n' ...
            'are selected for further processing.\n' ...
            '\n' ...
            '"Deselect": the opposite of "Select", the models belonging to the \n' ...
            'encircled points are eliminated from the selected ones.\n' ...
            '\n' ...
            'When the mouse is used for just one click close to a model in the plot, \n' ...
            'this will toggle the selection status of the closest model, independently \n' ...
            'of the type of the selected mouse action.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_deselpb'}
      Name='Deselect Improper';
      LongHelp=sprintf( ...
         [ ...
            'Models with numerator order larger than denominator order are deselected.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_axes_ax'}
      Name='Plot of possible models';
      LongHelp=sprintf( ...
         [ ...
            'Possible numerator/denominator order combinations are illustrated on a \n' ...
            'rectangular grid. Combinations can be selected/deselected by the mouse. A \n' ...
            'small circle marks selection of a point.\n' ...
            '\n' ...
            'During iteration, a big red dot marks the currently analyzed model, the \n' ...
            'already identified ones by green dots. Thus, the advance of the analysis \n' ...
            'can be followed. After automatic order selection, two models will be \n' ...
            'returned: the suggested one in green, and the "loose" one (lower order, \n' ...
            'not verified), in light green. When the two models coincide, only the \n' ...
            'selected one will be shown. After the selection of "autoscan", also all \n' ...
            'the models calculated during iteration will be returned. This does not \n' ...
            'mean ALL models in the range - these can be selected and calculated \n' ...
            'afterwards.\n' ...
            '\n' ...
            'When the mouse is used for just one click close to a point in the plot, \n' ...
            'this will toggle the selection status of the closest point, independently \n' ...
            'of the type of the selected mouse action.\n' ...
            '\n' ...
            'WARNING! Under some operational systems, event synchronization is not \n' ...
            'perfect. In such cases, do not move the mouse right after a click, before \n' ...
            'the message about selection appears in the status line.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_dompop'}
      Name='Domain';
      LongHelp=sprintf( ...
         [ ...
            'The domain can be selected: s-domain or z-domain, and if the UserLevel is \n' ...
            'Interactive, also w-domain (Warburg-domain, sqrt(s)).or r-domain \n' ...
            '(Richards-domain, tanh(s*TauR))\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_domaintext'}
      Name='Domain';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_dompop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_odedit'}
      Name='Denominator orders';
      LongHelp=sprintf( ...
         [ ...
            'The possible orders can be given in the form of a Matlab vector of integer \n' ...
            'numbers. E.g. [2:4,6]. If the word "scan" is given for both orders, it \n' ...
            'makes the algorithm to automatically determine a good model. If this is \n' ...
            'replaced by "autoscan", all the reasonable models calculated during \n' ...
            'iterative order determination will be returned. This does not mean the \n' ...
            'calculation of all models in the range - these can be determined by \n' ...
            'selecting all desired models and pushing start.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_onedit'}
      Name='Numerator orders';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_odedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_autoorderpb'}
      Name='Automatic Order Selection';
      LongHelp=sprintf( ...
         [ ...
            'The GUI is capable to automatically determine the desired orders of the \n' ...
            'model. Pushing this button will write the word "auto" into the numerator \n' ...
            'and denominator edit boxes. Pushing "Start" will automatically execute the \n' ...
            'search for the suggested orders. A second push will write the words \n' ...
            '"autoscan" into the edit boxes. This makes the algorithm collect all \n' ...
            'calculated models between the two suggestions, and mark them in the grid. \n' ...
            'Note: This does not mean the calculation of all models in the range - \n' ...
            'these can be determined by selecting all desired models and pushing \n' ...
            'start.\n' ...
            '\n' ...
            'The result of the order selection will be written into the edit boxes. The \n' ...
            '"model grid" is spanned between two models: the suggested one (the \n' ...
            'higher-order model), and the "loose" one which is often a lower-order \n' ...
            'model which is not bad either, but is not verified by systematic means. \n' ...
            'The calculated models are marked with green: the suggested one in the \n' ...
            'usual color, the others in lighter green.\n' ...
            '\n' ...
            'Warning: automatic order determination works properly only when the \n' ...
            'variances of the measurement are properly given. If this is not the case, \n' ...
            'for too large variances the orders will be too low (noisy data contain \n' ...
            'little information), for too small variances the orders will be too high \n' ...
            '(details of the FRF are carefully followed). With artifical variances \n' ...
            '(e.g. set to constant by the Variances and/or Averaging window) the \n' ...
            'results are not predictable. With artifical variances (e.g. set to \n' ...
            'constant by the Variances and/or Averaging window) the results are not \n' ...
            'predictable.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_delpop'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            'During estimation, the delay is either fixed to a given value, or \n' ...
            'variable, that is, it is estimated along with the transfer function \n' ...
            'coefficients.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_delaytext'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_delpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_deledit'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_delpop#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_raztext'}
      Name='Fix poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_razedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_razpop'}
      Name='Fix poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_razedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_raztext2'}
      Name='Fix poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_razedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_razedit'}
      Name='Number of fixed poles/zeros';
      LongHelp=sprintf( ...
         [ ...
            'In some cases, it is known a priori that in the model zero(s) or pole(s) \n' ...
            'have exact zero value. The GUI allows to assign this fixed zero value to \n' ...
            'either some poles or to some zeros.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_fsedit'}
      Name='Sampling frequency, fs';
      LongHelp=sprintf( ...
         [ ...
            'Sampling frequency for z-domain models\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_fstext'}
      Name='Sampling frequency, fs';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_fsedit#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_zsdspop'}
      Name='Type of mouse action';
      LongHelp=sprintf( ...
         [ ...
            'The mouse can be used over the plot in 3 different modes.\n' ...
            '\n' ...
            '"Zoom": it acts just like for regular zoom: the contents of a rubber box \n' ...
            'is zoomed to full window size.\n' ...
            '\n' ...
            '"Select": the models belonging to the points encircled by a rubber box are \n' ...
            'selected for further processing.\n' ...
            '\n' ...
            '"Deselect": the opposite of "Select", the models belonging to the \n' ...
            'encircled points are eliminated from the selected ones.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_improvedcb'}
      Name='Improved numerical stability';
      LongHelp=sprintf( ...
         [ ...
            'Transfer function representation of a dynamic system is often badly \n' ...
            'conditioned. This may even prevent proper identification. Conditioning can \n' ...
            'be dramatically improved by the use of orthogonal polynomials. This means \n' ...
            'that instead of dealing with the traditional polynomials of s-powers or \n' ...
            'z^(-1)-powers, we treat a linear combination of polynomials orthogonal to \n' ...
            'each other on the given frequency grid. This requires somewhat more \n' ...
            'numerical calculations than traditional calculations.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_transientcb'}
      Name='Transient elimination';
      LongHelp=sprintf( ...
         [ ...
            'Frequency domain methods work well first of all on stationary data. \n' ...
            'However, they are also capable to model transients. By this, the \n' ...
            'estimation algorithm can make a parallel estimation of the disturbing \n' ...
            'transient term, allowing more precise determination of the transfer \n' ...
            'function of the system. The cost is slightly improved variance and longer \n' ...
            'calculation time, but the results are much better if transients are indeed \n' ...
            'present.\n' ...
            '\n' ...
            'This method should be used not only when system transients are present, \n' ...
            'but also when nonperiodic excitation signals were used, for example random \n' ...
            'input.\n' ...
            '\n' ...
            'Enabled only if "UserLevel" is "Interactive" or higher, and the domain is \n' ...
            '"s" or "z".\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_elisparampb'}
      Name='Set elis run parameters';
      LongHelp=sprintf( ...
         [ ...
            'There are a few run parameters which can be modified when UserLevel is \n' ...
            '"Advanced". This pushbutton will bring up in the future a special window \n' ...
            'for this purpose. At this moment, the pull-down menu "Run modifiers" can \n' ...
            'be used for this purpose. The coloring of the string of the pushbutton \n' ...
            'warns about a non-default setting of the run modifiers.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_aml'}
      Name='Starting values: AML';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration with the approximate maximum \n' ...
            'likelihood method.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_iqml'}
      Name='Starting values: IQML';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration with the IQML method: take an \n' ...
            'object, and calculate the denominator of the cost function from this.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_ls'}
      Name='Starting values: LS';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration with the LS method: make the \n' ...
            'denominators of the terms of the cost function all equal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_equ'}
      Name='Starting values: EEM';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration using the equation error method of \n' ...
            'the signal processing toolbox.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_object'}
      Name='Starting values: Selected object';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration from a given object.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_weight'}
      Name='Starting values: Selected weight';
      LongHelp=sprintf( ...
         [ ...
            'Set the initial values of the iteration by setting the denominators of the \n' ...
            'additive terms from a given weight vector.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setobject'}
      Name='Load object';
      LongHelp=sprintf( ...
         [ ...
            'Read in object for initial value setting.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_sme'}
      Name='Select initial model: Output of EPM';
      LongHelp=sprintf( ...
         [ ...
            'Take object for initial value setting from the output of the EPM block.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_cams'}
      Name='Select initial model: Best of CAMS';
      LongHelp=sprintf( ...
         [ ...
            'Take object for initial value setting from the output of the CAMS block: \n' ...
            'if more than objects are there, take the best one.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_caem'}
      Name='Select initial model: Output of ECPM';
      LongHelp=sprintf( ...
         [ ...
            'Take object for initial value setting from the output of the ECPM block.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setweight'}
      Name='Load initial weight';
      LongHelp=sprintf( ...
         [ ...
            'Set the value of the weight vector.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_model'}
      Name='Info on Model';
      LongHelp=sprintf( ...
         [ ...
            'Show information on the estimated model.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_advice'}
      Name='Advice on Model';
      LongHelp=sprintf( ...
         [ ...
            'Give advice on quality of fit.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_model'}
      Name='Info on Model';
      LongHelp=sprintf( ...
         [ ...
            '#aided_menu_help_model#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_runmod'}
      Name='Modify algorithm';
      LongHelp=sprintf( ...
         [ ...
            'If the UserLevel is set to "Advanced", a few parameters of the estimation \n' ...
            'algorithm can be changed through the menu "Run modifiers". For example, \n' ...
            'the maximum allowed iteration number can be set, or the stability of the \n' ...
            'fitted model can be prescribed.\n' ...
            '\n' ...
            'WARNING! These changes may influence the algorithm in an unwanted manner, \n' ...
            'so the user may change these at own responsibility. E.g., if the iteration \n' ...
            'number is limited to a small number, the algorithm may stop prematurely, \n' ...
            'before reaching a minimum; or, stabilization of the poles may sometimes \n' ...
            'cause a poor fit or even divergence of the algorithm.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_off'}
      Name='Stability Enforcement off';
      LongHelp=sprintf( ...
         [ ...
            'Stability is not enforced\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_refl'}
      Name='Stability by Reflection';
      LongHelp=sprintf( ...
         [ ...
            'Stability is enforced by reflecting the unstable poles with respect to the \n' ...
            'stability limit after each iteration step.\n' ...
            '\n' ...
            'The reflection does not change the amplitude response, but it does change \n' ...
            'the phase response. By this, the phase of the fitted model decreases, and \n' ...
            'so for a proper fit a negative delay (noncausal system) would be adequate. \n' ...
            'A reasonable model with delay can sometimes be achieved by selecting a \n' ...
            'variable delay, and starting from a reasonably chosen positive one.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_stab_contr'}
      Name='Stability by Contraction';
      LongHelp=sprintf( ...
         [ ...
            'Stability is enforced by contraction the unstable poles to the stability \n' ...
            'limit after each iteration step.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_off'}
      Name='Enforcement of minimum phase off';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase property is not enforced\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_refl'}
      Name='Minimum Phase by Reflection';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase is enforced by reflecting the non-minimum phase zeros with \n' ...
            'respect to the minimum phase limit after each iteration step.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_fmph_contr'}
      Name='Minimum Phase by Contraction';
      LongHelp=sprintf( ...
         [ ...
            'Minimum phase is enforced by contraction the non-minimum phase zeros to \n' ...
            'the minimum phase limit after each iteration step.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_margin'}
      Name='User-defined stability / mph margin';
      LongHelp=sprintf( ...
         [ ...
            'Use stability margin set by the user\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_default'}
      Name='Default iteration limit';
      LongHelp=sprintf( ...
         [ ...
            'Use built-in maximum number of iterations (50).\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_value'}
      Name='User-defined iteration limit';
      LongHelp=sprintf( ...
         [ ...
            'Use maximum number of iterations set by the user\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_value'}
      Name='User-defined iteration limit';
      LongHelp=sprintf( ...
         [ ...
            'Use maximum number of iterations set by the user\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_itno_set'}
      Name='Set limit to iterations';
      LongHelp=sprintf( ...
         [ ...
            'Define the maximum allowed number of iterations.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_aml'}
      Name='Built-in setting of starting model';
      LongHelp=sprintf( ...
         [ ...
            'Use built-in algorithm to set the starting model\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_object'}
      Name='User-defined starting model';
      LongHelp=sprintf( ...
         [ ...
            'Use starting model set by the user\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_runmod_iobj_setobject'}
      Name='Set starting model';
      LongHelp=sprintf( ...
         [ ...
            'Define the starting model for the iteration\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_autoorder'}
      Name='Automatic order selection';
      LongHelp=sprintf( ...
         [ ...
            'The Toolbox is capable to determine a good order of the model. This is \n' ...
            'done is the numerator and denominator order fields are filled in with the \n' ...
            'string "auto". This can be done by pushing the button "Auto".\n' ...
            '\n' ...
            'After pushing the "Start" button, the order determination algorithm will \n' ...
            'be run, and the best guess will be written into the order fields. The \n' ...
            'suggested model will be marked with green, the "loose" (lower order model, \n' ...
            'but not verified by systematic means) will be denoted by light green.\n' ...
            '\n' ...
            'Warning: automatic order determination works properly only when the \n' ...
            'variances of the measurement are properly given. If this is not the case, \n' ...
            'for too large variances the orders will be too low (noisy data contain \n' ...
            'little information), for too small variances the orders will be too high \n' ...
            '(details of the FRF are carefully followed). With artifical variances \n' ...
            '(e.g. set to constant by the Variances and/or Averaging window) the \n' ...
            'results are not predictable.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_autoorder'}
      Name='Automatic order selection';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_autoorder#\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_autoorder_demo'}
      Name='Demonstration of automatic order selection';
      LongHelp=sprintf( ...
         [ ...
            'Open a graphical user interface window, and allow the experimentation with \n' ...
            'a series of cases.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_runmod'}
      Name='Modify elis run parameters';
      LongHelp=sprintf( ...
         [ ...
            'Sometimes it is reasonable to modify the basic run parameters of elis. \n' ...
            'This can be done in Advanced UserLevel only, through the Run parameters \n' ...
            'menu.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_save'}
      Name='Save models';
      LongHelp=sprintf( ...
         [ ...
            'The identified models can be immediately saved to the workspace or to a \n' ...
            'file through the File / Save model menu item, in the form of a fidmodel \n' ...
            'object.\n' ...
            '\n' ...
            'The object contains every information concerning the model and the fit. \n' ...
            'Its properties are easily available. If its name is "model", get(model) \n' ...
            'lists all the properties, and model(1).num returns the numerator of the \n' ...
            'first model, model(1).variable the variable of the transfer function, and \n' ...
            'model(1).representation the type (polynomial or orthopol). A complete \n' ...
            'description of the properties is available through the helper call: \n' ...
            'help(fidmodel). Another possibility is to use the command \n' ...
            '"exppar(object,filename)" in the command window to generate an ASCII file \n' ...
            'with the most important model data.\n' ...
            '\n' ...
            'Study the structure of the object and the exact meaning of each property \n' ...
            'carefully, because the meaning of properties may slightly change in \n' ...
            'certain cases. For example, for orthogonal representation, the \n' ...
            'coefficients of the transfer function numerator and denominator are not \n' ...
            'accessible, only the coefficients of the orthogonal polynomials. \n' ...
            '\n' ...
            'However, the properties are usually not necessary. helpc(fidmodel) lists \n' ...
            'the available functions: plot(model), plotpz(model), pole(model), \n' ...
            'zero(model), info(model), tf(model), etc. offer enough functionality and \n' ...
            'flexibility for most applications.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_save'}
      Name='Save models';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_save#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_help_load'}
      Name='Load model';
      LongHelp=sprintf( ...
         [ ...
            'Earlier identified models (fidmodel arrays) can be loaded into the window \n' ...
            'in fidmodel object format. Loading will also change the input data, to \n' ...
            'assure consistency.\n' ...
         ]);
      ShortHelp='';
      return
   case {'export-import'}
      Name='Saving model';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_save#\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_menu_info'}
      Name='Information on model';
      LongHelp=sprintf( ...
         [ ...
            'Textual description of model properties and of the quality of fit.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_file_load_model'}
      Name='Load models';
      LongHelp=sprintf( ...
         [ ...
            'Earlier identified models can be loaded into the window in fidmodel object \n' ...
            'format. Loading will also change the input data, to assure consistency.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_file_save_model'}
      Name='Save models';
      LongHelp=sprintf( ...
         [ ...
            '#sme_menu_help_save#\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'aided_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_trordedit'}
      Name='Order of transient numerator';
      LongHelp=sprintf( ...
         [ ...
            'The order of the transient numerator is set here. It may not be smaller \n' ...
            'than the maximum order of the numerator and the denominator minus 1. The \n' ...
            'edit box may contain an expression of the variable "maxord". If the edit \n' ...
            'box is empty, the order is set to the minimum allowed value.\n' ...
         ]);
      ShortHelp='';
      return
   case {'sme_uic_trordtext'}
      Name='Order of transient numerator';
      LongHelp=sprintf( ...
         [ ...
            '#sme_uic_trordedit#\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'compare_main'
   switch ObjTag
   case {'compare_main'}
      Name='Evaluate or Compare Plant Models';
      LongHelp=sprintf( ...
         [ ...
            'When this tool operates on the output of EPM, it shows different views of \n' ...
            'the input model. In parallel, it can also show a second model. Transfer \n' ...
            'functions, pole/zero patterns, cost functions, MDL and Akaike criteria \n' ...
            'etc. can be viewed a compared. Cross validation is also possible with \n' ...
            'another data set.\n' ...
            '\n' ...
            'When the output of CAMS is evaluated, a third subplot shows the MDL \n' ...
            'criteria, the Akaike criteria, the cost functions or mean model errors of \n' ...
            'different models, in order to help selection of the best model.\n' ...
            '\n' ...
            'The model plots can be zoomed in by double click on them. The magnified \n' ...
            'plots have extra zoom-in facility, so every detail can be studied from \n' ...
            'close.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_main_menu_file_print'}
      Name='Print';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_main_menu_file_print_ps'}
      Name='Print to PS file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_file_load_model1'}
      Name='Load model set';
      LongHelp=sprintf( ...
         [ ...
            'Load model set #1\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_file_load_model2'}
      Name='Load model set';
      LongHelp=sprintf( ...
         [ ...
            'Load model set #2\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_file_save_model1'}
      Name='Save model set';
      LongHelp=sprintf( ...
         [ ...
            'Save model set #1\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_file_save_model2'}
      Name='Save model set';
      LongHelp=sprintf( ...
         [ ...
            'Save model set #2\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_file_save_actual1'}
      Name='Save selected model';
      LongHelp=sprintf( ...
         [ ...
            'Save selected model in set #1\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_file_save_actual2'}
      Name='Save selected model';
      LongHelp=sprintf( ...
         [ ...
            'Save selected model in set #2\n' ...
         ]);
      ShortHelp='';
      return
   case {'bar3_numtag'}
      Name='Label "num" of Bar Plot';
      LongHelp=sprintf( ...
         [ ...
            'Order of the numerator\n' ...
         ]);
      ShortHelp='Order of the numerator';
      return
   case {'bar3_dentag'}
      Name='Label "den" of Bar Plot';
      LongHelp=sprintf( ...
         [ ...
            'Order of the denominator\n' ...
         ]);
      ShortHelp='Order of the denominator';
      return
   case {'caem_axes_axes(1)'}
      Name='Bar Plot';
      LongHelp=sprintf( ...
         [ ...
            'Plot of a bar for each model, representing the value of the selected \n' ...
            'criterion. The horizontal axes are set according to the numerator and \n' ...
            'denominator orders, respectively.\n' ...
            '\n' ...
            'Models can be selected by double-click of the mouse on top of a bar, or by \n' ...
            'using the pull-down model selection bar of set #1 (the two selection \n' ...
            'methods are equivalent). The selected model is represented by red color. \n' ...
            'The selected model can be deleted using the edit menu. \n' ...
            '\n' ...
            'The best model is marked in cyan, if it is not selected.\n' ...
            '\n' ...
            'The aspect of the plot can be changed for a better view in a zoomed plot \n' ...
            '(reachable by double-clicking). In this setting, you can grab the "3D box" \n' ...
            'and rotate.\n' ...
            'If the axis labels slide to a wrong position, then after right-click on \n' ...
            'the zoomed figure, set "Rotate Options" to "Plot Box Rotate". \n' ...
         ]);
      ShortHelp='Select "Help on Object" for explanation';
      return
   case {'caem_axes_axes(2)'}
      Name='Plot of model';
      LongHelp=sprintf( ...
         [ ...
            '#caem_uic_typepop#\n' ...
         ]);
      ShortHelp='Select "Help on Object" for explanation';
      return
   case {'caem_axes_axes(3)'}
      Name='Plot of model';
      LongHelp=sprintf( ...
         [ ...
            '#caem_uic_typepop#\n' ...
         ]);
      ShortHelp='Select "Help on Object" for explanation';
      return
   case {'caem_uic_crosspb'}
      Name='Cross Data';
      LongHelp=sprintf( ...
         [ ...
            'This action loads a frequency domain data object from the workspace or a \n' ...
            'file, and evaluates the fit of each model to these data. The idea is that \n' ...
            'while the best model incorporates just all dynamics present in the data, a \n' ...
            'model with too high order also follows a part of the noise. By cross \n' ...
            'validation based on another data set, this latter will exhibit a larger \n' ...
            'cost function, since it follows partly the noise pattern only present in \n' ...
            'the first data set, so we can easily eliminate it.\n' ...
            '\n' ...
            'The results can be viewed in the "Cross Validate" mode.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_crosspop'}
      Name='Validate/Cross Validate';
      LongHelp=sprintf( ...
         [ ...
            'Select between two modes.\n' ...
            '\n' ...
            'Validate: the models are matched to the data used for identification. \n' ...
            'Suggested criterion: MDL.\n' ...
            '\n' ...
            'Cross Validate: the models are matched to the "cross" data. This can \n' ...
            'eliminate overmodeling. Suggested criterion: Cost function.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_f1text'}
      Name='Information on Best Model';
      LongHelp=sprintf( ...
         [ ...
            'Textual information about the best model. For more details about this \n' ...
            'model, double click on the frame.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_f2text'}
      Name='Information on Selected Model of Set #1';
      LongHelp=sprintf( ...
         [ ...
            'Textual information about the selected model in set #1. For more details \n' ...
            'about this model, double click on the frame.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_f3text'}
      Name='Information on Selected Model of Set #2';
      LongHelp=sprintf( ...
         [ ...
            'Textual information about the selected model in set #2. For more details \n' ...
            'about this model, double click on the frame.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_critpop'}
      Name='Criterion';
      LongHelp=sprintf( ...
         [ ...
            'Criterion evaluated for the selection of the desired model. The model best \n' ...
            'according to the criterion is marked by cyan (if it is not selected - \n' ...
            'selection makes it red). Possibilities:\n' ...
            '\n' ...
            'MDL (Minimum Description Length) - the cost function itself theoretically \n' ...
            'decreases with increasing the model order. To avoid this, Rissanen \n' ...
            'modified it to punish too large model orders in the presence of modeling \n' ...
            'errors: cf*(1+np/(2*F)*log(4*F)) for input/output noise, and \n' ...
            'cf*(1+np/(2*F)*log(2*F)) for output noise only. \n' ...
            '\n' ...
            'Akaike - the cost function itself theoretically decreases with increasing \n' ...
            'the model order. To avoid this, Akaike slightly modified it to punish too \n' ...
            'large model orders in the presence of modeling errors: cf*(1+np/F). \n' ...
            '\n' ...
            'Cost function - this is the cost minimized by the nonlinear LS fit. It can \n' ...
            'be compared to its theoretical value.\n' ...
            '\n' ...
            'Mean model error - this quantifies the fitting error in a number. This \n' ...
            'offers help to select models with small errors.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_typepop'}
      Name='Type of Plot';
      LongHelp=sprintf( ...
         [ ...
            '!@!All plots!@!\n' ...
            'The popup menu below the window(s) selects the type of the plot. By double \n' ...
            'click on the plot, it is zoomed into a large window. Zoom can be requested \n' ...
            'in the large window by a rubber box (click by mouse and pull other corner \n' ...
            'to desired location).\n' ...
            '\n' ...
            'The individual plot types are described under separate Topics.\n' ...
            'The number of possibilities differ according to the setting of UserLevel. \n' ...
            'When it is set to Interactive or higher, the possibilities "Cost function \n' ...
            'vs. Delay", "Residuals" and "Correlation Test" appear.\n' ...
            '!@!TF Magnitudes with Errors!@!\n' ...
            'The magnitude of the measured frequency response function (FRF) is shown \n' ...
            'with + marks in green, the magnitude of the estimated transfer function \n' ...
            '(model) in red, and the fitting error in cyan.\n' ...
            '!@!TF Magnitudes with Errors and Bounds!@!\n' ...
            'The magnitude of the measured frequency response function (FRF) is shown \n' ...
            'with + marks in green, the magnitude of the estimated transfer function \n' ...
            '(model) in red, the fitting error in cyan, and the 50%% and 95%% \n' ...
            'theoretical error bounds in magenta after linear processing, or in blue \n' ...
            'after nonlinear processing.\n' ...
            '!@!TF Magnitudes!@!\n' ...
            'The magnitude of the measured frequency response function (FRF) is shown \n' ...
            'with + marks in green, and the magnitude of the estimated transfer \n' ...
            'function (model) in red.\n' ...
            '!@!TF Magnitudes + std''s!@!\n' ...
            'The magnitude of the measured frequency response function (FRF) is shown \n' ...
            'with + marks in green, the magnitude of the estimated transfer function \n' ...
            '(model) in red, and its standard deviations in dashed red.\n' ...
            '!@!TF Magnitudes, Linear Scale!@!\n' ...
            'The magnitude of the measured frequency response function (FRF) is shown \n' ...
            'with + marks in green, and the magnitude of the estimated transfer \n' ...
            'function (model) in red. The magnitude is shown in linear scale.\n' ...
            '!@!TF Phases!@!\n' ...
            'The phase of the measured frequency response function (FRF) is shown with \n' ...
            '+ marks in green, and the phase of the estimated transfer function (model) \n' ...
            'in red.\n' ...
            '!@!TF Phases Wrapped!@!\n' ...
            'The phase of the measured frequency response function (FRF) is shown with \n' ...
            '+ marks in green, and the phase of the estimated transfer function (model) \n' ...
            'in red. No unwrapping is done: the scale is [-180,180] degrees.\n' ...
            '!@!Poles/Zeros with Bounds!@!\n' ...
            'The pole/zero pattern of the estimated transfer function is shown, along \n' ...
            'with uncertainty ellipses. If the uncertainty is degenerate (one of the \n' ...
            'ellipse axes is negligible compared to the other), a rectangle is plotted \n' ...
            'instead of the ellipse.\n' ...
            '!@!Poles/Zeros!@!\n' ...
            'The pole/zero pattern of the estimated transfer function is shown.\n' ...
            '!@!Impulse Response!@!\n' ...
            'If the Control System Toolbox is installed, the impulse response of the \n' ...
            'system is shown.\n' ...
            '!@!Step Response!@!\n' ...
            'If the Control System Toolbox is installed, the step response of the \n' ...
            'system is shown.\n' ...
            '!@!Nyquist Diagram!@!\n' ...
            'If the Control System Toolbox is installed, the Nyquist diagram of the \n' ...
            'system is shown.\n' ...
            '!@!Cloud of Models!@!\n' ...
            'The nominal model is shown along with 9 Monte-Carlo simulated scattered \n' ...
            'models on top of each other, based on the covariance matrix of the \n' ...
            'estimated parameters.\n' ...
            '!@!Cloud of Models with Data!@!\n' ...
            'The nominal model is shown along with 9 Monte-Carlo simulated scattered \n' ...
            'models on top of each other, based on the covariance matrix of the \n' ...
            'estimated parameters. The measured amplitudes with 2-sigma uncertainty \n' ...
            'bounds are also shown.\n' ...
            '!@!Cost Function vs. Delay!@!\n' ...
            'Cost functions belonging to different models are plotted vs. the \n' ...
            'corresponding delays. When the delays are free, their starting values and \n' ...
            'final values are connected by a blue half-ellipsoid, with a triangle \n' ...
            'marking the starting values.\n' ...
            '!@!Residuals!@!\n' ...
            'The error between the estimated model and the frf is plotted in cyan. The \n' ...
            '50%% and 95%% confidence bounds are also plotted in magenta (or blue for \n' ...
            'bounds calculated from the nonlinear variances).\n' ...
            '!@!Correlation Test!@!\n' ...
            'When the model is good, the difference between the frf and the model is \n' ...
            'assumed to be white. When each standard deviation is normalized to 1, \n' ...
            'whiteness means that the autocorrelation function of the normalized error \n' ...
            'sequence consists of a peak at zero lag, and small values elsewhere, with \n' ...
            'expected values zero. Nonwhiteness is exhibited by large autocorrelation \n' ...
            'values at nonzero lags. The deviation of the autocorrelation function from \n' ...
            'its theoretical value is plotted together with 50%% and 95%% confidence \n' ...
            'bounds in magenta. The bounds for the nonlinear analysis are shown in \n' ...
            'blue.\n' ...
            'If practically all lag values are under the 95%% bound (and the residuals \n' ...
            'themselves are also small), then probably no unmodeled dynamics remained.\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_linlogpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_couplepop'}
      Name='Couple/Decouple plots';
      LongHelp=sprintf( ...
         [ ...
            'Plots of set #1 and set #2 can have the same axis (coupled) or their own \n' ...
            'best axis (decoupled).\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_modelpop2'}
      Name='Set #1, select model';
      LongHelp=sprintf( ...
         [ ...
            'Select model from set #1. It is equivalent to double-click on the bar plot \n' ...
            'on top of a bar, displayed if set #1 contains more than one model.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_modelpop3'}
      Name='Set #2, select model';
      LongHelp=sprintf( ...
         [ ...
            'Select model from set #2.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_set1'}
      Name='Copy Set #1 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy Set #1 to the "Model clipboard". This can later be pasted into a \n' ...
            'model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_set2'}
      Name='Copy Set #2 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy Set #2 to the "Model clipboard". This can later be pasted into a \n' ...
            'model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_set2'}
      Name='Cut Set #2 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut Set #2 and move to the "Model clipboard". This can later be pasted \n' ...
            'into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_set2'}
      Name='Delete Set #2';
      LongHelp=sprintf( ...
         [ ...
            'Delete Set #2 from the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_selected1'}
      Name='Copy Selected Model #1 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy selected model in Set #1 to the "Model clipboard". This can later be \n' ...
            'pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_selected2'}
      Name='Copy Selected Model #2 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy selected model in Set #2 to the "Model clipboard". This can later be \n' ...
            'pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_selected1'}
      Name='Cut Selected Model #1 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut selected model in Set #1 and move to the "Model clipboard". This can \n' ...
            'later be pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_selected2'}
      Name='Cut Selected Model #2 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut selected model in Set #2 and move to the "Model clipboard". This can \n' ...
            'later be pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_selected1'}
      Name='Delete Selected Model #1';
      LongHelp=sprintf( ...
         [ ...
            'Delete selected model in Set #1.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_selected2'}
      Name='Delete Selected Model #2';
      LongHelp=sprintf( ...
         [ ...
            'Delete selected model in Set #2.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_nonsel1'}
      Name='Copy Nonselected Models #1 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy nonselected models in Set #1 to the "Model clipboard". This can later \n' ...
            'be pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_nonsel2'}
      Name='Copy Nonselected Models in #2 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy nonselected models in Set #2 to the "Model clipboard". This can later \n' ...
            'be pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_nonsel1'}
      Name='Cut Nonselected Models in #1 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut nonselected models in Set #1 and move to the "Model clipboard". This \n' ...
            'can later be pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_nonsel2'}
      Name='Cut Nonselected Models in #2 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut nonselected models in Set #2 and move to the "Model clipboard". This \n' ...
            'can later be pasted into a model set in the ECPM window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_nonsel1'}
      Name='Delete Nonselected Models in #1';
      LongHelp=sprintf( ...
         [ ...
            'Delete nonselected models in Set #1.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_nonsel2'}
      Name='Delete Nonselected Models in #2';
      LongHelp=sprintf( ...
         [ ...
            'Delete nonselected models in Set #2.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_bad1'}
      Name='Copy Bad Models #1 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy bad models in Set #1 to the "Model clipboard". This can later be \n' ...
            'pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_bad2'}
      Name='Copy Bad Models #2 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy bad models in Set #2 to the "Model clipboard". This can later be \n' ...
            'pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_bad1'}
      Name='Cut Bad Models in #1 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut bad models from Set #1 and move them to the "Model clipboard". This \n' ...
            'can later be pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_bad2'}
      Name='Cut Bad Models in #2 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut bad models from Set #2 and move them to the "Model clipboard". This \n' ...
            'can later be pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_bad1'}
      Name='Delete Bad Models from #1';
      LongHelp=sprintf( ...
         [ ...
            'Delete bad models from Set #1.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_bad2'}
      Name='Delete Bad Models from #2';
      LongHelp=sprintf( ...
         [ ...
            'Delete bad models from Set #2.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_unstab1'}
      Name='Copy Unstable Models #1 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy unstable models in Set #1 to the "Model clipboard". This can later be \n' ...
            'pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_copy_unstab2'}
      Name='Copy Unstable Models #2 to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Copy unstable models in Set #2 to the "Model clipboard". This can later be \n' ...
            'pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_unstab1'}
      Name='Cut Unstable Models in #1 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut unstable models from Set #1 and move them to the "Model clipboard". \n' ...
            'This can later be pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_cut_unstab2'}
      Name='Cut Unstable Models in #2 and Move to Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Cut unstable models from Set #2 and move them to the "Model clipboard". \n' ...
            'This can later be pasted into a model set in the ECPM window.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_unstab1'}
      Name='Delete Unstable Models from #1';
      LongHelp=sprintf( ...
         [ ...
            'Delete unstable models from Set #1.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_delete_unstab2'}
      Name='Delete Unstable Models from #2';
      LongHelp=sprintf( ...
         [ ...
            'Delete unstable models from Set #2.\n' ...
            '\n' ...
            'A model is considered as bad if the corresponding cost function is higher \n' ...
            'than the best one by more than 20%% of the maximum difference of all cost \n' ...
            'functions in the set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_paste_add1'}
      Name='Add Clipboard to Set #1';
      LongHelp=sprintf( ...
         [ ...
            'Paste contents of the "Model Clipboard" to Set #1: add the two sets.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_paste_replace1'}
      Name='Replace Set #1 by Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Paste contents of the "Model Clipboard" to Set #1: replace Set #1 by its \n' ...
            'contents.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_paste_add2'}
      Name='Add Clipboard to Set #2';
      LongHelp=sprintf( ...
         [ ...
            'Paste contents of the "Model Clipboard" to Set #2: add the two sets.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_paste_replace2'}
      Name='Replace Set #2 by Clipboard';
      LongHelp=sprintf( ...
         [ ...
            'Paste contents of the "Model Clipboard" to Set #2: replace Set #1 by its \n' ...
            'contents.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_clpboardinfo'}
      Name='Clipboard Information';
      LongHelp=sprintf( ...
         [ ...
            'Show information on the contents of the "Model Clipboard".\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_copypb'}
      Name='Copy model >';
      LongHelp=sprintf( ...
         [ ...
            'Copy selected model in set #1 to set #2. The model will be added to the \n' ...
            'end of set #2, and also kept in set #1.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_copysetpb'}
      Name='Copy model set >>';
      LongHelp=sprintf( ...
         [ ...
            'Copy model set #1 to set #2. The models will be added to the end of set \n' ...
            '#2, and also kept in set #1.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_remcopypb'}
      Name='Copy model <';
      LongHelp=sprintf( ...
         [ ...
            'Copy selected model in set #2 to set #1. The model will be added to the \n' ...
            'end of set #1, and also kept in set #2.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_remcopysetpb'}
      Name='Copy model set <<';
      LongHelp=sprintf( ...
         [ ...
            'Copy models in set #2 to set #1. The models will be added to the end of \n' ...
            'set #1, and also kept in set #2.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_comparepb'}
      Name='Compare <>';
      LongHelp=sprintf( ...
         [ ...
            'Plot selected models from set #1 and #2 on top of each other, in different \n' ...
            'colors. This is a tool to study small differences between models.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'export-import'}
      Name='Save model';
      LongHelp=sprintf( ...
         [ ...
            'The identified model can be saved to the workspace or to a file through \n' ...
            'the File / Save / Model... menu items, in the form of a fidmodel object, \n' ...
            'furthermore in the object formats of the Control Toolbox or of the System \n' ...
            'Identification Toolbox.\n' ...
            '\n' ...
            'The object contains every information concerning the model and the fit. \n' ...
            'Its properties are easily available. If its name is "model", get(model) \n' ...
            'lists all the properties, and model.num returns the numerator(s), \n' ...
            'model.variable the variable(s) of the transfer function(s), and \n' ...
            'model.representation the type(s) (polynomial or orthopol). A complete \n' ...
            'description of the properties is available through the helper call: \n' ...
            'help(fidmodel). Another possibility is to use the command \n' ...
            '"exppar(object,filename)" in the command window to generate an ASCII file \n' ...
            'with the most important model data.\n' ...
            '\n' ...
            'Study the structure of the object and the exact meaning of each property \n' ...
            'carefully, because the meaning of properties may slightly change in \n' ...
            'certain cases. For example, for orthogonal representation, the \n' ...
            'coefficients of the transfer function numerator and denominator are not \n' ...
            'accessible, only the coefficients of the orthogonal polynomials. \n' ...
            '\n' ...
            'However, the properties are usually not necessary. helpc(fidmodel) lists \n' ...
            'the available functions: plot(model), plotpz(model), pole(model), \n' ...
            'zero(model), info(model), tf(model), etc. offer enough functionality and \n' ...
            'flexibility for most applications.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'compare_menu_help_advice'}
      Name='Advice on Model';
      LongHelp=sprintf( ...
         [ ...
            'Give advice concerning fit.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_frame(1)'}
      Name='Information on the best model';
      LongHelp=sprintf( ...
         [ ...
            'Textual information (main properties) of the best model.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_frame(2)'}
      Name='Information on selected model 1';
      LongHelp=sprintf( ...
         [ ...
            'Textual information (main properties) of the selected model in set #1.\n' ...
         ]);
      ShortHelp='';
      return
   case {'caem_uic_frame(1)'}
      Name='Information on selected model 2';
      LongHelp=sprintf( ...
         [ ...
            'Textual information (main properties) of the selected model in set #2\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'gettdatafig'
   switch ObjTag
   case {'gettdatafig'}
      Name='Get Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            'Read in time domain data. \n' ...
            '\n' ...
            'The data must be in tiddata format, or maybe "iddata" (see Sysid toolbox). \n' ...
            'On the generation of a tiddata object, type "help tiddata" in the command \n' ...
            'window.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_uic_import'}
      Name='Import';
      LongHelp=sprintf( ...
         [ ...
            '!@!Importing data!@!\n' ...
            'Read tiddata object (or iddata, see the Sysid toolbox) from workspace, or \n' ...
            'from file.\n' ...
            '\n' ...
            'The reading procedure checks the type of the data: they must be objects. \n' ...
            'Such objects can be created by the function "tiddata" from your own \n' ...
            'vectors - see "Help / Getting Started... / Using Time Domain Data", and the \n' ...
            'corresponding function helps for details. The objects allow the use of the \n' ...
            '"get" and "set" functions: e.g. get(dat). In time domain, don''t forget to \n' ...
            'fill in either the "PeriodLength" or the "Frequencies" property, e.g. \n' ...
            '\n' ...
            '     data.periodlength = 0.03;\n' ...
            '\n' ...
            'otherwise unnecessarily long processing time may be necessary later, \n' ...
            'during the execution of the "Variance Analysis" block. If data of more \n' ...
            'than one experiments are used, and measurements are properly synchronized, \n' ...
            'also set the property "synchronization".\n' ...
            '\n' ...
            '!@!Sample program for preparing load!@!\n' ...
            'Let us assume that we have measured five times 1024 time domain samples, \n' ...
            'which are stored in the 1024 x 5 arrays inp and outp. The sampling \n' ...
            'frequency is fs = 40960 Hz, the period length in each signal is 1/160 s \n' ...
            '(there are 4 periods in each record).\n' ...
            '\n' ...
            '%%First prepare the data in 1 x 5 cell arrays:\n' ...
            'u = num2cell(inp,1); y = num2cell(outp,1);\n' ...
            '%%Now make the object:\n' ...
            'obj = tiddata(y,u,1/40960);\n' ...
            '%%Set some properties:\n' ...
            'obj.periodlength = 1/160;\n' ...
            'obj.synchronization=''on'';\n' ...
            'get(obj) %%check properties\n' ...
            '\n' ...
            'Now the variable obj can be imported to this block.\n' ...
            '\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_uic_simulate'}
      Name='Simulate';
      LongHelp=sprintf( ...
         [ ...
            'Generate simulated data using the generated excitation signal, and the \n' ...
            'selected variance and model. "Import Data" is a special opportunity to \n' ...
            'take a time domain data object instead of the model, and add noise to it.\n' ...
            '\n' ...
            'Enabled only when "UserLevel" is "Advanced".\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_uic_measure'}
      Name='Measure';
      LongHelp=sprintf( ...
         [ ...
            'Measure time domain data. By pushing this button, the user-defined \n' ...
            'function M-file "fdhwfun.m" is called which handles all hardware-dependent \n' ...
            'actions and must return a tiddata object. For the specifications see the \n' ...
            'predefined file "fdhwfsigl.m".\n' ...
            '\n' ...
            'Enabled only when "UserLevel" is "Interactive" or higher.\n' ...
         ]);
      ShortHelp='';
      return
   case {'gettdata_uic_cancel'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            'Cancel operation and return empty data.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_importfig'
   switch ObjTag
   case {'fdtool_importfig'}
      Name='Import variable window';
      LongHelp=sprintf( ...
         [ ...
            'Import variable from workspace or file\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_varlist_lb'}
      Name='Select a variable';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_varname_edit'}
      Name='Variable name';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_filename_edit'}
      Name='File name';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_path_edit'}
      Name='Path';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_varlist_lb'}
      Name='Import variable';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_modsel_pop2'}
      Name='Model';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_ch_pop2'}
      Name='Input Channel';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_ch_pop1'}
      Name='Output Channel';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_exportfig'
   switch ObjTag
   case {'fdtool_exportfig'}
      Name='Export variable window';
      LongHelp=sprintf( ...
         [ ...
            'Export variable to workspace or file\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_varlist_lb'}
      Name='Select a variable';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_ch_pop2'}
      Name='Output channel';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_ch_pop1'}
      Name='Input channel';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_varname_edit'}
      Name='Variable name';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_filename_edit'}
      Name='File name';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_path_edit'}
      Name='Path';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_varlist_lb'}
      Name='Export variable';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'import_modsel_pop2'}
      Name='Model';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_ch_pop2'}
      Name='Input Channel';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_ch_pop1'}
      Name='Output Channel';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'import_export_type'}
      Name='Type of exported variable';
      LongHelp=sprintf( ...
         [ ...
            'The type of the exported model can be one of the following ones:\n' ...
            '\n' ...
            'fidmodel object: model object native to the fdident toolbox\n' ...
            '\n' ...
            'The following types are available if the Control Toolbox is installed \n' ...
            'under Matlab.\n' ...
            '\n' ...
            'LTI tf object: model object directly usable in the Control System Toolbox\n' ...
            '\n' ...
            'LTI ss object: model object directly usable in the Control System Toolbox\n' ...
            '\n' ...
            'LTI zpk object: model object directly usable in the Control System \n' ...
            'Toolbox\n' ...
            '\n' ...
            'The following types are available if the System Identification Toolbox is \n' ...
            'installed under Matlab.\n' ...
            '\n' ...
            'idpoly object: the identified model is exported as y(q) = B(q)/F(q)u(q) + \n' ...
            'n(q), that is, the output noise is assumed to be white.\n' ...
            '\n' ...
            'idarx object: the identified model is exported as A(q)y(q) = B(q)u(q) + \n' ...
            'n(q), that is, the equation error is assumed to be white.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'segmentfig'
   switch ObjTag
   case {'segmentfig'}
      Name='Segment time record';
      LongHelp=sprintf( ...
         [ ...
            'Segment time record\n' ...
         ]);
      ShortHelp='';
      return
   case {'overlapedit'}
      Name='Overlap';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'segmentedit'}
      Name='Samples in a segment';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'segmentapply'}
      Name='Apply settings';
      LongHelp=sprintf( ...
         [ ...
            'Calculate dependable settings in window from given ones\n' ...
         ]);
      ShortHelp='';
      return
   case {'segmentcheck'}
      Name='Apply period length';
      LongHelp=sprintf( ...
         [ ...
            'Apply period length for segment length\n' ...
         ]);
      ShortHelp='';
      return
   case {'segmentfig_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'segmentfig_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'segmentfig_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'segmentfig_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'segmentfig_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'freqselfig'
   switch ObjTag
   case {'freqselfig'}
      Name='Frequency Selection';
      LongHelp=sprintf( ...
         [ ...
            'Select frequencies for identification.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_zsdspop'}
      Name='Type of Mouse Action';
      LongHelp=sprintf( ...
         [ ...
            'The mouse-controlled rubber box can be used over the plot in 3 different \n' ...
            'modes.\n' ...
            '\n' ...
            '"Zoom": it acts just like for regular zoom: the contents of a rubber box \n' ...
            'are zoomed to full window size.\n' ...
            '\n' ...
            '"Select": the frequencies belonging to the points encircled by a rubber \n' ...
            'box are selected for further processing.\n' ...
            '\n' ...
            '"Deselect": the opposite of "Select", the frequencies belonging to the \n' ...
            'encircled points are eliminated from the selected ones.\n' ...
            '\n' ...
            'When the mouse is used for just one click close to a point in the plot, \n' ...
            'this will toggle the selection status of the closest point, independently \n' ...
            'of the type of the selected mouse action.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_excpop'}
      Name='Type of selection';
      LongHelp=sprintf( ...
         [ ...
            'This popup menu determines if we select the frequency points for further \n' ...
            'analysis, of just the excitation frequencies, with automatic selection of \n' ...
            'the band of interest and of the related frequency points.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_frffxfypop'}
      Name='Type of plot';
      LongHelp=sprintf( ...
         [ ...
            'Frequency selection can be done or even continued from a processed set on \n' ...
            'two different plots.\n' ...
            '\n' ...
            '"frf": The Frequency response function (the ratio of the output over the \n' ...
            'input Fourier amplitudes) is plotted.\n' ...
            '\n' ...
            '"output-input": Two subplots are displayed for output and input. \n' ...
            'Select/deselect operates on both. \n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_linloghpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_axes_uaxes'}
      Name='Axes for freq. selection';
      LongHelp=sprintf( ...
         [ ...
            '#freqsel_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_axes_laxes'}
      Name='Axes for freq. selection';
      LongHelp=sprintf( ...
         [ ...
            'The plot can be used for selection of the frequency points. The mouse can \n' ...
            'be used in two ways. \n' ...
            '\n' ...
            'When we click close to a point in the plot, this will toggle the selection \n' ...
            'status of the closest point, independently of the type of the selected \n' ...
            'mouse action.\n' ...
            '\n' ...
            'When a rubber box encircles some points, the Select/Deselect/Zoom action \n' ...
            'depends on the type of mouse action selected by the pop-up menu.\n' ...
            '\n' ...
            'WARNING! Under some operational systems, event synchronization is not \n' ...
            'perfect. In such cases, do not move the mouse after a click, before the \n' ...
            'message about selection appears in the status line.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'freqsel2fig'
   switch ObjTag
   case {'freqsel2fig'}
      Name='Frequency Selection';
      LongHelp=sprintf( ...
         [ ...
            'Select frequencies for identification.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_zsdspop'}
      Name='Mouse action type';
      LongHelp=sprintf( ...
         [ ...
            'The mouse can be used over the plot in 3 different modes.\n' ...
            '\n' ...
            '"Zoom": it acts just like for regular zoom: the contents of a rubber box \n' ...
            'are zoomed to full window size.\n' ...
            '\n' ...
            '"Select": the frequencies belonging to the points encircled by a rubber \n' ...
            'box are selected for further processing.\n' ...
            '\n' ...
            '"Deselect": the opposite of "Select", the frequencies belonging to the \n' ...
            'encircled points are eliminated from the selected ones.\n' ...
            '\n' ...
            'When the mouse is used for just one click close to a point in the plot, \n' ...
            'this will toggle the selection status of the closest point, independently \n' ...
            'of the type of the selected mouse action.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_frffxfypop'}
      Name='Type of plot';
      LongHelp=sprintf( ...
         [ ...
            'Frequency selection can be done or even continued from a processed set on \n' ...
            'four different plots.\n' ...
            '\n' ...
            '"frf": The Frequency response function (the ratio of the output over the \n' ...
            'input Fourier amplitudes) is plotted.\n' ...
            '\n' ...
            ' "frf + std": The Frequency response function (the ratio of the output \n' ...
            'over the input Fourier amplitudes) is plotted, together with the standard \n' ...
            'deviations.\n' ...
            '\n' ...
            '"output-input": Two subplots are displayed for output and input. \n' ...
            'Select/deselect operates on both. \n' ...
            '\n' ...
            '"output-input + std": Two subplots are displayed for output and input, \n' ...
            'together with the standard deviations.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_frffxfypop-old'}
      Name='Type of plot';
      LongHelp=sprintf( ...
         [ ...
            'Frequency selection can be done or even continued from a processed set on \n' ...
            'four different plots.\n' ...
            '\n' ...
            '"frf": The Frequency response function (the ratio of the output over the \n' ...
            'input Fourier amplitudes) is plotted.\n' ...
            '\n' ...
            ' "frf + std": The Frequency response function (the ratio of the output \n' ...
            'over the input Fourier amplitudes) is plotted, together with the standard \n' ...
            'deviations.\n' ...
            '\n' ...
            '"output-input": Two subplots are displayed for output and input. \n' ...
            'Select/deselect operates on both. \n' ...
            '\n' ...
            '"output-input + std": Two subplots are displayed for output and input, \n' ...
            'together with the standard deviations.\n' ...
            '\n' ...
            'For UserLevel Advanced only:\n' ...
            '\n' ...
            ' "SNR + frf": the signal-to-noise ratio is plotted along with the frf. \n' ...
            'Select/deselect operates on the SNR points.\n' ...
            '\n' ...
            ' "NSR + frf": the noise-to signal ratio is plotted along with the frf. \n' ...
            'Select/deselect operates on the NSR points.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_linloghpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_axes_uaxes'}
      Name='Axes for freq. selection';
      LongHelp=sprintf( ...
         [ ...
            '#freqsel_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_axes_laxes'}
      Name='Axes for freq. selection';
      LongHelp=sprintf( ...
         [ ...
            'The plot can be used for selection of the frequency points. The mouse can \n' ...
            'be used in two ways. \n' ...
            '\n' ...
            'When we click close to a point in the plot, this will toggle the selection \n' ...
            'status of the closest point, independently of the type of the selected \n' ...
            'mouse action.\n' ...
            '\n' ...
            'When a rubber box encircles some points, the Select/Deselect/Zoom action \n' ...
            'depends on the type of mouse action selected by the pop-up menu.\n' ...
            '\n' ...
            '\n' ...
            'WARNING! Under some operational systems, event synchronization is not \n' ...
            'perfect. In such cases, do not move the mouse after a click, before the \n' ...
            'message about selection appears in the status line.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel2fig_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel2fig_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel2fig_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel2fig_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel2fig_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'freqsel3fig'
   switch ObjTag
   case {'freqsel3fig'}
      Name='Frequency Selection';
      LongHelp=sprintf( ...
         [ ...
            'Select frequencies for identification.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_zsdspop'}
      Name='Mouse action type';
      LongHelp=sprintf( ...
         [ ...
            'The mouse can be used over the plot in 3 different modes.\n' ...
            '\n' ...
            '"Zoom": it acts just like for regular zoom: the contents of a rubber box \n' ...
            'are zoomed to full window size.\n' ...
            '\n' ...
            '"Select": the frequencies belonging to the points encircled by a rubber \n' ...
            'box are selected for further processing.\n' ...
            '\n' ...
            '"Deselect": the opposite of "Select", the frequencies belonging to the \n' ...
            'encircled points are eliminated from the selected ones.\n' ...
            '\n' ...
            'When the mouse is used for just one click close to a point in the plot, \n' ...
            'this will toggle the selection status of the closest point, independently \n' ...
            'of the type of the selected mouse action.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_frffxfypop'}
      Name='Type of plot';
      LongHelp=sprintf( ...
         [ ...
            'Frequency selection can be done or even continued from a processed set on \n' ...
            'four different plots.\n' ...
            '\n' ...
            '"frf": The Frequency response function (the ratio of the output over the \n' ...
            'input Fourier amplitudes) is plotted.\n' ...
            '\n' ...
            ' "frf + std": The Frequency response function (the ratio of the output \n' ...
            'over the input Fourier amplitudes) is plotted, together with the standard \n' ...
            'deviations.\n' ...
            '\n' ...
            '"output-input": Two subplots are displayed for output and input. \n' ...
            'Select/deselect operates on both. \n' ...
            '\n' ...
            '"output-input + std": Two subplots are displayed for output and input, \n' ...
            'together with the standard deviations.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_frffxfypop-old'}
      Name='Type of plot';
      LongHelp=sprintf( ...
         [ ...
            'Frequency selection can be done or even continued from a processed set on \n' ...
            'four different plots.\n' ...
            '\n' ...
            '"frf": The Frequency response function (the ratio of the output over the \n' ...
            'input Fourier amplitudes) is plotted.\n' ...
            '\n' ...
            ' "frf + std": The Frequency response function (the ratio of the output \n' ...
            'over the input Fourier amplitudes) is plotted, together with the standard \n' ...
            'deviations.\n' ...
            '\n' ...
            '"output-input": Two subplots are displayed for output and input. \n' ...
            'Select/deselect operates on both. \n' ...
            '\n' ...
            '"output-input + std": Two subplots are displayed for output and input, \n' ...
            'together with the standard deviations.\n' ...
            '\n' ...
            'For UserLevel Advanced only:\n' ...
            '\n' ...
            ' "SNR + frf": the signal-to-noise ratio is plotted along with the frf. \n' ...
            'Select/deselect operates on the SNR points.\n' ...
            '\n' ...
            ' "NSR + frf": the noise-to signal ratio is plotted along with the frf. \n' ...
            'Select/deselect operates on the NSR points.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_uic_linloghpop'}
      Name='Linear/logarithmic plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_axes_uaxes'}
      Name='Axes for freq. selection';
      LongHelp=sprintf( ...
         [ ...
            '#freqsel_axes_laxes#\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel_axes_laxes'}
      Name='Axes for freq. selection';
      LongHelp=sprintf( ...
         [ ...
            'The plot can be used for selection of the frequency points. The mouse can \n' ...
            'be used in two ways. \n' ...
            '\n' ...
            'When we click close to a point in the plot, this will toggle the selection \n' ...
            'status of the closest point, independently of the type of the selected \n' ...
            'mouse action.\n' ...
            '\n' ...
            'When a rubber box encircles some points, the Select/Deselect/Zoom action \n' ...
            'depends on the type of mouse action selected by the pop-up menu.\n' ...
            '\n' ...
            '\n' ...
            'WARNING! Under some operational systems, event synchronization is not \n' ...
            'perfect. In such cases, do not move the mouse after a click, before the \n' ...
            'message about selection appears in the status line.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel3fig_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel3fig_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel3fig_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel3fig_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'freqsel3fig_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdsimulation_main'
   switch ObjTag
   case {'fdsimulation_main'}
      Name='Simulation window';
      LongHelp=sprintf( ...
         [ ...
            'Simulate data from model, variances, and designed input signal.  "Import \n' ...
            'data" is a special opportunity to take a data object instead of the model, \n' ...
            'and add noise to it. \n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_varrb(1)'}
      Name='"Mean" SNR';
      LongHelp=sprintf( ...
         [ ...
            'Average values for Signal to Noise Ratio at input and output. The average \n' ...
            'of the absolute Fourier amplitudes is divided by the constant std of the \n' ...
            'noise.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_varrb(3)'}
      Name='VA variance result';
      LongHelp=sprintf( ...
         [ ...
            'Take the variances from the output of the Variances and/or Averaging block.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_alltext'}
      Name='Scaling factor';
      LongHelp=sprintf( ...
         [ ...
            'Multiplicative factor to modify noise level, defined by Import or VA \n' ...
            'result. A typical application is when the VA output is the variance of the \n' ...
            'averaged amplitudes, while simulation attempts to use the variances of the \n' ...
            'non-averaged experiments. In such a case, the factor is to be set to the \n' ...
            'number of experiments averaged by VA.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_muledit'}
      Name='Scaling factor';
      LongHelp=sprintf( ...
         [ ...
            '#fdsimul_uic_alltext#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_multext'}
      Name='Scaling factor';
      LongHelp=sprintf( ...
         [ ...
            '#fdsimul_uic_alltext#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_savetext'}
      Name='Save var to object';
      LongHelp=sprintf( ...
         [ ...
            'Save variance data to object\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_mgrb(5)'}
      Name='Import data';
      LongHelp=sprintf( ...
         [ ...
            'Read data object, and perform simulation by adding noise to it.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_mgrb(1)'}
      Name='Import model';
      LongHelp=sprintf( ...
         [ ...
            'Import model from the workspace or a file.\n' ...
            '\n' ...
            'It requires excitation signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_mgrb(2)'}
      Name='Output of EPM';
      LongHelp=sprintf( ...
         [ ...
            'Take model from the output of the Estimate Plant Model block.\n' ...
            '\n' ...
            'It requires excitation signal. \n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_mgrb(3)'}
      Name='Best of CAMS outputs';
      LongHelp=sprintf( ...
         [ ...
            'Take best model (according to the criterion selected in ECPM, default: \n' ...
            'MDL) from the output of the Computer Aided Model Selection block.\n' ...
            '\n' ...
            'It requires excitation signal.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_mgrb(4)'}
      Name='Output of ECPM';
      LongHelp=sprintf( ...
         [ ...
            'Take model from the output of the Evaluate or Compare Plant Models block.\n' ...
            '\n' ...
            'It requires excitation signal. \n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_needit'}
      Name='Number of experiments';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_netext'}
      Name='Number of experiments';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_reedit'}
      Name='Number of repetitions';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_retext'}
      Name='Number of repetitions';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_outedit'}
      Name='Output SNR';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_outtext'}
      Name='Output SNR';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_inedit'}
      Name='Input SNR';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_intext'}
      Name='Input SNR';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_varhdtext'}
      Name='Frame for variances';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_varrb(2)'}
      Name='Import variances';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_varrb(4)'}
      Name='Import noise models';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_varframe'}
      Name='Frame for variances';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_modelhdtext'}
      Name='Frame for amplitudes';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_modelframe'}
      Name='Frame for amplitudes';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_fdsimulpb'}
      Name='Simulate';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_tdtext'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_tdedit'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_tdtext2'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_ptpop'}
      Name='Periodic or one-shot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_cancelpb'}
      Name='Cancel';
      LongHelp=sprintf( ...
         [ ...
            'Close the window without saving data or window settings\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdsimul_uic_donepb'}
      Name='Close';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'simul_plot_fig_main'
   switch ObjTag
   case {'simul_plot_fig_main'}
      Name='Plot of simulated data';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdmeasurement_main'
   switch ObjTag
   case {'fdmeasurement_main'}
      Name='Measurement window';
      LongHelp=sprintf( ...
         [ ...
            'Specify parameters for measurement and execute it.\n' ...
            '\n' ...
            'The actions initiated by pushing the button "Goto VI" or "Take data", are \n' ...
            'implemented by the user-defined function M-file "fdhwfun.m" which handles \n' ...
            'all hardware-dependent actions and must return a tiddata object in time \n' ...
            'domain, or an fiddata object in frequency domain. For the specifications \n' ...
            'see the predefined file "fdhwfsigl.m".\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_hwpop'}
      Name='Hardware or simulator';
      LongHelp=sprintf( ...
         [ ...
            'Select special hardware or emulator to perform measurement.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_vipop'}
      Name='Virtual instrument';
      LongHelp=sprintf( ...
         [ ...
            'Select virtual instrument, or instrument emulator to perform measurement. \n' ...
            'Some instruments need input signal - when there is no excitation signal, \n' ...
            'the selection of these will result in a warning message. A similar warning \n' ...
            'appears if the associated hardware is off.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_needit'}
      Name='Number of experiments';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_netext'}
      Name='Number of experiments';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_reedit'}
      Name='Number of repetitions';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_retext'}
      Name='Number of repetitions';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_fdmeaspb'}
      Name='Goto VI';
      LongHelp=sprintf( ...
         [ ...
            'Go to virtual instrument or hardware emulator. By pushing this button, the \n' ...
            'selected virtual instrument is started (or selected if it is already \n' ...
            'open). Parameters can be set, and measurement can be made. The data are \n' ...
            'either returned\n' ...
            '\n' ...
            '- by pushing "Take data" while the instrument is open, or\n' ...
            '\n' ...
            '- by properly closing the virtual instrument, or\n' ...
            '\n' ...
            '- automatically.\n' ...
            '\n' ...
            'By pushing "Goto VI", the user-defined function M-file "fdhwfun.m" is \n' ...
            'called which handles all hardware-dependent actions and must return a \n' ...
            'tiddata object in time domain, or an fiddata object in frequency domain. \n' ...
            'For the specifications see the predefined file "fdhwfsigl.m".\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_fdtakepb'}
      Name='Take data';
      LongHelp=sprintf( ...
         [ ...
            'Take data from virtual instrument if this latter is already open.\n' ...
            '\n' ...
            'By pushing "Take data", the user-defined function M-file "fdhwfun.m" is \n' ...
            'called which handles all hardware-dependent actions and must return a \n' ...
            'tiddata object in time domain, or an fiddata object in frequency domain. \n' ...
            'For the specifications see the predefined file "fdhwfsigl.m". \n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_tdtext'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_tdedit'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_tdtext2'}
      Name='Delay';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_ptpop'}
      Name='Periodic or one-shot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_calpop'}
      Name='Calibration data';
      LongHelp=sprintf( ...
         [ ...
            'The GUI is capable to calibrate the measurement in order to eliminate the \n' ...
            'effect of possible non-uniform frequency response of the measurement \n' ...
            'device. To do this, select "read calibration data" to get the data from an \n' ...
            'fiddata or a fidmodel object, or select "take calibration data" to take \n' ...
            'these directly from the virtual instrument.  If calibration is on when \n' ...
            'closing the window, the measured frf will be subtracted from the data \n' ...
            'before passing it to the identification process.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the fdident GUI\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_menu_help_this'}
      Name='Help on this window';
      LongHelp=sprintf( ...
         [ ...
            'Short introduction to this window\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_menu_help_object'}
      Name='Help on selected object';
      LongHelp=sprintf( ...
         [ ...
            'After selection of this item, click on an object with the question mark, \n' ...
            'and read the related text.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_menu_file_print'}
      Name='Print figure';
      LongHelp=sprintf( ...
         [ ...
            'Print window using the system "print" command. The M-file "printopt" must \n' ...
            'be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_menu_file_print_ps'}
      Name='Print figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append window to postscript file.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_cancelpb'}
      Name='Cancel the window';
      LongHelp=sprintf( ...
         [ ...
            'Close the window without saving data or window settings\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdmeas_uic_donepb'}
      Name='Close the window';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'meas_plot_fig_main'
   switch ObjTag
   case {'meas_plot_fig_main'}
      Name='Plot of measured data';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_recorder_fig'
   switch ObjTag
   case {'fdtool_recorder_fig'}
      Name='Action Recorder';
      LongHelp=sprintf( ...
         [ ...
            'Every important action in the GUI can be recorded and later replayed by \n' ...
            'the Action Recorder. Its buttons resemble those of a usual tape recorder. \n' ...
            'When "RECORD" is on, each action is stored to the actual position of a \n' ...
            '"history record". "PLAY" will replay all these. The history record can be \n' ...
            'saved into a MAT-file (please use the extension .MAT for these files).\n' ...
            '\n' ...
            'You probably want to replay your actions later. This will only be \n' ...
            'successful if you start the GUI from exactly the same state. Therefore, at \n' ...
            'the beginning of each history record, we suggest to do some state setting. \n' ...
            'Push RECORD, and do the following: \n' ...
            '\n' ...
            '1) "File / Clear / Whole GUI", and \n' ...
            '\n' ...
            '2) "UserLevel / Interactive" or "UserLevel / Automatic", as you prefer.\n' ...
            '\n' ...
            'Now you can record your actions. When you are ready, push STOP, then \n' ...
            'select "File / Save history as...", and give a file name with the extension \n' ...
            '.MAT.\n' ...
            '\n' ...
            'It is also possible to automatically load the contents of a MAT-file to \n' ...
            'the workspace before your actions if you want. To do this, push STOP, \n' ...
            'select in the recorder "Edit / Insert MATLAB Command", and in the field \n' ...
            '"Param" type "load <mydata>.mat". Now push PLAY to really execute the \n' ...
            'load. After pushing RECORD you can record your actions.\n' ...
         ]);
      ShortHelp='';
      return
   case {'guirecrd_fdtool'}
      Name='Action Recorder';
      LongHelp=sprintf( ...
         [ ...
            '#fdtool_recorder_fig#\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_help_fdid'}
      Name='Help on fdident GUI';
      LongHelp=sprintf( ...
         [ ...
            'General introduction to the GUI with a set of topics\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_help_this'}
      Name='Help on the fdident Action Recorder';
      LongHelp=sprintf( ...
         [ ...
            'Explain briefly how the Recorder works\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_help_object'}
      Name='Help on objects of the Action Recorder';
      LongHelp=sprintf( ...
         [ ...
            'Display explanations on selected menu items and controls\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_commentbox_copyall'}
      Name='Copy contents of commentbox';
      LongHelp=sprintf( ...
         [ ...
            'Copy text in the commentbox to the clipboard\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_commentbox_cutall'}
      Name='Cut contents of commentbox';
      LongHelp=sprintf( ...
         [ ...
            'Cut out text from the commentbox and paste it to the clipboard\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_commentbox_replaceall'}
      Name='Replace contents of commentbox';
      LongHelp=sprintf( ...
         [ ...
            'Paste text from the clipboard to the commentbox\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_commentbox_export'}
      Name='Export contents of commentbox';
      LongHelp=sprintf( ...
         [ ...
            'Export the text in the commentbox to the base workspace variable "ebtext" \n' ...
            'for direct manipulations\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_commentbox_import'}
      Name='Import contents of commentbox';
      LongHelp=sprintf( ...
         [ ...
            'Import the text in the variable "ebtext" to the commentbox\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_copy'}
      Name='Copy action';
      LongHelp=sprintf( ...
         [ ...
            'Copy currently shown action to the "Action clipboard"\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_cut'}
      Name='Cut action';
      LongHelp=sprintf( ...
         [ ...
            'Cut out currently shown action and paste it to the "Action clipboard"\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_cutandadd'}
      Name='Cut and add action';
      LongHelp=sprintf( ...
         [ ...
            'Cut out currently shown action and paste it to the "Action clipboard", \n' ...
            'adding it to the end of already cut actions\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_paste'}
      Name='Paste action';
      LongHelp=sprintf( ...
         [ ...
            'Paste action from the "Action clipboard" to the current history\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_delete_actual'}
      Name='Delete Action';
      LongHelp=sprintf( ...
         [ ...
            'Delete currently shown action\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_insert_cmd'}
      Name='Insert Matlab command';
      LongHelp=sprintf( ...
         [ ...
            'Insert Matlab command (to be executed in the base workplace). The command \n' ...
            'string can even be left empty, e.g. for the purpose of comments. \n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_edit_insert_jmp'}
      Name='Insert Jump';
      LongHelp=sprintf( ...
         [ ...
            'Insert an absolute or relative jump command into the history (e.g. to \n' ...
            'temporarily bypass some portions)\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_new'}
      Name='Start new history';
      LongHelp=sprintf( ...
         [ ...
            'Clear contents of the Recorder, and start a new history\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_load'}
      Name='Load history';
      LongHelp=sprintf( ...
         [ ...
            'Load an earlier save history to the Recorder\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_save'}
      Name='Save history';
      LongHelp=sprintf( ...
         [ ...
            'Save history from the Recorder to the designated variable in the \n' ...
            'designated file (if they are given)\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_saveas'}
      Name='Save history as';
      LongHelp=sprintf( ...
         [ ...
            'Save history from the Recorder to a variable in a file: both have be \n' ...
            'specified\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_print'}
      Name='Print recorder';
      LongHelp=sprintf( ...
         [ ...
            'Print contents of the Recorder to the printer, using the system "print" \n' ...
            'command. The M-file "printopt" must be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_print_ps'}
      Name='Print recorder to PS file';
      LongHelp=sprintf( ...
         [ ...
            'Append contents of the Recorder to the postscript file fdidgui.ps.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_print_last_pr'}
      Name='Print last figure';
      LongHelp=sprintf( ...
         [ ...
            'Print the last generated figure of the GUI, using the system "print" \n' ...
            'command. The M-file "printopt" must be properly set.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_file_print_last_ps'}
      Name='Print last figure to postscript file';
      LongHelp=sprintf( ...
         [ ...
            'Append the last generated figure of the GUI to the postscript file \n' ...
            'fdidgui.ps.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_menu_close'}
      Name='Close recorder';
      LongHelp=sprintf( ...
         [ ...
            'Close recorder window\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_testmodepop'}
      Name='Test mode';
      LongHelp=sprintf( ...
         [ ...
            'There are 3 test modes:\n' ...
            '\n' ...
            '- Test mode off: nothing special is selected during test procedures\n' ...
            '\n' ...
            '- Test mode normal: not yet used\n' ...
            '\n' ...
            '- Test mode quick: in iterative procedures, the number of iteration cycles \n' ...
            'is limited, to assure quick execution\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit6'}
      Name='Cmd';
      LongHelp=sprintf( ...
         [ ...
            'Type of action\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit5'}
      Name='Fcn';
      LongHelp=sprintf( ...
         [ ...
            'Name of related function M-file\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit4'}
      Name='Win';
      LongHelp=sprintf( ...
         [ ...
            'Tag of graphical window\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit3'}
      Name='CurObj';
      LongHelp=sprintf( ...
         [ ...
            'Tag of object to be selected\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit13'}
      Name='Window';
      LongHelp=sprintf( ...
         [ ...
            'Name of window in which action will be executed.\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit12'}
      Name='Cmd';
      LongHelp=sprintf( ...
         [ ...
            'Descriptive name of action (e.g. name of pushbutton, etc.)\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit1'}
      Name='Param';
      LongHelp=sprintf( ...
         [ ...
            'Parameter of given action\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_edit8'}
      Name='Comment box';
      LongHelp=sprintf( ...
         [ ...
            'Explanations for selected steps in action histories\n' ...
         ]);
      ShortHelp='';
      return
   case {'fdtool_recorder_discardcb2'}
      Name='Skip error checking';
      LongHelp=sprintf( ...
         [ ...
            'If set, error checking will not be performed.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'signal_shape'
   switch ObjTag
   case {'signal_shape'}
      Name='Excitation Signal Shape';
      LongHelp=sprintf( ...
         [ ...
            'Time domain plot of the excitation signal.\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'amplitude_spectrum'
   switch ObjTag
   case {'amplitude_spectrum'}
      Name='Amplitude spectrum';
      LongHelp=sprintf( ...
         [ ...
            'Excited amplitudes is signal\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'gettdatafig'
   switch ObjTag
   case {'gettdatafig'}
      Name='Get Time Domain Data';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'arrow_plot_fig_gettime'
   switch ObjTag
   case {'arrow_plot_fig_gettime'}
      Name='Time Domain Plot';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'arrow_plot_fig_main'
   switch ObjTag
   case {'arrow_plot_fig_main'}
      Name='Plot of arrow data';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdtool_arrowdlg'
   switch ObjTag
   case {'fdtool_arrowdlg'}
      Name='Arrow Dialog';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'fdguidem_tmp'
   switch ObjTag
   case {'fdguidem_tmp'}
      Name='Fdident GUI Demos';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'caem_model_zoom_fig'
   switch ObjTag
   case {'caem_model_zoom_fig'}
      Name='ECPM Zoom';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'caem_compare_model_fig'
   switch ObjTag
   case {'caem_compare_model_fig'}
      Name='ECPM Compare figure';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'elis_window'
   switch ObjTag
   case {'elis_window'}
      Name='ELiS Information Window';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'getmexp'
   switch ObjTag
   case {'getmexp'}
      Name='Get MATLAB Expression';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'gmexp_uic_edit'}
      Name='Editbox for MATLAB Expression';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'vna_main'
   switch ObjTag
   case {'vna_main'}
      Name='Virtual Network Analyzer';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'vna_uic_avg'}
      Name='Avg';
      LongHelp=sprintf( ...
         [ ...
            'Execute measurement with averaging\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'vfg_fig'
   switch ObjTag
   case {'vfg_fig'}
      Name='Virtual Function Generator';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'vfg_uic_onoff'}
      Name='All On/Off';
      LongHelp=sprintf( ...
         [ ...
            'Excitation on/off\n' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
case 'automodelselectiondemofig'
   switch ObjTag
   case {'automodelselectiondemofig'}
      Name='Automatic model order demo';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'popupmenu'}
      Name='Select a demo';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'pushbuttonstart'}
      Name='Start';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   case {'pushbuttonclose'}
      Name='Close';
      LongHelp=sprintf( ...
         [ ...
            '' ...
         ]);
      ShortHelp='';
      return
   otherwise
      Name='';
      LongHelp='';
      ShortHelp='';
   end % case ObjTag
otherwise
   Name='';
   LongHelp='';
   ShortHelp='';
   if guiinfos('isdevelopment')
      warning(['Bad window tag: ' WinTag])
   end
end % case WinTag

